Package: regioneReloaded
Type: Package
Title: RegioneReloaded: Multiple Association for Genomic Region Sets
Version: 1.15.0
Authors@R: c(
    person(given = "Roberto",
           family = "Malinverni",
           role = c("aut", "cre"),
           email = "roberto.malinverni@gmail.com",
           comment = c(ORCID ="0000-0002-0113-3417")),
    person(given = "David",
           family = "Corujo",
           role = c("aut"),
           email = "dcorujo@carrerasresearch.org"),
    person(given = "Bernat",
           family = "Gel",
           role = c("aut"),
           email = "bgel@igtp.org"))
URL: https://github.com/RMalinverni/regioneReload
Description: RegioneReloaded is a package that allows simultaneous analysis of associations between genomic region sets, enabling clustering of data and the creation of ready-to-publish graphs. It takes over and expands on all the features of its predecessor regioneR. It also incorporates a strategy to improve p-value calculations and normalize z-scores coming from multiple analysis to allow for their direct comparison. RegioneReloaded builds upon regioneR by adding new plotting functions for obtaining publication-ready graphs. 
License: Artistic-2.0
Encoding: UTF-8
LazyData: false
RoxygenNote: 7.2.1
Roxygen: list(markdown = TRUE)
Depends: R (>= 4.2), regioneR
Imports: stats, RColorBrewer, Rtsne, umap, ggplot2, ggrepel, reshape2,
        methods, scales, cluster, grid, grDevices
Suggests: rmarkdown, BiocStyle, GenomeInfoDb, knitr, testthat (>=
        3.0.0)
biocViews: Genetics, ChIPSeq, DNASeq, MethylSeq, CopyNumberVariation,
        Clustering, MultipleComparison
VignetteBuilder: knitr
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/regioneReloaded
git_branch: devel
git_last_commit: d229c87
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 00:38:04 UTC; biocbuild
Author: Roberto Malinverni [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-0113-3417>),
  David Corujo [aut],
  Bernat Gel [aut]
Maintainer: Roberto Malinverni <roberto.malinverni@gmail.com>

#' genoMatriXeR Class
#'
#' @description
#'
#' An S4 class for "genoMatriXeR" object.
#'
#' @slot parameters List of parameters used to create the object.
#' @slot multiOverlaps Results of multiple pairwise permutation tests generated with [crosswisePermTest()].
#' @slot matrix List of numerical matrices containing z-score, pvalues and correlation values generated with [makeCrosswiseMatrix()]
#'
#' @examples
#'
#' data("cw_Alien")
#'
#' AlienRSList_narrow_small  <- AlienRSList_narrow[c("regA","regB","regC")]
#'
#' cw_test <- crosswisePermTest(Alist = AlienRSList_narrow_small,Blist = AlienRSList_narrow_small,
#'                             sampling = FALSE, genome = AlienGenome, per.chromosome = TRUE,
#'                             ranFUN = "resampleGenome", evFUN = "numOverlaps",
#'                             ntimes = 10, mc.cores = 2)
#'
#' class(cw_test)
#'
#' @export
#'

gMXR <- setClass("genoMatriXeR",
                 slots = c(
                 parameters = "list",
                 multiOverlaps = "list",
                 matrix = "list"
                 )
              )

#' multiLocalZScore Class
#'
#' @description
#'
#' An S4 class for "multiLocalZScore" object.
#'
#' @slot parameters List of parameters used to create the object
#' @slot multiLocalZscores Results of multiple pairwise permutation tests on shifted region sets generated with [multiLocalZscore()].
#' @slot matrix List of numerical matrices containing local z-scores and correlation values generated with [makeLZMatrix()].
#'
#' @examples
#'
#' data("cw_Alien")
#'
#' AlienRSList_narrow_small  <- AlienRSList_narrow[c("regA","regB","regC")]
#'
#' mlz_test <- multiLocalZscore(A = AlienRSList_narrow_small$regA, Blist = AlienRSList_narrow_small,
#'                             sampling = FALSE, genome = AlienGenome, per.chromosome = TRUE,
#'                             ranFUN = "resampleGenome", evFUN = "numOverlaps",
#'                             ntimes = 10, mc.cores = 2)
#'
#' class(mlz_test)
#'
#' @export
#'

mLZS <- setClass("multiLocalZScore",
                 slots = c(
                   parameters = "list",
                   multiLocalZscores = "list",
                   matrix = "list"
                 )
)

#' crosswisePermTest
#'
#' @description
#'
#' Perform multiple permutation tests between each element in two lists of region sets.
#'
#' @details
#'
#' This function performs multiple permutation tests for all pairwise combinations
#' of the elements in two lists of region sets. Essentially, it uses the [regioneR::permTest()]
#' function and its associated randomization and evaluation functions. It creates and returns a
#' [genoMatriXeR-class] object with the result of the permutation tests stored in the `multiOverlaps` slot.
#' In addition, all the parameters used for the test are stored in the `parameters` slot.
#'
#' @usage crosswisePermTest(Alist, Blist = NULL, sampling = FALSE, fraction = 0.15,
#'  min_sampling = 5000, ranFUN = "randomizeRegions", evFUN = "numOverlaps",
#'  ntimes = 100, universe = NULL, adj_pv_method = "BH",
#'  genome = "hg19", ...)
#'
#'
#' @param Alist,Blist [GRangesList][GenomicRanges::GRangesList] or list of region sets in any accepted formats by [regioneR](https://bioconductor.org/packages/release/bioc/html/regioneR.html) package
#' ([GRanges][GenomicRanges::GRanges], [data.frame] etc.).
#' @param sampling logical, if TRUE the function will use only a sample of each element of Alist to perform the test as specified in `fraction.` (default = FALSE)
#' @param fraction logical, if `sampling=TRUE`, defines the fraction of the region sets used to perform the test. (default = 0.15)
#' @param min_sampling numeric, minimum number of regions accepted after sampling is performed with the specified `fraction`. If the number of sampled
#' regions is less than `min_sampling`, the number specified by `min_sampling` will be used as number of regions sampled instead. (default = 5000)
#' @param ranFUN character, the randomization strategy used for the test, see [regioneR](https://bioconductor.org/packages/release/bioc/html/regioneR.html). (default = "randomizeRegions")
#' @param evFUN  character, the evaluation strategy used for the test, see  [regioneR](https://bioconductor.org/packages/release/bioc/html/regioneR.html). (default = "numOverlaps)
#' @param ntimes numeric, number of permutations used in the test. (default = 100)
#' @param universe  region set to use as universe, used only when [regioneR::resampleRegions()] function is selected. (default = NULL)
#' @param adj_pv_method character, the method used for the calculation of the adjusted p-value, to choose between the options of [p.adjust()]. (default = "BH")
#' @param genome character or [GRanges][GenomicRanges::GRanges], genome used to compute the randomization. (default = "hg19")
#' @param ... further arguments to be passed to other methods.
#'
#' @return
#'
#' A object of class [genoMatriXeR][genoMatriXeR-class] containing three slots
#'
#' \itemize{
#' \item \bold{\code{@parameters}}
#' \item \bold{\code{@multioverlaps}}
#' \item \bold{\code{@matrix}}
#'
#' }
#'
#' @seealso [genoMatriXeR][genoMatriXeR-class], [`regioneR`](https://bioconductor.org/packages/release/bioc/html/regioneR.html), [regioneR::permTest()], [regioneR::overlapPermTest()]
#'
#' @examples
#'
#' fakeGenome <- regioneR::toGRanges("chrF", 1, 1000)
#' regA <- regioneR::createRandomRegions(nregions = 10, length.mean = 10,
#' length.sd = 2, genome = fakeGenome)
#' regB <- regioneR::createRandomRegions(nregions = 10, length.mean = 10,
#' length.sd = 2, genome = fakeGenome)
#' regAs <- similarRegionSet(GR = regA, genome = fakeGenome, name = "A",
#' vectorPerc = seq(0.1, 0.3, by = 0.1))
#' regBs <- similarRegionSet(GR = regB, genome = fakeGenome, name = "B",
#' vectorPerc = seq(0.1, 0.3, by = 0.1))
#' ABList <- c(regAs, regBs)
#' cw_ptAB <- crosswisePermTest(ABList, genome = fakeGenome, ntimes = 10)
#' print(cw_ptAB)
#'
#' @import regioneR
#' @importFrom methods hasArg
#' @importFrom methods new
#'
#' @export crosswisePermTest


crosswisePermTest <-
  function(Alist,
           Blist = NULL,
           sampling = FALSE,
           fraction = 0.15,
           min_sampling = 5000,
           ranFUN = "randomizeRegions",
           evFUN = "numOverlaps",
           ntimes = 100,
           universe = NULL,
           adj_pv_method = "BH",
           genome = "hg19",
           ...) {

    # control parameters

    stopifnot("Alist is missing" = methods::hasArg(Alist))
    stopifnot("fraction must be numeric" = is.numeric(fraction))
    stopifnot("sampling must be logical" = is.logical(sampling))
    stopifnot("min_sampling must be numeric" = is.numeric(min_sampling))
    stopifnot("ranFun must be charachter" = is.character(ranFUN))
    stopifnot("evFun must be charachter" = is.character(evFUN))
    stopifnot("ntimes must be numeric" = is.numeric(ntimes))

    # create @parameters slot

    paramList <- list(
      Alist = deparse(substitute(Alist)),
      Blist = deparse(substitute(Blist)),
      sampling = deparse(substitute(sampling)),
      fraction = deparse(substitute(fraction)),
      min_sampling = deparse(substitute(fraction)),
      ranFUN = ranFUN,
      evFUN = evFUN,
      ntimes = ntimes,
      universe = NULL,
      adj_pv_method = adj_pv_method,
      nc = NULL,
      matOrder = NULL,
      errors = NULL
    )

    if (is.character(genome)){
      genome <- getGenome(genome)
    }

    if (is.null(names(Alist))){
      names(Alist) <- paste0("RS1_",1:length(Alist))
    }


    Alist <- as.list(Alist)

    Alist <- lapply(Alist, function(GR,genome){
      newGR <- GR[regioneR::overlapRegions(GR, genome, only.boolean = TRUE)]
    } ,genome)


    if (is.null(Blist)) {
      Blist <- Alist
    }else{
      Blist <- as.list(Blist)
    }

    Blist <- as.list(Blist)

    if (is.null(names(Blist))){
      names(Blist) <- paste0("RS2_",1:length(Blist))
    }

    rFUN <- eval(parse(text = ranFUN))

    if (sampling == TRUE) {
      Alist <-
        subList(Alist, min_sampling = min_sampling, fraction = fraction)
    }

    if ((ranFUN == "resampleRegions") & (is.null(universe))) {
      warning(
        "resampleRegions function need that 'universe' is not NULL, universe was created using all the regions present in Alist"
      )
      universe <- createUniverse(Alist)
    }

    # create multiOverlaps slot

    list.tabs <- mapply(FUN = function(A, nameA, i, ...){
                            show(paste0("Performing permutation tests for ", nameA, " (", i, " of ", length(Alist), ")"))
                            tryCatch(
                              res <- multiPermTest(A, ...), error = function(e) {
                                message("There was an issue when performing the permutation test for: ", nameA)
                                return(list(NULL, e))
                              }
                            )
                        },
                        Alist,
                        names(Alist),
                        seq_along(Alist),
                        MoreArgs = list(Blist = Blist,
                        ranFUN = ranFUN, evFUN = evFUN, uni = universe,
                        genome = genome, rFUN = rFUN, ntimes = ntimes, adj_pv_method = adj_pv_method),
                        SIMPLIFY = FALSE
    )

    names(list.tabs) <- names(Alist)

    # Save error list
    list.errors <- lapply(list.tabs, FUN = function(x) {
      if (is.null(x[[1]])) {
        return(x[[2]])
      }
    })

    list.errors <- list.errors[!unlist(lapply(list.errors, FUN = is.null))]

    if(length(list.errors) > 0) {
      paramList$errors <- data.frame(call = unlist(lapply(list.errors, FUN = function(x) deparse(x[["call"]]))),
                                     errorMessage = unlist(lapply(list.errors, FUN = function(x) x[["message"]])))
      warning("There was an issue in one or more of the permutation test iterations (note that the evaluation for these test has been set to NULL)",
              call. = FALSE)
    }

    # Clean list.tabs of errors
    list.tabs <- lapply(list.tabs, FUN = function(x) {
      if (is.data.frame(x)) {
        return(x)
      } else {
        return(NULL)
      }
    })

    # create S4 object (matrix slot is = NULL)

    GMXRobj <- gMXR(
      parameters = paramList,
      multiOverlaps = list.tabs,
      matrix = list(NULL)
    )

    return(GMXRobj)
  }

test_that("crosswisePermTest: argument checks", {
  expect_error(crosswisePermTest(), "missing")
})

test_that("crosswisePermTest: different randomization functions", {

  set.seed(42)

  expect_snapshot(
    crosswisePermTest(
      Alist = AlienRSList_narrow_small,
      Blist = AlienRSList_narrow_small,
      sampling = FALSE,
      genome = AlienGenome,
      per.chromosome = TRUE,
      ranFUN = "resampleGenome",
      evFUN = "numOverlaps",
      ntimes = 10,
      mc.cores = 2
    )
  )

  expect_snapshot(
    crosswisePermTest(
      Alist = AlienRSList_narrow_small,
      Blist = AlienRSList_narrow_small,
      sampling = FALSE,
      genome = AlienGenome,
      ranFUN = "resampleRegions",
      evFUN = "numOverlaps",
      ntimes = 10,
      mc.cores = 2
    )
  )

  expect_snapshot(
    crosswisePermTest(
      Alist = AlienRSList_narrow_small,
      Blist = AlienRSList_narrow_small,
      sampling = TRUE,
      genome = AlienGenome,
      ranFUN = "randomizeRegions",
      evFUN = "numOverlaps",
      ntimes = 10,
      mc.cores = 2
    )
  )

  expect_snapshot(
    crosswisePermTest(
      Alist = AlienRSList_narrow_small,
      Blist = AlienRSList_narrow_small,
      sampling = TRUE,
      genome = AlienGenome,
      ranFUN = "circularRandomizeRegions",
      evFUN = "numOverlaps",
      ntimes = 10,
      mc.cores = 2
    )
  )
})

test_that("crosswisePermTest: different evaluation functions", {

  set.seed(42)

  expect_snapshot(
    crosswisePermTest(
      Alist = AlienRSList_narrow_small,
      Blist = AlienRSList_narrow_small,
      sampling = FALSE,
      genome = AlienGenome,
      per.chromosome = TRUE,
      ranFUN = "circularRandomizeRegions",
      evFUN = "numOverlaps",
      ntimes = 10,
      mc.cores = 2
    )
  )

  expect_snapshot(
    crosswisePermTest(
      Alist = AlienRSList_narrow_small,
      Blist = AlienRSList_narrow_small,
      sampling = FALSE,
      genome = AlienGenome,
      ranFUN = "circularRandomizeRegions",
      evFUN = "meanDistance",
      ntimes = 10,
      mc.cores = 2
    )
  )
})

test_that("crosswisePermTest: resampling and fraction", {

  set.seed(42)

  expect_snapshot(
    crosswisePermTest(
      Alist = AlienRSList_narrow_small,
      Blist = AlienRSList_narrow_small,
      sampling = TRUE,
      fraction = 0.25,
      genome = AlienGenome,
      per.chromosome = TRUE,
      ranFUN = "resampleGenome",
      evFUN = "numOverlaps",
      ntimes = 10,
      mc.cores = 2
    )
  )

  expect_snapshot(
    crosswisePermTest(
      Alist = AlienRSList_narrow_small,
      Blist = AlienRSList_narrow_small,
      sampling = TRUE,
      fraction = 0.5,
      genome = AlienGenome,
      per.chromosome = TRUE,
      ranFUN = "resampleGenome",
      evFUN = "numOverlaps",
      ntimes = 10,
      mc.cores = 2
    )
  )
})

#' cleanCrosswiseMatrix
#'
#' @description
#'
#' Clean and scale a matrix from a genoMatriXeR object
#'
#' @usage cleanCrosswiseMatrix(GM, GM_pv, pvcut, scale, subEX)
#'
#' @return a matrix filtered for a matrix of pvalue
#'
#' @seealso [makeCrosswiseMatrix()]
#'
#' @inheritParams makeCrosswiseMatrix
#'
#' @param GM matrix,  numerical matrix of z-scores.
#' @param GM_pv matrix, numerical matrix of pvalues.
#'
#' @keywords internal

cleanCrosswiseMatrix <-
  function(GM,
           GM_pv,
           pvcut,
           scale,
           subEX) {
    GM[GM_pv > pvcut] <- subEX

    if (scale == TRUE) {
      GM <- scale(GM)
    }

    GM[is.nan(GM)] <- subEX

    stopifnot("All values of the matrix are 0" = sum(GM) != 0)

    return(GM)
  }

#' multiPermTest
#'
#' @details
#'
#' Perform a multiple permutation test
#'
#' @keywords internal function
#' @usage multiPermTest (A, Blist, ranFUN, evFUN, uni, genome, rFUN, ntimes, adj_pv_method, ...)
#'
#' @return a data frame object computed starting from results of [regioneR::permTest()] function
#'
#' @inheritParams crosswisePermTest
#' @param A Genomic Ranges or any accepted formats by  [regioneR](https://bioconductor.org/packages/release/bioc/html/regioneR.html) package
#' ([GRanges][GenomicRanges::GRanges], [data.frame] etc.).
#' @param uni region set to use as universe, used only when [regioneR::resampleRegions()] function is selected. (default = NULL)
#' @seealso [regioneR::permTest()]
#'
#' @importFrom methods show
#' @importFrom stats sd
#' @importFrom stats p.adjust
#'
#' @keywords internal function

multiPermTest <-
  function(A,
           Blist,
           ranFUN,
           evFUN,
           uni,
           genome,
           rFUN,
           ntimes,
           adj_pv_method,
           ...) {


    new.names <- names(Blist)
    func.list <-
      regioneR::createFunctionsList(FUN = evFUN,
                                    param.name = "B",
                                    values = Blist)

    if(ranFUN == "resampleRegions"){


      pt <- regioneR::permTest(
        A = A,
        evaluate.function = func.list,
        randomize.function = rFUN,
        genome = genome ,
        ntimes = ntimes,
        universe = uni,
        ...
      )

    }else{

      pt <- regioneR::permTest(
        A = A,
        evaluate.function = func.list,
        randomize.function = rFUN,
        genome = genome ,
        ntimes = ntimes,
        ...
      )
    }

    tab <- do.call("rbind",lapply(seq_along(pt),
                                  FUN = function(j, pt){

                                    if (pt[[j]]$zscore == 0 |
                                        is.na(pt[[j]]$zscore) |
                                        is.nan((pt[[j]]$zscore))) {
                                      zscore.norm <- 0
                                    } else{
                                      zscore.norm <- pt[[j]]$zscore / sqrt(length(A))
                                    }

                                    vec <- data.frame(
                                      order.id = j,
                                      name = new.names[j],
                                      n_regionA = length(A),
                                      n_regionB = length(Blist[[j]]),
                                      z_score = pt[[j]]$zscore,
                                      p_value = pt[[j]]$pval,
                                      n_overlaps = pt[[j]]$observed,
                                      mean_perm_test = mean(pt[[j]]$permuted),
                                      sd_perm_test = stats::sd(pt[[j]]$permuted)
                                    )

                                  }, pt))

    tab$norm_zscore <- tab$z_score / sqrt(tab$n_regionA)
    tab$adj.p_value <-
      round(stats::p.adjust(tab$p_value, method = adj_pv_method), digits = 4)

    return(tab)
  }

#' randomizeRegionsPerc
#'
#' @description
#'
#' Create a random region set similar to a reference region set.
#'
#' @details
#'
#' This function takes an input region set and generates a region set where a
#' fraction of the regions has been randomized.
#'
#' @usage randomizeRegionsPerc(GR, genome = "hg19", frac = 0.2, ...)
#'
#' @return a [GRanges][GenomicRanges::GRanges] object
#'
#' @inheritParams similarRegionSet
#'
#' @param frac fraction of the original region set to randomize. (default = 0.2)
#' @param ... further arguments to be passed to other methods.
#'
#' @examples
#'
#' data("cw_Alien")
#'
#' nreg <- 100
#'
#' regA <-
#'   createRandomRegions(
#'   nregions = nreg,
#'   length.mean = 100,
#'   length.sd = 10,
#'   non.overlapping = TRUE,
#'   genome = AlienGenome
#'  )
#'
#' regA_02 <- randomizeRegionsPerc(GR = regA, genome = AlienGenome, frac = 0.2)
#'
#' @seealso [similarRegionSet()]
#'
#' @export randomizeRegionsPerc
#'


randomizeRegionsPerc<-function(GR,
                               genome = "hg19",
                               frac = 0.2,
                               ...)
  {

  nc<-round(length(GR) * frac)
  change<-sample(length(GR), nc)
  GR1<-GR[-change]
  GR2<-randomizeRegions(GR[change], genome=genome)
  GR3<-c(GR1,GR2)

  return(GR3)
}

#' Themes used in the regioneReloaded package
#'
#' Ggplot2 themes created for the package.
#'
#' @usage
#'
#' mendel_theme(
#'   base_size = 11,
#'   base_family = ""
#' )
#'
#' @param base_size	 base font size, given in pts.
#' @param base_family	 base font family
#'
#' @import ggplot2
#'
#' @keywords internal
#'
#' @noRd

mendel_theme <- function(base_size = 11, base_family = ""){
  ggplot2::theme(
    panel.background = ggplot2::element_rect(
      fill = "#F7F4DB",
      colour = "#F7F4DB",
      size = 0.5,
      linetype = "solid"
    ),
    panel.grid.major = ggplot2::element_line(
      size = 0.5,
      linetype = 'solid',
      colour = "#FDFAF6"
    ),
    panel.grid.minor = ggplot2::element_line(
      size = 0.25,
      linetype = 'solid',
      colour = "#FDFAF6"
    )
  )
}

#' plotPal
#'
#' @description
#'
#' Internal function to create a palette generating function for plots
#'
#' @inheritParams plotSingleLZ
#'
#' @importFrom grDevices colorRampPalette
#' @keywords internal
#'
#' @return A palette function
#' @noRd

plotPal <- function(colPal = NULL) {
  if (is.null(colPal)) {
    # colPal <- c("#434C6D", "#553B23", "#EF7E39", "#E23A79", "#6EA89E")
    colPal <- c("#BD3241", "#802160", "#3E3C66", "#495C52", "#E67E45")
    pal <- grDevices::colorRampPalette(colPal)
  } else {
    pal <- grDevices::colorRampPalette(colPal)
  }
  return(pal)
}

#' plotSingleLZ
#'
#' @description
#'
#' Plot the result of specific local Z-Score tests from a [multiLocalZScore][multiLocalZScore-class] object in the
#' form of line plot profiles.
#'
#' @details
#'
#' This function generates a line plot with the local Z-score profiles of
#' selected region sets from a [multiLocalZScore][multiLocalZScore-class] object. This type of plot
#' complements the local Z-score matrix (generated by [plotLocalZScoreMatrix],
#' since it allows to visualize in detail the local Z-score profile of just the
#' region sets of interest.
#'
#' This plot is well suited for a single or a few region sets, but
#' will get busy if attempting to plot many different profiles. For the latter,
#' the full matrix generated by [plotLocalZScoreMatrix] is usually a better
#' visualization option.
#'
#' @usage plotSingleLZ(mLZ, RS, xlab = "", normZS = TRUE, ylim = NULL, main = NA,
#'  colPal = NULL, labValues = TRUE, labSize = 2.5, labMax = FALSE, smoothing = FALSE, ...)
#'
#' @param mLZ an object of class [multiLocalZScore][multiLocalZScore-class].
#' @param RS character, vector of region set names for which to plot the local Z-score results.
#' @param xlab character, label for the x axis. (default = NA)
#' @param main character, title for the plot. If NA, the name of the query region set in the multiLocalZScore object will be used. (default = NA)
#' @param normZS logical, indicates whether the normalized Z-score values should be plotted. If FALSE, the raw Z-score is used. (default = TRUE)
#' @param ylim numeric, vector with two elements: minimum and maximum Y values of the plot. If NULL, the plot limits are set by default so all data points can be plotted. (default = NULL)
#' @param labValues logical, if TRUE each local Z-score profile is labelled at position 0 with the name of the region set and its Z-score value at the central position. (default = TRUE)
#' @param labSize numerical, size of the labels from labValues in the plot. (default = 2.5)
#' @param labMax logical, if TRUE the labels are placed at the maximum value of each local Z-score profile instead of the center. (default = FALSE)
#' @param colPal character, colors to use as palette for the plot. If NULL, default colors will be used. (default = NULL)
#' @param smoothing logical, if TRUE the [smooth.spline()] function will be applied to the localZ-score profile. (default = FALSE)
#' @param ...  further arguments to be passed to other methods.
#'
#' @return Returns a ggplot object.
#'
#' @seealso [multiLocalZscore()], [makeLZMatrix()]
#'
#' @examples
#'
#' data("cw_Alien")
#'
#' plotSingleLZ(mLZ_regA_ReG, RS = c("regD", "regD_02", "regA", "regAB_04"),
#' labMax = TRUE, smoothing = TRUE)
#'
#' @export plotSingleLZ
#' @import ggplot2
#' @importFrom ggrepel geom_label_repel
#' @importFrom methods hasArg
#' @importFrom RColorBrewer brewer.pal
#' @importFrom methods is
#' @importFrom stats smooth.spline
#' @importFrom stats aggregate


plotSingleLZ <-
  function(mLZ,
           RS,
           xlab = "",
           normZS = TRUE,
           ylim = NULL,
           main = NA,
           colPal = NULL,
           labValues = TRUE,
           labSize = 2.5,
           labMax = FALSE,
           smoothing = FALSE,
           ...) {

    stopifnot("mLZ is missing" = methods::hasArg(mLZ))
    stopifnot("mLZ needs to be a multiLocalZScore object" = methods::is(mLZ, "multiLocalZScore"))
    stopifnot("RS is missing" = methods::hasArg(RS))
    stopifnot("One or more elements in RS do not match region set names in mLZ" = all(RS %in% names(mlzsMultiLocalZscores(mLZ)$shifed_ZSs)))

    RS <- as.list(RS)
    df <- do.call("rbind", lapply(X = RS, FUN = DFfromLZ, mLZ = mLZ))

    if (is.na(main)) {
      main <- mlzsParam(mLZ)$A
    }
    evfun <- mlzsParam(mLZ)$evFUN
    ranfun <- mlzsParam(mLZ)$ranFUN

    pal <- plotPal(colPal) #palette

    if (mlzsParam(mLZ)$evFUN == "numOverlaps") {
      mlzsParam(mLZ)$evFUN <- "N. of overlaps"
    }

    if (normZS) { # Raw or norm ZS
      df$score <- df$normLocalZscore
      ylabel <- "Normalized Z-score"
    } else {
      df$score <- df$lzscore
      ylabel <- "Z-score"
    }

    if (smoothing == TRUE){
      smth <- stats::smooth.spline(df$score)
      df$score <- smth$y
    }

    # Plot
    p <- ggplot2::ggplot(df, ggplot2::aes_string(x = "shift", y = "score", group = "name", fill = "name", color = "name")) +
      ggplot2::geom_hline(yintercept = 0, color = "#515E63", size = 0.6) +
      ggplot2::geom_vline(xintercept = 0, color = "#515E63", size = 0.4, linetype = "dotted") +
      ggplot2::geom_density(alpha = 0.3, stat = "identity") +
      ggplot2::scale_color_manual(values = pal(length(RS))) +
      ggplot2::scale_fill_manual(values = pal(length(RS))) +
      ggplot2::labs(
        title = main,
        subtitle = paste("ranFUN: ", ranfun, "\nevFUN: ", evfun),
        y = ylabel,
        x = "bp"
      ) +
      ggplot2::theme(legend.title = ggplot2::element_blank())

    # Labels
    if (labValues) {
      if (labMax) {
        df_label <- merge(stats::aggregate(score ~ name, data = df, FUN = max), df)
        df_label <- df_label[order(df_label$shift), , drop = FALSE]
        df_label <- df_label[!duplicated(df_label$name), , drop = FALSE]
      } else {
        df_label <- df[df$shift == 0, , drop = FALSE]
      }
      df_label$text <- paste(df_label$name, "\nZS: ", round(df_label$score, digits = 2), sep = "")
      p <- p +
        ggplot2::coord_cartesian(clip = "off") +
        ggrepel::geom_label_repel(
          data = df_label, inherit.aes = FALSE,
          ggplot2::aes_string(label = "text", x = "shift", y = "score", color = "name"),
          fill = "#FDFAF6", size = labSize,
          xlim = c(0.2 * max(df$shift), NA),
          show.legend = FALSE,
          min.segment.length = 0
        )
    }

    # Ylims
    if (!is.null(ylim)) {
      p <- p + ggplot2::coord_cartesian(ylim = ylim)
    }
    p <- p + mendel_theme()
    return(p)
  }

test_that("Argument checks", {
  expect_error(plotSingleLZ(), "missing")
  expect_error(plotSingleLZ("a"), "multiLocalZScore")
  expect_error(plotSingleLZ(mLZ_regA_ReG), "missing")
  expect_error(plotSingleLZ(mLZ_regA_ReG, RS = "a"), "names")
})

test_that("Returns the correct class without errors", {
  expect_s3_class(plotSingleLZ(mLZ = mLZ_regA_ReG,RS =c("regA","regA_02","regA_06","regA_08","regD")), "ggplot")
  expect_s3_class(plotSingleLZ(mLZ = mLZ_regA_ReG,RS =c("regA","regA_02","regA_06","regA_08","regD"), smoothing = TRUE), "ggplot")
  expect_s3_class(plotSingleLZ(mLZ = mLZ_regA_ReG,RS =c("regA","regA_02","regA_06","regA_08","regD"), colPal = c("black", "red")), "ggplot")
  expect_s3_class(plotSingleLZ(mLZ = mLZ_regA_ReG,RS =c("regA","regA_02","regA_06","regA_08","regD"), labValues = FALSE), "ggplot")
  expect_s3_class(plotSingleLZ(mLZ = mLZ_regA_ReG,RS =c("regA","regA_02","regA_06","regA_08","regD"), labMax = FALSE), "ggplot")
})

#' similar RegionSets
#'
#' @description
#'
#' Create a list of similar region sets to a reference region set.
#'
#' @details
#'
#' This function takes a region set as an input and a vector of desired randomized
#' fractions. For each fraction value, a new region set will be generated
#' where that fraction of the original regions in the input region set has been randomized.
#' In effect, this creates region sets that are "similar" to a controlled degree
#' to the original region set. This tool can be useful for validation purposes
#' and its use in the demonstration of the usage of this package can be
#' seen in the `RegioneReloaded` vignette.
#'
#' @usage similarRegionSet(GR, name, genome, vectorPerc)
#'
#' @param GR a [GRanges][GenomicRanges::GRanges] object with the input region set.
#' @param name character, name for the output region sets. The names will be generated by adding an underscore and the
#' fraction of similarity after the name of each region set generated. (default = "A")
#' @param genome genome of reference to generate the similar region sets. (default = "hg19)
#' @param vectorPerc numeric, vector of desired randomized fractions. (default = seq(.1,.9,.1))
#'
#' @return A list of [GRanges][GenomicRanges::GRanges] objects.
#'
#' @examples
#'
#' data("cw_Alien")
#'
#' A<-createRandomRegions(nregions = 20, length.mean = 1000, length.sd = 100,
#' genome = AlienGenome)
#'
#' similAList <- similarRegionSet(GR = A, genome = AlienGenome,
#' vectorPerc = seq(0.1,0.9,0.2), name = "test")
#'
#' summary (similAList)
#'
#' @seealso [GRanges][GenomicRanges::GRanges]
#'
#' @examples
#'
#' data("cw_Alien")
#'
#' regA <- createRandomRegions(
#'   nregions = 100,
#'   length.mean = 10,
#'  length.sd = 5,
#'  genome = AlienGenome
#' )
#'
#' listRegA <- similarRegionSet(GR = regA, genome = AlienGenome)
#' summary(listRegA)
#'
#' @export similarRegionSet
#'
similarRegionSet <- function(GR,
                             name = "A",
                             genome = "hg19",
                             vectorPerc = seq(.1,.9,.1))
  {

  GRL<-lapply(seq_along(vectorPerc),
              FUN = function(i, vectorPerc, GR, genome){
                GRL <- randomizeRegionsPerc(GR, genome = genome, frac = vectorPerc[i])},
              vectorPerc, GR, genome)

  vectorNames <- paste0(name, "_0", vectorPerc * 10)

  GRL <- c(GRL, GR)
  vectorNames <- c(vectorNames, name)
  names(GRL) <- vectorNames

  return(GRL)
}

# Load sample data included in the package

data("cw_Alien", package = "regioneReloaded")

# Define small subsets of the region set lists to test crosswisePermTest() with
# a small computation time

sel <- c("regA", "regB", "regAB")
sel_br <- c("regA_br", "regB_br", "regAB_br")

AlienRSList_narrow_small <- AlienRSList_narrow[sel]
AlienRSList_broad_small <- AlienRSList_broad[sel]

#' createUniverse
#'
#' @description
#'
#' Create the universe parameter for [regioneR::resampleRegions()] using all unique regions present in Alist.
#'
#' @usage createUniverse(Alist, joinR = TRUE)
#'
#' @param Alist list of regions set in a format accepted for [regioneR](https://bioconductor.org/packages/release/bioc/html/regioneR.html)
#' @param joinR logical, if TRUE all the regions will be joined using the function [regioneR::joinRegions()].(default == TRUE)
#'
#' @return A list of [GRanges][GenomicRanges::GRanges] objects
#'
#' @examples
#'
#' data("cw_Alien")
#'
#' universe <- createUniverse(AlienRSList_narrow)
#'
#' @importFrom methods as
#'
#' @export

createUniverse <- function(Alist, joinR = TRUE) {
  is.integer0 <- function(x) {
    is.integer(x) && length(x) == 0L
  }

  uniList <- unlist(methods::as(Alist, "GRangesList"))

  if (joinR == TRUE) {
    uniList <- regioneR::joinRegions(uniList)
  }

  return(uniList)
}

#' makeCrosswiseMatrix
#'
#' @description
#'
#' Populate the `matrix` slot in a [genoMatriXeR][genoMatriXeR-class] object.
#'
#' @details
#'
#' This function will create a series of matrices of z-scores, adj.pvalues and
#' pearson correlation values from all the pairwise permutation tests stored in
#' the `multiOverlaps` slot of a [genoMatriXeR][genoMatriXeR-class] as
#' calculated with [multiPermTest()]. These matrices will then be stored in the
#' `matrix` slot of the [genoMatriXeR][genoMatriXeR-class] object. In addition,
#' clustering will be performed on the association matrices using [hclust].
#'
#' @usage makeCrosswiseMatrix(mPT, clusterize = TRUE, hc.method = NULL, dist.method = "euclidean",
#' transform = FALSE, scale = FALSE, zs.type = 'norm_zscore', symm_matrix = TRUE,
#' selectRow = NULL, selectCol = NULL, pvcut = 1, subEX = 0, GM_diag = TRUE, ...)
#'
#' @param mPT an object of class [genoMatriXeR][genoMatriXeR-class].
#' @param clusterize logical, if TRUE the matrix will be clustered using the method specified by \code{hc.method} (default = TRUE)
#' @param hc.method character, select the [hclust()] method to use for clustering the matrix. If NULL, the clustering method will be automatically selected by the function [chooseHclustMet()]. (default = NULL)
#' @param dist.method character, the distance measure to be used from those available in [dist()] . (default = "euclidean")
#' @param transform logical, if TRUE the matrix will be transformed using the function [t()]. (default = FALSE)
#' @param scale logical, if TRUE the matrix will be scaled. (default = FALSE)
#' @param zs.type character, z-score type to use to generate the matrix, either raw z-score ("zscore") or normalized z-score ("norm_zscore"). (default = "norm_zscore")
#' @param symm_matrix logical, if TRUE the matrix will be treated as symmetrical (same clustering for rows and columns). (default = TRUE)
#' @param selectRow,selectCol vector, the matrix will be reduced selecting the rows and/or columns in this vector. (default = NULL)
#' @param pvcut numeric, the z-score value is substituted by `subEX` (0 by default) for all the associations with an adj.pvalue (as calculated in [crosswisePermTest()]) higher than `pvcut`. (default = 0.05)
#' @param subEX numeric, value used to substitute the z-score values when the associated pvalue is higher than `pvcut`. (default = 0)
#' @param GM_diag logic, if FALSE the values of the diagonal will be set to 0. (default = TRUE)
#' @param ... further arguments to be passed to other methods.
#'
#' @return
#'
#' An object of class [genoMatriXeR][genoMatriXeR-class] containing three slots, with a populated `matrix` slot.
#'
#' \itemize{
#' \item \bold{\code{@parameters}}
#' \item \bold{\code{@multioverlaps}}
#' \item \bold{\code{@matrix}}
#'
#' }
#'
#' @seealso [crosswisePermTest()], [chooseHclustMet()], [plotCrosswiseMatrix()]
#'
#' @examples
#'
#' data("cw_Alien")
#'
#' cw_Alien_ReG <- makeCrosswiseMatrix(cw_Alien_ReG)
#'
#' summary(cw_Alien_ReG)
#'
#' @importFrom stats cor
#' @importFrom methods is
#' @export makeCrosswiseMatrix


makeCrosswiseMatrix <-

  function(mPT,
           clusterize = TRUE,
           hc.method = NULL,
           dist.method = "euclidean",
           transform = FALSE,
           scale = FALSE,
           zs.type = 'norm_zscore',
           symm_matrix = TRUE,
           selectRow = NULL,
           selectCol = NULL,
           pvcut = 1,
           subEX = 0,
           GM_diag = TRUE,
           ...) {

    stopifnot("mPT must be an object of class genoMatriXeR" = methods::is(mPT,"genoMatriXeR"))

    mat <- crosswiseMatrix(mPT, zs.type = zs.type)
    mat_pv <- crosswiseMatrix(mPT, zs.type = "adj.p_value")

    if (!is.null(selectRow)) {
      indRow <- grep(paste(selectRow, collapse = "|"), rownames(mat))
      mat <- mat[indRow, , drop = FALSE]
      mat_pv <- mat_pv[indRow, , drop = FALSE]
    }

    if (!is.null(selectCol)) {
      indCol <- grep(paste(selectCol, collapse = "|"), colnames(mat))
      mat <- mat[, indCol, drop = FALSE]
      mat_pv <- mat_pv[, indCol, drop = FALSE]
    }


    if (transform == TRUE) {
      mat <- t(mat)
      mat_pv <- t(mat_pv)
    }

    mat[is.na(mat)] <- 0
    mat[!is.finite(mat)] <- 0

    if (symm_matrix == TRUE & (ncol (mat) != nrow(mat))) {
      symm_matrix <- FALSE
      warning(
        "impossible to create symmetrical matrix, number of columns is different from number of rows"
      )

    }


    if (clusterize == TRUE) {
      fit <-
        chooseHclustMet(mat,
                        scale = scale,
                        vecMet = hc.method,
                        distHC = dist.method)
      ind <- fit$labels[fit$order]

      if (symm_matrix == TRUE) {
        mat <- mat[ind, ind, drop = FALSE]
        mat_pv <- mat_pv[ind, ind, drop = FALSE]
        fit2 <- NULL

      } else{
        fit2 <-
          chooseHclustMet(t(mat),
                          scale = FALSE,
                          vecMet = hc.method,
                          distHC = dist.method)
        ind2 <- fit2$labels[fit2$order]
        mat <- mat[ind, ind2, drop = FALSE]
        mat_pv <- mat_pv[ind, ind2, drop = FALSE]

      }

    } else {
      fit <- NULL
      fit2 <- NULL
    }

    mat_corX <- stats::cor(x = mat, method = "pearson")
    mat_corY <- stats::cor(x = t(mat), method = "pearson")
    mat <- cleanCrosswiseMatrix(
      GM = mat,
      GM_pv = mat_pv ,
      pvcut = pvcut,
      scale = scale,
      subEX = subEX
    )

    if (symm_matrix == TRUE & GM_diag == FALSE) {
      diag(mat) <- 0
    }

    mat1 <-
      list(
        GMat = mat,
        GMat_pv = mat_pv,
        GMat_corX = mat_corX ,
        GMat_corY = mat_corY,
        FitRow = fit,
        FitCol = fit2
      )

    gmxrMatrix(mPT) <- mat1

    return(mPT)

  }

test_that("Argument checks", {
  expect_error(plotCrosswiseMatrix(), "missing")
  expect_error(plotCrosswiseMatrix(cw_Alien_ReG), "empty")
  expect_error(plotCrosswiseMatrix("a"), "genoMatriXeR")
})

test_that("Returns the correct class without errors", {
  cw_Alien_ReG <- makeCrosswiseMatrix(cw_Alien_ReG)
  # Defaults
  expect_s3_class(plotCrosswiseMatrix(cw_Alien_ReG), "ggplot")
  # Matrix type and cor
  expect_s3_class(plotCrosswiseMatrix(cw_Alien_ReG, matrix_type = "correlation"), "ggplot")
  expect_s3_class(plotCrosswiseMatrix(cw_Alien_ReG, matrix_type = "correlation", cor = "col"), "ggplot")
  # Maxval
  expect_s3_class(plotCrosswiseMatrix(cw_Alien_ReG, maxVal = "max"), "ggplot")
  expect_s3_class(plotCrosswiseMatrix(cw_Alien_ReG, maxVal = 3), "ggplot")
  expect_s3_class(plotCrosswiseMatrix(cw_Alien_ReG, maxVal = -3), "ggplot")
  # Colors and interpolate
  expect_s3_class(plotCrosswiseMatrix(cw_Alien_ReG, lineColor = "white", colMatrix = c("darkorange", "darkred", "black")), "ggplot")
  expect_s3_class(plotCrosswiseMatrix(cw_Alien_ReG, interpolate = TRUE), "ggplot")
})

test_that("getMatrix retrieves the correct data", {
  expect_warning(getMatrix(cw_Alien_ReG))
  expect_warning(getMatrix(mLZ_regA_ReG))
  cw_Alien_ReG <- makeCrosswiseMatrix(cw_Alien_ReG)
  mLZ_regA_ReG <- makeLZMatrix(mLZ_regA_ReG)
  expect_snapshot(getMatrix(cw_Alien_ReG))
  expect_snapshot(getMatrix(mLZ_regA_ReG))
})

test_that("Argument checks", {
  expect_error(plotCrosswiseDimRed(), "missing")
  expect_error(plotCrosswiseDimRed("a"))
  expect_error(plotCrosswiseDimRed(cw_Alien_ReR), "empty")
})

test_that("Returns the correct class without errors", {
  cw_Alien_ReR <- makeCrosswiseMatrix(cw_Alien_ReR)
  expect_s3_class(plotCrosswiseDimRed(cw_Alien_ReR), "ggplot")
  expect_s3_class(plotCrosswiseDimRed(cw_Alien_ReR, return_table = TRUE, return_plot = FALSE), "data.frame")
  # Different clustering methods
  expect_s3_class(plotCrosswiseDimRed(cw_Alien_ReR, clust_met = "pam"), "ggplot")
  expect_s3_class(plotCrosswiseDimRed(cw_Alien_ReR, clust_met = "kmeans"), "ggplot")
  # Different plot types
  expect_s3_class(plotCrosswiseDimRed(cw_Alien_ReR, type = "tSNE"), "ggplot")
  expect_s3_class(plotCrosswiseDimRed(cw_Alien_ReR, type = "UMAP"), "ggplot")
  # Graphical parameters
  expect_s3_class(plotCrosswiseDimRed(cw_Alien_ReR, ellipse = TRUE), "ggplot")
  expect_warning(plotCrosswiseDimRed(cw_Alien_ReR, ellipse = TRUE, emphasize = TRUE))
  expect_s3_class(plotCrosswiseDimRed(cw_Alien_ReR, ellipse = TRUE,
                                      emphasize = TRUE,
                                      listRS = list(regA = "regA", regAB = "regAB")), "ggplot")
  expect_s3_class(plotCrosswiseDimRed(cw_Alien_ReR, ellipse = TRUE,
                                      emphasize = TRUE,
                                      listRS = list(regA = "regA", regAB = "regAB"),
                                      labAll = TRUE), "ggplot")
})

#' plotCrosswiseMatrix
#'
#' @description
#'
#' Plot matrix of associations/correlations stored in a [genoMatriXeR][genoMatriXeR-class] object.
#'
#' @details
#'
#' This functions creates a graphical representation of the matrix of associations
#' stored in a [genoMatriXeR][genoMatriXeR-class] object. The values plotted and
#' clustering options can be controlled when creating the matrix with the function
#' [makeCrosswiseMatrix].
#'
#' @usage plotCrosswiseMatrix(mPT, lineColor = NA, interpolate = FALSE, colMatrix =
#' "default", matrix_type = "association", cor = "row",
#' maxVal = NA, main = "", ord_mat = NULL)

#'
#' @param mPT an object of class [genoMatriXeR][genoMatriXeR-class] or a numerical matrix.
#' @param lineColor logical, color for the line grid delineating the tiles of the matrix plot. If NA, no line will be drawn. (default = NA)
#' @param interpolate logical, if TRUE the image will be interpolated using the function [geom_raster()]. (default = FALSE)
#' @param colMatrix character or vector of colors, if "default" will be used a default selection see..
#' @param matrix_type character, type of matrix to be plotted, either "association" or "correlation". (default = "association")
#' @param cor character, if `matrix_type` is "correlation", choose if the function [cor()] will be executed on each "row" or "col" of the matrix. (default = "row")
#' @param maxVal numeric, maximum absolute value displayed by the plot. If "max", the maximum values in the matrix are used. If NA, the 0.95 quantile of all absolute values is used. (default = NA)
#' @param main character, title of the plot. (default = "")
#' @param ord_mat numeric, list with two numeric vectors that represent the ordering of rows and column of the matrix to be used in the plot.
#' If NULL, the order of the matrix is preserved as is. (default = NULL)
#'
#' @return Returns a ggplot object.
#'
#' @seealso [crosswisePermTest] [makeCrosswiseMatrix]
#'
#' @examples
#'
#' data("cw_Alien")
#'
#' cw_Alien_ReG <- makeCrosswiseMatrix( cw_Alien_ReG)
#'
#' plotCrosswiseMatrix(cw_Alien_ReG, matrix_type = "association")
#'
#' plotCrosswiseMatrix(cw_Alien_ReG, matrix_type = "correlation")
#'
#'
#' @import ggplot2
#' @importFrom reshape2 melt
#' @importFrom methods hasArg
#' @importFrom methods is
#' @importFrom RColorBrewer brewer.pal
#'
#' @export plotCrosswiseMatrix
#'

plotCrosswiseMatrix <- function(mPT,
                       lineColor = NA,
                       interpolate = FALSE,
                       colMatrix = "default",
                       matrix_type = "association",
                       cor = "row",
                       maxVal = NA,
                       main = "",
                       ord_mat=NULL) {

  # Check mPT object
  stopifnot("mPT is missing" = methods::hasArg(mPT))
  stopifnot("mPT needs to be a genoMatriXeR object or a numeric matrix" = {
    methods::is(mPT, "genoMatriXeR") | methods::is(mPT, "matrix")
  })
  stopifnot("The matrix slot of mPT is empty, run first makeCrosswiseMatrix()" = !is.null(gmxrMatrix(mPT)[[1]]))

  # Check arguments
  stopifnot("Invalid matrix_type, choose 'association' or 'correlation'" = matrix_type %in% c("association", "correlation"))
  stopifnot("Invalid cor value, choose 'row' or 'col'" = cor %in% c("row", "col"))
  stopifnot("maxVal has to be a numerical value, 'max' or NA" = {
    is.na(maxVal) | is.numeric(maxVal) | maxVal == "max"
  })

  if (methods::is(mPT,"genoMatriXeR")) {

    if  (matrix_type == "association") {
      GM <- getMatrix(mPT)
      title <- "Association Matrix"

      if (is.na(maxVal)){
          maxVal<-quantile(abs(GM),.95)
      }

      if (maxVal=="max"){
        maxVal<-max(c(abs(max(GM)),abs(min(GM))))
      }

    }

    if  (matrix_type == "correlation") {
      if (cor == "row") {
        GM <- gmxrMatrix(mPT)$GMat_corX
      }
      if (cor == "col") {
        GM <- gmxrMatrix(mPT)$GMat_corY
      }
      title <- "Correlation Matrix"
      maxVal<-1
    }

  }


  if (is.matrix(mPT)){
    GM <- mPT
    if (is.na(maxVal)){
      maxVal<-max(c(abs(max(GM)),abs(min(GM))))
    }
  }

  if (length(colMatrix) == 1) {
    if (colMatrix == "default") {
      colMatrix <-
        rev(c(rev(RColorBrewer::brewer.pal(9, "PuBuGn")), RColorBrewer::brewer.pal(9, "YlOrRd")))

    }
  }




  if (!is.null(ord_mat)){
    if (is.list(ord_mat)){
      if(length(ord_mat)==2){
        GM<-GM[ord_mat[[1]],ord_mat[[2]],drop = FALSE]
      }
    }
  }


  DF <- reshape2::melt(GM, varnames = c("X", "Y"))

  if (interpolate == FALSE) {
    ggplot2::ggplot(DF, ggplot2::aes_string(x = "X", y = "Y")) +
      ggplot2::geom_tile(ggplot2::aes_string(fill = "value"), color = lineColor) +
      ggplot2::scale_fill_gradientn(
        colours = rev(colMatrix),
        limits = c(-maxVal, maxVal),
        oob = scales::squish
      )  +
      ggplot2::theme(
        axis.text.x = ggplot2::element_text(
          angle = 90,
          size = 6,
          hjust = 0.95,
          vjust = 0.2
        ),
        axis.text.y = ggplot2::element_text(size = 6)
      ) +
      ggplot2::labs(subtitle = title, title=main, caption = gmxrParam(mPT)$ranFUN) +
      ggplot2::coord_equal()
  } else{
    ggplot2::ggplot(DF, ggplot2::aes_string(x = "X", y = "Y")) +
      ggplot2::geom_raster(ggplot2::aes_string(fill = "value"), interpolate = TRUE) +
      ggplot2::scale_fill_gradientn(
        colours = rev(colMatrix),
        limits = c(-maxVal, maxVal),
        oob = scales::squish
      )  +
      ggplot2::theme(
        axis.text.x = ggplot2::element_text(
          angle = 90,
          size = 6,
          hjust = 0.95,
          vjust = 0.2
        ),
        axis.text.y = ggplot2::element_text(size = 6)
      ) +
      ggplot2::labs(subtitle =  title, title=main,caption = gmxrParam(mPT)$ranFUN) +
       ggplot2::coord_equal()
  }
}

#' chooseHclustMet
#'
#' @description
#'
#' Evaluate and choose the best method for clustering a matrix using the [hclust()] function.
#'
#' @usage chooseHclustMet(GM, scale = FALSE, vecMet = NULL, distHC = "euclidean")
#'
#' @param GM matrix,  numerical matrix.
#' @param scale logical, if TRUE, the clustering will be performed using the scaled matrix. (default = FALSE)
#' @param vecMet character, vector of methods that will be tested in the function.
#' If NULL, the following methods will be tested: "complete", "average", "single", "ward.D2", "median", "centroid" and "mcquitty. (default = NULL)
#' @param distHC character, the distance measure to be used from those available in [dist()] . (default = "euclidean")
#'
#' @return An object of class [hclust]
#'
#' @seealso [hclust()]
#'
#' @examples
#'
#' M1 <- matrix(1:18, nrow = 6, ncol = 3)
#' set.seed(42)
#' M2 <- matrix(sample(100, 18), nrow = 6, ncol = 3)
#' GM <- cbind(M1, M2)
#'
#' chooseHclustMet(GM)
#'
#'
#' @importFrom stats dist
#' @importFrom stats hclust
#' @importFrom stats cor
#' @importFrom stats cophenetic
#' @importFrom methods show
#'
#' @export chooseHclustMet
#'



chooseHclustMet <-
  function(GM,
           scale = FALSE,
           vecMet = NULL,
           distHC = "euclidean") {


    if (scale == TRUE) {
      GM <- scale(GM)
    }

    if (is.null(vecMet)) {
      vecMet <-
        c("complete",
          "average",
          "single",
          "ward.D2",
          "median",
          "centroid",
          "mcquitty"
        )
    }

    mat_dist <- stats::dist(x = GM, method = distHC)

    resMetList<- lapply(seq_along(vecMet),
                        FUN = function(i, mat_dist, vecMet){
                          resMetList<- stats::hclust(d = mat_dist, method = vecMet[[i]])
                        },
                        mat_dist, vecMet)

    names(resMetList) <- vecMet

    resMetVec <- unlist(lapply(seq_along(resMetList),
                               FUN= function(i, mat_dist, resMetList){
                                 resMetVec <- stats::cor(x = mat_dist,
                                                         stats::cophenetic(resMetList[[i]]))
                               },
                               mat_dist, resMetList))


    names(resMetVec) <- vecMet

    name_model <- vecMet[which(resMetVec == max(resMetVec))]

    if (length(name_model) > 1) {
      name_model <- name_model[1]
    }

    model <- resMetList[[name_model]]

    methods::show(paste0("method selected for hclustering: ", name_model))
    methods::show(resMetVec)

    return(model)
  }

#' getHClust
#'
#' @description
#' get Object of class [hclust] from  [genoMatriXeR][genoMatriXeR-class] or [multiLocalZScore][multiLocalZScore-class]
#'
#' @usage getHClust( rR, hctype = "rows")
#'
#' @param rR A genoMatriXeR or multiLocalZScore object.
#' @param hctype character. Can be "rows" or "cols". (default= "cols")
#'
#'
#' @returns
#'
#' an object of class [hclust]
#'
#' @seealso [genoMatriXeR][genoMatriXeR-class], [multiLocalZScore][multiLocalZScore-class], [hclust]
#'
#' @examples
#'
#' data("cw_Alien")
#'
#' cw_Alien_ReG <- makeCrosswiseMatrix(cw_Alien_ReG)
#' hc <- getHClust(cw_Alien_ReG)
#'
#' plot(hc)
#'
#' @importFrom methods is
#' @importFrom methods hasArg
#'
#'
#' @export getHClust
#'

getHClust<-function(rR, hctype = "rows"){

  stopifnot("rR is missing" = methods::hasArg(rR))
  stopifnot("rR must be of class genoMatriXeR or multiLocalZScore" = {
    methods::is(rR , "genoMatriXeR") | methods::is(rR , "multiLocalZScore")
    })
  stopifnot("hctype must be rows or cols" = {
    hctype == "rows" | hctype == "cols"
  })

  if(methods::is(rR , "genoMatriXeR" )){

    if (hctype == "rows"){

      mod <- gmxrMatrix(rR)$FitRow

    }
    if (hctype == "cols"){

      mod <- gmxrMatrix(rR)$FitCol

      if (is.null(mod)) { mod <- gmxrMatrix(rR)$FitRow}

    }

  }

  if(methods::is(rR , "multiLocalZScore")){

      mod <- mlzsMatrix(rR)$FitRow

      if (hctype == "cols"){

        warning(" For a multiLocalZScore objects columns clustering is not allowed,
              row clustering will be retrived instead.")
      }


  }

  return(mod)
}

#' plotCrosswiseDimRed
#'
#' @description
#'
#' Plot a visualization of a [genoMatriXeR][genoMatriXeR-class] object (or matrix) using different
#' dimensional reduction algorithms (PCA, tSNE and UMAP).
#'
#' @details
#'
#' This function generates a plot with a two-dimensional representation of the
#' association data stored in a [genoMatriXeR][genoMatriXeR-class] object by
#' using either PCA, tSNE or UMAP transformations of the data. This function
#' incorporates a clustering step and allows to highlight specific region sets
#' of interest and the clusters they belong to. In addition to generating a plot,
#' a table with the cluster assignments can be retrieved.
#'
#' @usage plotCrosswiseDimRed(mPT, type = "PCA", GM_clust = NA, clust_met =
#' "hclust", nc = 5, listRS = NULL, main = "", labSize = 2, emphasize = FALSE,
#' labAll = FALSE, labMaxOverlap = 100, ellipse = TRUE, colPal = NULL,
#' perplexity = 10, theta = 0.1, return_table = FALSE, return_plot = TRUE, ...)
#'
#'
#' @param mPT an object of class genoMatriXeR or a numerical matrix.
#' @param type character, dimensional reduction algorithm to use ("PCA", "tSNE", "UMAP"). (default  = "PCA")
#' @param GM_clust numeric, vector of assigned clusters used to cluster the matrix. If NA, the matrix will be clustered using the method defined by `clust_met`. (default = NA)
#' @param clust_met character, unsupervised cluster strategy used ([hclust], [kmeans] or [pam]). (default = "hclust")
#' @param nc numeric, number of clusters to define if using the default "kmeans" method. (default = 5)
#' @param listRS list, a list of names of region sets of interest to be highlighted in the graph. (default = NULL)
#' @param main character, title for the plot. (default = "")
#' @param labSize numeric, size for point labels in the plot. If 0, no labels will be plotted. (default = 2)
#' @param emphasize logical, if TRUE, only the cluster in which the elements of `listRS` are present will be highlighted. (default = FALSE)
#' @param labAll logical, if TRUE all data points are labelled, even if not in `listRS` when `emphasize` = TRUE. (default = FALSE)
#' @param labMaxOverlap numeric, max.overlaps for \code{\link{geom_text_repel}}. (default = 100)
#' @param ellipse logical, if TRUE ellipses will be drawn around the clusters. (default = FALSE)
#' @param colPal character, colors to use as palette for the plot. If NULL, default colors will be used. (default = NULL)
#' @param perplexity,theta numeric, if `type` = "tSNE" values of perplexity and theta for the function [Rtsne()]. (default = 10)
#' @param return_table logical, if TRUE a table with the cluster assigned to each region is returned. (default = FALSE)
#' @param return_plot logical, if TRUE a plot is returned. (default = TRUE)
#' @param ... further arguments to be passed on to other methods
#'
#' @return A ggplot object or a table with cluster assignments is returned.
#'
#' @seealso [crosswisePermTest()]
#'
#' @examples
#'
#' data("cw_Alien")
#'
#' cw_Alien_ReG <- makeCrosswiseMatrix(cw_Alien_ReG)
#'
#' plotCrosswiseDimRed(cw_Alien_ReG, type = "PCA")
#'
#' CDR_clust <- plotCrosswiseDimRed(cw_Alien_ReG, type = "UMAP", return_table = TRUE)
#'
#' print(CDR_clust)
#'
#' @export plotCrosswiseDimRed
#'
#' @import ggplot2
#' @importFrom Rtsne Rtsne
#' @importFrom umap umap
#' @importFrom ggrepel geom_text_repel
#' @importFrom stats cutree
#' @importFrom stats kmeans
#' @importFrom stats princomp
#' @importFrom cluster pam
#' @importFrom cluster silhouette
#' @importFrom methods is

plotCrosswiseDimRed <-
  function(mPT,
           type = "PCA",
           GM_clust = NA,
           clust_met = "hclust",
           nc = 5,
           listRS = NULL,
           main = "",
           labSize = 2,
           emphasize = FALSE,
           labAll = FALSE,
           labMaxOverlap = 100,
           ellipse = TRUE,
           colPal = NULL,
           perplexity = 10,
           theta = 0.1,
           return_table = FALSE,
           return_plot = TRUE,
           ...) {

    # Check mPT object
    stopifnot("mPT is missing" = methods::hasArg(mPT))
    stopifnot("mPT needs to be a genoMatriXeR object or a numeric matrix" = {
      methods::is(mPT, "genoMatriXeR") | methods::is(mPT, "matrix")
    })
    stopifnot("The matrix slot of mPT is empty, run first makeCrosswiseMatrix()" = !is.null(gmxrMatrix(mPT)[[1]]))

    # Check arguments
    stopifnot("type must be 'PCA', 'tSNE' or 'UMAP'" = type %in% c("PCA", "tSNE", "UMAP"))
    stopifnot("clust_met must be 'hclust', 'kmeans' or 'pam'" = clust_met %in% c("hclust", "kmeans", "pam"))

    if (methods::is(mPT, "genoMatriXeR")) {
      GM <- getMatrix(mPT)
    } else if (is.matrix(mPT)) {
      GM <- mPT
    }

    if(!all(unlist(listRS) %in% names(gmxrMultiOverlaps(mPT)))) {
      warning("One or more elements in listRS do not match region set names in mPT")
    }

    if (is.na(GM_clust)) {
      if (clust_met == "hclust") {
        clust_tab <- stats::cutree(gmxrMatrix(mPT)$FitRow, k = nc)
        clust_tab <- clust_tab[rownames(GM)]
      }

      if (clust_met == "kmeans") {
        GM_clust <- stats::kmeans(GM, centers = nc)
        clust_tab <- GM_clust$cluster
      }

      if (clust_met == "pam") {
        GM_clust <- cluster::pam(GM, k = nc)
        clust_tab <- GM_clust$cluster
      }
    }

    sil <- cluster::silhouette(clust_tab, dist(GM))
    sumSil <- summary(sil)
    vecSil <- sumSil$clus.avg.widths


    df <- df1 <- data.frame()
    vec <- vec2 <- vec3 <- vector()
    df1 <- do.call("rbind", lapply(seq_len(nc), function(i) {
      nms <- names(clust_tab[clust_tab == i])
      df <- data.frame(
        Name = nms,
        Cluster = rep(paste0("clust_", i), length(nms)),
        ASW = rep(vecSil[i], length(nms))
      )
    })
    )

    df1[is.na(df1)] <- 0

    if (type == "PCA") {
      pdr_out <- stats::princomp(GM, scores = TRUE)
      PoV <- round(pdr_out$sdev^2/sum(pdr_out$sdev^2)*100, 2)
      pdr_df <- data.frame(pdr_out$scores)
      pdr_df <- pdr_df[, c("Comp.1", "Comp.2")]
      colnames(pdr_df) <- c("x", "y")
      pdr_df$Name <- rownames(GM)
    }

    if (type == "tSNE") {
      pdr_out <- Rtsne::Rtsne(GM, perplexity = perplexity, theta = theta, check_duplicates = FALSE)
      pdr_df <- data.frame(
        x = pdr_out$Y[, 1],
        y = pdr_out$Y[, 2],
        Name = rownames(GM)
      )
    }

    if (type == "UMAP") {
      pdr_out <- umap::umap(GM)
      pdr_df <-
        data.frame(
          x = pdr_out$layout[, 1],
          y = pdr_out$layout[, 2],
          Name = rownames(GM)
        )
    }

    if (main == "") {
      main <- deparse(substitute(mPT))
    }


    pdr_df$clust <-
      paste0("clust_", as.factor(clust_tab))

    if (!is.null(listRS) & emphasize) {
      anno_clust <- do.call("rbind", mapply(FUN = function(x, y) {
        data.frame("clust_name" = rep(y, length(x)),
                   "rs_name" = x)
      }, listRS, names(listRS), SIMPLIFY = FALSE))

      pdr_df <- merge(pdr_df, anno_clust, by.x = "Name", by.y = "rs_name", all.x = TRUE, all.y = FALSE)
      pdr_df$clust1 <- pdr_df$clust_name
      pdr_df$clust1[is.na(pdr_df$clust1)] <- "none"

      sel_clust <- pdr_df$clust[pdr_df$clust1 != "none"]

      pdr_df$clust2 <- pdr_df$clust
      pdr_df$clust2[!(pdr_df$clust %in% sel_clust)] <- "none"
      pdr_df$clust <- pdr_df$clust2
      pdr_df_emph <- pdr_df[pdr_df$clust != "none", ]
    } else if (emphasize) {
      warning("Emphasize is set to TRUE but listRS is NULL, ignoring emphasize")
      pdr_df_emph <- pdr_df
    }

    p <-
      ggplot2::ggplot(pdr_df, ggplot2::aes_string(
        x = "x",
        y = "y",
        label = "Name",
        color = "clust"
      )) +
      ggplot2::geom_point()

    if (emphasize & ellipse) { # ellipse only for emphasized clusters
      p <- p + ggplot2::stat_ellipse(
        data = pdr_df_emph,
        type = "t",
        geom = "polygon",
        alpha = 0.15
      )
    } else if (ellipse) { # ellipse for all clusters
      p <- p + ggplot2::stat_ellipse(
        type = "t",
        geom = "polygon",
        alpha = 0.15
      )
    }

    if (emphasize & !labAll) { # label only emphasized clusters
      p <- p + ggrepel::geom_text_repel(
        data = pdr_df_emph,
        size = labSize,
        ggplot2::aes_string(label = "Name"),
        max.overlaps = labMaxOverlap,
        point.padding = 0.5,
        segment.color = "grey"
      )
    } else { # label all clusters
      p <- p + ggrepel::geom_text_repel(
        size = labSize,
        ggplot2::aes_string(label = "Name"),
        max.overlaps = labMaxOverlap,
        point.padding = 0.5,
        segment.color = "grey"
      )
    }

    if (type == "PCA") {
      p <- p + ggplot2::labs(
        title = "PCA plot",
        subtitle = main,
        caption = paste0("clusterization method: ", clust_met),
        x = paste0("PC1: ", PoV[1], "%"),
        y = paste0("PC2: ", PoV[2], "%")
      )
    }

    if (type == "tSNE") {
      p <- p + ggplot2::labs(
        title = "tSNE plot",
        subtitle = main,
        caption = paste0("perplexity: ", perplexity, " theta: ", theta, "\n",
        "clusterization method: ", clust_met),
        x = "tSNE-1",
        y = "tSNE-2"
        )
    }

    if (type == "UMAP") {
      p <- p + ggplot2::labs(
        title = "UMAP plot",
        subtitle = main,
        caption = paste0("clusterization method: ", clust_met),
        x = "UMAP-1",
        y = "UMAP-2"
      )
    }

    # Palette and theme
    pal <- plotPal(colPal)
    p <- p +
      ggplot2::scale_color_manual(values = pal(nc)) +
      ggplot2::scale_fill_manual(values = pal(nc)) +
      mendel_theme()

    if (return_table == TRUE) {
      if (return_plot == TRUE) {
        plot(p)
      }

      return(df1)
    } else {
      if (return_plot == TRUE) {
        return(p)
      }
    }
  }

#' plotSinglePT
#'
#' @description
#'
#' Plot the result of a single pairwise permutation test from a genoMatriXeR object.
#'
#' @details
#'
#' This function generates a plot representing the result of a single
#' permutation test stored in a [genoMatriXeR][genoMatriXeR-class] object. This includes a plot of the
#' density distribution of the randomized evaluations and a vertical line
#' showing the observed evaluation in the original region set. The values of the
#' mean randomized evaluations and the value of the observed evaluation are
#' shown, in addition to the calculated Z-score, normalized Z-score and adjusted
#' p-value.
#'
#' @usage plotSinglePT(mPT, RS1, RS2, xlab = NA, main = NA)
#'
#' @param mPT an object of class [genoMatriXeR][genoMatriXeR-class].
#' @param RS1,RS2 character, names of region sets in a genoMatriXeR object for which to represent the pairwise permutation test results.
#' @param xlab character, label for x axis. (default = NA)
#' @param main title for the plot, if NA the name of the genoMatriXeR object is used (default = NA)
#'
#' @return Returns a ggplot object.
#'
#' @seealso [crosswisePermTest] [makeCrosswiseMatrix]
#'
#' @examples
#'
#' data("cw_Alien")
#' plotSinglePT(cw_Alien_ReG, RS1 = "regA", RS2 = "regA_05")
#' plotSinglePT(cw_Alien_ReG, RS1 = "regA", RS2 = "regC")
#'
#' @import ggplot2
#' @importFrom grid unit
#' @importFrom grid arrow
#' @importFrom methods hasArg
#' @importFrom scales alpha
#' @importFrom stats dnorm
#' @importFrom methods is
#'
#' @export plotSinglePT



plotSinglePT <-
  function(mPT,
           RS1,
           RS2,
           xlab = NA,
           main = NA) {

    # Check mPT object
    stopifnot("mPT is missing" = methods::hasArg(mPT))
    stopifnot("mPT needs to be a genoMatriXeR object or a numeric matrix" = methods::is(mPT, "genoMatriXeR"))

    stopifnot("RS1 and RS2 are required" = methods::hasArg(RS1) & methods::hasArg(RS2))
    stopifnot("RS1 or RS2 do not match region set names in the mPT genoMatriXeR object" = all(c(RS1, RS2) %in% names(gmxrMultiOverlaps(mPT))))

    if (is.na(xlab) & gmxrParam(mPT)$evFUN == "numOverlaps") {
      xlab <- "N of overlaps"
    }

    colvec <- c("#57837B", "#F1ECC3", "#C9D8B6", "#515E63", "#C05555")

    tab <- gmxrMultiOverlaps(mPT)[[RS1]]
    n <- grep(paste0("^", RS2, "$"), tab$name)
    mean.1 <- tab$mean_perm_test[n]
    sd.1 <- tab$sd_perm_test[n]
    max_curve <-
      max(stats::density(stats::rnorm(seq_len(1000), mean = mean.1, sd = sd.1))$y)
    zstart <- mean.1 - 4 * sd.1
    zend   <-   mean.1  + 4 * sd.1
    zs1 <- mean.1 + 1 * sd.1
    zs1neg <- mean.1 - 1 * sd.1
    zs2 <- mean.1 + 2 * sd.1
    zs2neg <- mean.1 - 2 * sd.1
    zs3 <- mean.1 + 3 * sd.1
    zs3neg <- mean.1 - 3 * sd.1
    vec_slices <- c(zs1, zs1neg, zs2, zs2neg, zs3, zs3neg)

    nov <- tab$n_overlaps[n]
    splot <- zstart
    eplot <- zend
    if (zstart > 0) {
      splot <- 0
    }
    if (nov > zend) {
      eplot <- nov
    }
    if (is.na(main)) {
      main <- deparse(substitute(mPT))
    }
    p <- ggplot2::ggplot(data.frame(x = c(splot, eplot)), ggplot2::aes_string("x")) +
      ggplot2::labs(
        title = main,
        subtitle = paste0("PermTest:  ", RS1, " vs ", RS2),
        caption = paste0("Number of Permutations:  ", gmxrParam(mPT)$ntimes)
      ) +
      ggplot2::xlab(paste0(xlab, " on ", tab$n_regionA[n], " regions")) +
      ggplot2::ylab("Freq") +
      ggplot2::stat_function(
        fun = stats::dnorm,
        geom = "area",
        fill = scales::alpha(colvec[1], alpha = 0.5),
        args = list(mean = mean.1, sd = sd.1)
      ) +
      ggplot2::stat_function(
        fun = stats::dnorm,
        geom = "area",
        xlim = c(vec_slices[1], zend),
        fill = scales::alpha(colvec[1], alpha = 0.5),
        args = list(mean = mean.1, sd = sd.1)
      ) +
      ggplot2::stat_function(
        fun = stats::dnorm,
        geom = "area",
        xlim = c(vec_slices[3], zend),
        fill = scales::alpha(colvec[1], alpha = 0.5),
        args = list(mean = mean.1, sd = sd.1)
      ) +
      ggplot2::stat_function(
        fun = stats::dnorm,
        geom = "area",
        xlim = c(vec_slices[5], zend),
        fill = scales::alpha(colvec[1], alpha = 0.5),
        args = list(mean = mean.1, sd = sd.1)
      ) +
      ggplot2::stat_function(
        fun = stats::dnorm,
        geom = "area",
        xlim = c(zstart, vec_slices[2]),
        fill = scales::alpha(colvec[1], alpha = 0.5),
        args = list(mean = mean.1, sd = sd.1)
      ) +
      ggplot2::stat_function(
        fun = stats::dnorm,
        geom = "area",
        xlim = c(zstart, vec_slices[4]),
        fill = scales::alpha(colvec[1], alpha = 0.5),
        args = list(mean = mean.1, sd = sd.1)
      ) +
      ggplot2::stat_function(
        fun = stats::dnorm,
        geom = "area",
        xlim = c(zstart, vec_slices[6]),
        fill = scales::alpha(colvec[1], alpha = 0.5),
        args = list(mean = mean.1, sd = sd.1)
      ) +


      ggplot2::geom_hline(yintercept = 0,
                 color = colvec[4],
                 size = 0.6) +


      ggplot2::geom_vline(
        xintercept = 0,
        color = colvec[4],
        size = 0.4,
        linetype = "dotted"
      ) +

      # Random overlaps
      ggplot2::geom_vline(
        xintercept = c(mean.1),
        color = colvec[4],
        linetype = "dashed",
        size = 0.4
      ) +

      # Observed overlaps
      ggplot2::geom_vline(
        ggplot2::aes_string(xintercept = "nov"),
        color = colvec[5],
        linetype = "dashed",
        size = 0.4
      ) +

      # Arrow between random and observed
      ggplot2::geom_segment(
        ggplot2::aes(
          x = mean.1,
          y = max_curve / 2,
          xend = nov,
          yend = max_curve / 2
        ),
        linetype = "dashed",
        color = colvec[4],
        arrow = grid::arrow(length = grid::unit(0.5, "cm"))
      ) +

      # Text labels
      # Box with ZS and adjpv
      ggplot2::annotate(
        "label",
        x = mean.1 + ((nov - mean.1) / 2),
        y = max_curve * 0.36,
        label = paste(
          "Z-score",
          tab$z_score[n],
          "adj.p-value",
          tab$adj.p_value[n],
          sep = "\n"
        ),
        size = 3,
        fill = "#FDFAF6"
      ) +
      # Box with nZS and sZS
      ggplot2::annotate(
        "label",
        x = eplot * 0.9,
        y = max_curve * 0.9,
        size = 3,
        fill = "#FDFAF6",
        label = paste(
          paste0("Normal Z-score: ", round(tab$norm_zscore[n], digits = 2)),
          sep = "\n"
        ),
        hjust = 1
      ) +
      # Ranfun used
      ggplot2::annotate(
        "text",
        x = eplot * 0.5,
        y = max_curve * 0.99,
        label = gmxrParam(mPT)$ranFUN
      ) +
      # Observed and mean random overlaps
      ggplot2::annotate(
        "label",
        x = nov,
        y = max_curve * 0.03,
        size = 3,
        label = nov,
        col = colvec[5],
        hjust = 0.5,
        fill = "#FDFAF6"
      ) +
      ggplot2::annotate(
        "label",
        x = mean.1,
        y = -max_curve * 0.03,
        size = 3,
        label = round(mean.1, digits = 2),
        col = colvec[4],
        hjust = 0.5,
        fill = "#FDFAF6"
      ) +
      mendel_theme()
    return(p)
  }

test_that("Argument checks", {
  expect_error(plotSinglePT(), "missing")
  expect_error(plotSinglePT("a"), "genoMatriXeR")
  expect_error(plotSinglePT(cw_Alien_ReG), "RS1")
  expect_error(plotSinglePT(cw_Alien_ReG, RS1 = "a", RS2 = "regA"), "RS1")
})

test_that("Returns the correct class without errors", {
  expect_s3_class(plotSinglePT(cw_Alien_ReG, RS1 = "regA", RS2 = "regA_05"), "ggplot")
  expect_s3_class(plotSinglePT(cw_Alien_ReG, RS1 = "regA", RS2 = "regC"), "ggplot")
})

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
 fig.width=6, 
 fig.height=6,
 fig.align = "center"
)

## ----style, echo = FALSE, results = 'asis'------------------------------------
BiocStyle::markdown()

## ----eval=FALSE---------------------------------------------------------------
# 
# if (!require("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("regioneReloaded")
# 

## ----setup--------------------------------------------------------------------
library("regioneReloaded")

## ----load _data, eval=FALSE---------------------------------------------------
# #NOT RUN
# 
#   set.seed(42)
#   cw_Alien_ReG<-crosswisePermTest(Alist = AlienRSList_narrow,
#                             sampling = FALSE,
#                             mc.cores= 25,
#                             ranFUN = "resampleGenome",
#                             evFUN = "numOverlaps",
#                             genome = AlienGenome,
#                             ntimes= 1000
#   )
# #

## -----------------------------------------------------------------------------

data("cw_Alien")

cw_Alien_ReG<-makeCrosswiseMatrix(cw_Alien_ReG, pvcut = 1)

plotCrosswiseMatrix(cw_Alien_ReG)


## -----------------------------------------------------------------------------

AlienGenome <-
  toGRanges(data.frame(
    chr = c("AlChr1", "AlChr2", "AlChr3", "AlChr4"),
    start = c(rep(1, 4)),
    end = c(2e6, 1e6, 5e5, 1e5)
  ))



## -----------------------------------------------------------------------------
gnm <- AlienGenome

nreg=100

regA <-
  createRandomRegions(
    nregions = nreg,
    length.mean = 100,
    length.sd = 50,
    non.overlapping = TRUE,
    genome = gnm
  )

regB <-
  createRandomRegions(
    nregions = nreg,
    length.mean =  100,
    length.sd = 50 ,
    non.overlapping = TRUE,
    genome = gnm
  )

regC <-
  createRandomRegions(
    nregions = nreg,
    length.mean = 100,
    length.sd = 50,
    non.overlapping = TRUE,
    genome = gnm
  )


## -----------------------------------------------------------------------------

vectorPerc <- seq(0.1, 0.9, 0.1)

RsetA <-
  similarRegionSet(
    GR = regA,
    name = "regA",
    genome = gnm,
    vectorPerc = vectorPerc
  )
RsetB <-
  similarRegionSet(
    GR = regB,
    name = "regB",
    genome = gnm,
    vectorPerc = vectorPerc
  )
RsetC <-
  similarRegionSet(
    GR = regC,
    name = "regC",
    genome = gnm,
    vectorPerc = vectorPerc
  )


## -----------------------------------------------------------------------------

vectorPerc2 <- seq(0.2, 0.8, 0.2)
regAB <- c(sample(regA, nreg / 2), sample(regB, nreg / 2))
RsetAB <-
  similarRegionSet(
    GR = regAB,
    name = "regAB",
    genome = gnm,
    vectorPerc = vectorPerc2
  )


## -----------------------------------------------------------------------------

reg_no_A <-
  createRandomRegions(
    nregions = nreg,
    length.mean = 100,
    length.sd = 50,
    non.overlapping = TRUE,
    genome = subtractRegions(gnm, regA)
  )

reg_no_B <-
  createRandomRegions(
    nregions = nreg,
    length.mean = 100,
    length.sd = 50,
    non.overlapping = TRUE,
    genome = subtractRegions(gnm, regB)
  )

reg_no_C <-
  createRandomRegions(
    nregions = nreg,
    length.mean = 100,
    length.sd = 50,
    non.overlapping = TRUE,
    genome = subtractRegions(gnm, regC)
  )

reg_no_AB <-
  createRandomRegions(
    nregions = nreg,
    length.mean = 100,
    length.sd = 50,
    non.overlapping = TRUE,
    genome = subtractRegions(gnm, c(regA, regB))
  )

reg_no_ABC <-
  createRandomRegions(
    nregions = nreg,
    length.mean = 100,
    length.sd = 50,
    non.overlapping = TRUE,
    genome = subtractRegions(gnm, c(regA, regB, regC))
  )


## -----------------------------------------------------------------------------

dst <- sample(c(-300,300),length(regA),replace = TRUE)
regD <- regioneR::toGRanges(
                    data.frame(
                      chr=as.vector(GenomeInfoDb::seqnames(regA)),
                      start = start(regA) + dst,
                      end = end (regA) + dst
                      )
                    )

RsetD <-
  similarRegionSet(
    GR = regD,
    name = "regD",
    genome = gnm,
    vectorPerc = vectorPerc2
  )


## -----------------------------------------------------------------------------

Rset_NO <- list(reg_no_A, reg_no_B, reg_no_C, reg_no_AB, reg_no_ABC)

names(Rset_NO) <- c("reg_no_A", "reg_no_B", "reg_no_C", "reg_no_AB", "reg_no_ABC")

AlienRSList_narrow <- c(RsetA, RsetB, RsetC, RsetD, RsetAB, Rset_NO)

summary(AlienRSList_narrow)


## -----------------------------------------------------------------------------

data("cw_Alien")
getParameters(cw_Alien_ReG)


## ----eval=FALSE---------------------------------------------------------------
# 
# #NOT RUN
# 
# set.seed(42)
# cw_Alien_RaR <-  crosswisePermTest(
#   Alist = AlienRSList_narrow,
#   Blist = AlienRSList_narrow,
#   sampling = FALSE,
#   genome = AlienGenome,
#   per.chromosome=TRUE,
#   ranFUN = "randomizeRegions",
#   evFUN = "numOverlaps",
#   ntimes= 1000,
#   mc.cores = 20
# )
# 
# 
# set.seed(42)
# cw_Alien_ReR <-  crosswisePermTest(
#   Alist = AlienRSList_narrow,
#   Blist = AlienRSList_narrow,
#   sampling = FALSE,
#   genome = AlienGenome,
#   per.chromosome=TRUE,
#   ranFUN = "resampleRegions",
#   evFUN = "numOverlaps",
#   ntimes= 1000,
#   mc.cores = 20
# )
# 
# set.seed(42)
# cw_Alien_ReG <-  crosswisePermTest(
#   Alist = AlienRSList_narrow,
#   Blist = AlienRSList_narrow,
#   sampling = FALSE,
#   genome = AlienGenome,
#   per.chromosome=TRUE,
#   ranFUN = "resampleGenome",
#   evFUN = "numOverlaps",
#   ntimes= 100,
#   mc.cores = 20
# )
# 
# #
# 

## -----------------------------------------------------------------------------

cw_Alien_RaR <- makeCrosswiseMatrix(cw_Alien_RaR)

cw_Alien_ReG <- makeCrosswiseMatrix(cw_Alien_ReG)

cw_Alien_ReR <- makeCrosswiseMatrix(cw_Alien_ReR)


## -----------------------------------------------------------------------------

modX <- getHClust(cw_Alien_ReG,hctype = "rows")
modY <- getHClust(cw_Alien_ReG,hctype = "cols")



X<-modX$labels[modX$order]
Y<-modY$labels[modX$order]

ord<-list(X=X,Y=Y)

p_ReG <- plotCrosswiseMatrix(cw_Alien_ReG, matrix_type = "association", ord_mat = ord)
p_ReR <- plotCrosswiseMatrix(cw_Alien_ReR, matrix_type = "association", ord_mat = ord)


plot(p_ReG)
plot(p_ReR)


## -----------------------------------------------------------------------------

plot(modX,cex = 0.8)


## -----------------------------------------------------------------------------

p_ReG_cor <- plotCrosswiseMatrix(cw_Alien_ReG, matrix_type = "correlation", ord_mat = ord)
# p_ReR_cor <- plotCrosswiseMatrix(cw_Alien_ReR, matrix_type = "correlation", ord_mat = ord)

plot(p_ReG_cor)
# plot(p_ReR_cor)


## -----------------------------------------------------------------------------
plotSinglePT(cw_Alien_ReG, RS1 = "regA", RS2 = "regA_05")

## -----------------------------------------------------------------------------
  p_sPT1 <- plotSinglePT(cw_Alien_ReG, RS1 = "regA", RS2 = "regC")

plot(p_sPT1)

## -----------------------------------------------------------------------------

set.seed(42)

plotCrosswiseDimRed(cw_Alien_ReG, nc = 6, type="PCA")


## -----------------------------------------------------------------------------
set.seed(42)
p_cdr_hc <- plotCrosswiseDimRed(cw_Alien_ReG, nc = 6, type="PCA", clust_met = "hclust")

# set.seed(42)
# p_cdr_pam <- plotCrosswiseDimRed(cw_Alien_ReG, nc = 6, type="PCA", clust_met = "pam")

plot(p_cdr_hc) 
# plot(p_cdr_pam)
          

## -----------------------------------------------------------------------------

lsRegSet<-list(regA="regA",regB="regB",regC="regC")

set.seed(42)
plotCrosswiseDimRed(cw_Alien_ReG, nc = 6, type="PCA",listRS = lsRegSet)

set.seed(42)
plotCrosswiseDimRed(cw_Alien_ReG, nc = 6, type="PCA",listRS = lsRegSet,ellipse = TRUE, emphasize =TRUE)

set.seed(67)
plotCrosswiseDimRed(cw_Alien_ReG, nc = 6, type="tSNE",listRS = lsRegSet,ellipse = TRUE, emphasize =TRUE)

set.seed(67)
plotCrosswiseDimRed(cw_Alien_ReG, nc = 6, type="UMAP",listRS = lsRegSet,ellipse = TRUE, emphasize =TRUE)


## -----------------------------------------------------------------------------
set.seed(67)
silTable <- plotCrosswiseDimRed(cw_Alien_ReG, nc = 6, type="UMAP",listRS = lsRegSet,return_table = TRUE)

silTable

## ----eval=FALSE---------------------------------------------------------------
# 
# #NOT RUN
# mlz_Alien_ReG<-multiLocalZscore(A = AlienRSList_narrow$regA,
#                  Blist = AlienRSList_narrow,
#                  ranFUN = "resampleGenome",
#                  evFUN = "numOverlaps",
#                  window = 100,
#                  step = 1,
#                  max_pv = 1,
#                  genome = AlienGenome)

## -----------------------------------------------------------------------------
getParameters(mLZ_regA_ReG)

mlz_Me <- getMultiEvaluation(rR = mLZ_regA_ReG )

head(mlz_Me$resumeTable)

## -----------------------------------------------------------------------------

mLZ_regA_ReG <- makeLZMatrix(mLZ_regA_ReG)

plot(getHClust(mLZ_regA_ReG),cex = 0.8)

## -----------------------------------------------------------------------------
plotLocalZScoreMatrix(mLZ_regA_ReG, maxVal = "max")

## -----------------------------------------------------------------------------
plotSingleLZ(mLZ = mLZ_regA_ReG, RS =c("regA"), smoothing = TRUE)

## -----------------------------------------------------------------------------
plotSingleLZ(mLZ = mLZ_regA_ReG,RS =c("regA","regA_02","regA_06","regA_08","regD"),smoothing = TRUE)

## -----------------------------------------------------------------------------
# average of the widths of AlienRSList_narrow
do.call("c",lapply(lapply(AlienRSList_narrow, width),mean))
# average of the widths of AlienRSList_broad
do.call("c",lapply(lapply(AlienRSList_broad, width),mean))

## ----eval=FALSE---------------------------------------------------------------
# 
# ##NOT RUN
# cw_Alien_RaR_no_Square <-  crosswisePermTest(
#   Alist = AlienRSList_narrow,
#   Blist = AlienRSList_broad,
#   sampling = FALSE,
#   genome = AlienGenome,
#   per.chromosome=TRUE,
#   ranFUN = "resampleGenome",
#   evFUN = "numOverlaps",
#   ntimes= 100,
#   mc.cores = 6
# )
# 
# ###

## -----------------------------------------------------------------------------
cw_Alien_ReG_no_Square <- makeCrosswiseMatrix(cw_Alien_ReG_no_Square)

plotCrosswiseMatrix(cw_Alien_ReG_no_Square)

## ----eval=FALSE---------------------------------------------------------------
# 
# #NOT RUN
# mLZ_regA_ReG_br<-multiLocalZscore(A =
#                                     AlienRSList_narrow$regA,
#                                   Blist = AlienRSList_broad,
#                                   ranFUN = "resampleGenome",
#                                   genome = AlienGenome,
#                                   window = 5000,
#                                   step =100)
# ##

## -----------------------------------------------------------------------------
mLZ_regA_ReG_br<-makeLZMatrix(mLZ_regA_ReG_br)

plotLocalZScoreMatrix(mLZ_regA_ReG_br)

## -----------------------------------------------------------------------------
plotSingleLZ(mLZ = mLZ_regA_ReG_br,RS =c("regA_br","regA_br_02","regA_br_06","regA_br_08","regD_br"), smoothing = TRUE)


## ----sessionInfo--------------------------------------------------------------
sessionInfo()

#' getParameters
#'
#' @description
#'
#' Get parameters from a genoMatriXeR or multiLocalZScore class object.
#'
#' @usage getParameters(rR, show_err = FALSE)
#'
#' @param rR A genoMatriXeR or multiLocalZScore class object.
#' @param show_err logical, if TRUE the function returns a list with two dataframes:
#' one containing the parameter values and one with any error messages that have been
#' generated during the permutation test iterations when running [crosswisePermTest].
#'
#' @return A dataframe with parameters and values, or a list with two dataframes
#' with parameters and errors information.
#'
#' @seealso [genoMatriXeR][genoMatriXeR-class], [multiLocalZScore][multiLocalZScore-class]
#'
#' @examples
#'
#' data("cw_Alien")
#'
#' prm <- getParameters(cw_Alien_ReG)
#'
#' prm
#'
#'
#' @importFrom methods is
#' @importFrom methods hasArg
#'
#' @export getParameters
#'

getParameters <- function(rR, show_err = FALSE){

  stopifnot("rR is missing" = methods::hasArg(rR))
  stopifnot("rR must be an object of class genoMatriXeR or multiLocalZScore" = {
    methods::is(rR , "genoMatriXeR") | methods::is(rR , "multiLocalZScore")
  })

  if (methods::is(rR , "genoMatriXeR")) {
    param <- gmxrParam(rR)
    errors <- param$errors
    param <- param[names(param) != "errors"]
    res <- data.frame(parameter = names(param), value = as.character(param))

    if (show_err) {
      res <- list(parameters = res, errors = errors)
    }

  }

  if(methods::is(rR , "multiLocalZScore")){
    param <- mlzsParam(rR)
    res <- data.frame(parameter = names(param), value = as.character(param))

    if (show_err) {
      message("show_err is only relevant for genoMatriXeR objects")
    }
  }

  return(res)
}

test_that("getParameters argument checks", {
  expect_error(getParameters(), "missing")
  expect_error(getParameters("a"), "genoMatriXeR")
})

test_that("getParameters retrieves the correct data", {
  expect_snapshot(getParameters(cw_Alien_ReG))
  expect_snapshot(getParameters(mLZ_regA_ReG))
})

#' Dataframe from MultiLocalZScore object
#'
#' @return a data.frame from [multiLocalZScore-class]
#'
#' @usage DFfromLZ( mLZ, RS )
#' @param mLZ object class MultilocalZScore
#' @param RS string name of single region set present in the mLZ object
#'
#' @keywords internal

DFfromLZ <- function(mLZ, RS) {

  nelem <- grep(paste0("\\b",RS,"\\b"), names(mlzsMultiLocalZscores(mLZ)$shifed_ZSs))

  lineLZ <- mlzsMultiLocalZscores(mLZ)$shifed_ZSs[[nelem]]
  nreg <- mlzsParam(mLZ)$Nregions

  zs <- mlzsMultiLocalZscores(mLZ)$resumeTab$z_score[nelem]
  pv <- mlzsMultiLocalZscores(mLZ)$resumeTab$adj.p_value[nelem]
  mlzsMultiLocalZscores(mLZ)$resumeTab$n_overlaps == nreg

  df <-
    data.frame(
      name = rep(RS, length(lineLZ)),
      lzscore = lineLZ,
      normLocalZscore = lineLZ / (sqrt(nreg)),
      shift = mlzsMultiLocalZscores(mLZ)$shifts
    )

  return(df)

}

#' @title cw_Alien
#'
#' @description
#'
#' Alien Genome crosswise matrix using [regioneR::randomizeRegions] , [regioneR::circularRandomizeRegions],
#' [regioneR::resampleRegions], [regioneR::resampleGenome] functions as permutation strategies.
#'
#' @name cw_Alien
#' @docType data
#' @usage data(cw_Alien)
#' @format An objects of class [genoMatriXeR][genoMatriXeR-class]; see [makeCrosswiseMatrix()].
#'
#' @keywords datasets
#'
NULL #"cw_Alien"




#' @title AlienGenome
#'
#' @description
#'
#' The Alien Genome is an artificial genomic coordinates system for the purposes
#' of testing and demonstrating the functions of regioneReload with a low
#' computing time.
#'
#' @details
#'
#' The Alien Genome consists of four chromosomes and is generated by the
#' following code:
#'
#' \preformatted{AlienGenome <-
#' toGRanges(data.frame(
#'   chr = c("AlChr1", "AlChr2", "AlChr3", "AlChr4"),
#'   start = c(rep(1, 4)),
#'   end = c(2e6, 1e6, 5e5, 1e5)
#' ))}
#'
#' @name AlienGenome
#' @docType data
#' @usage data(cw_Alien)
#' @format An objects of class [GRanges][GenomicRanges::GRanges].
#'
#' @keywords datasets
#'
NULL #"cw_Alien"





#' @title AlienRSList_narrow
#'
#' @description
#'
#' List of region sets (as [GRanges][GenomicRanges::GRanges]) on the [AlienGenome].
#'
#' @details
#'
#' This region sets are generated for the purpose of demonstrating the functions
#' of RegioneReloaded with a low computing time and "predictable" associations. The
#' regions are generated with by combining [createRandomRegions()] and
#' [similarRegionSet()] so that there is a known overlap between certain region
#' sets. To see a full description of this sample data and the code used to
#' generate it, see the RegioneReloaded vignette.
#'
#' @name AlienRSList_narrow
#' @docType data
#' @usage data(cw_Alien)
#' @format A list of [GRanges][GenomicRanges::GRanges] objects.
#'
#' @keywords datasets
#'
NULL #"cw_Alien"





#' @title AlienRSList_broad
#'
#' @description
#'
#' List of region sets (as [GRanges][GenomicRanges::GRanges]) on the [AlienGenome].
#'
#' @details
#'
#' This region sets are generated for the purpose of demonstrating the functions
#' of RegioneReloaded with a low computing time and "predictable" associations. The
#' regions are generated with by combining [createRandomRegions()] and
#' [similarRegionSet()] so that there is a known overlap between certain region
#' sets. To see a full description of this sample data and the code used to
#' generate it, see the RegioneReloaded vignette.
#'
#' @name AlienRSList_broad
#' @docType data
#' @usage data(cw_Alien)
#' @format A list of [GRanges][GenomicRanges::GRanges] objects.
#'
#' @keywords datasets
#'
NULL #"cw_Alien"




#' @title cw_Alien_RaR
#'
#' @description
#'
#' Alien Genome crosswise matrix using [regioneR::randomizeRegions()]
#' function a permutation strategy. Alist = AlienRSList_narrow, Blist = AlienRSList_narrow
#'
#' @name cw_Alien_RaR
#' @docType data
#' @usage data(cw_Alien)
#' @format An objects of class [genoMatriXeR][genoMatriXeR-class]; see [makeCrosswiseMatrix()].
#'
#' @keywords datasets
#'
NULL #"cw_Alien"



#' @title cw_Alien_ReG
#'
#' @description
#'
#' Alien Genome crosswise matrix using [regioneR::resampleGenome()] function as permutations
#' trategy. Alist = AlienRSList_narrow, Blist = AlienRSList_narrow
#'
#' @name cw_Alien_ReG
#' @docType data
#' @usage data(cw_Alien)
#' @format An objects of class [genoMatriXeR][genoMatriXeR-class]; see [makeCrosswiseMatrix()].
#'
#' @keywords datasets
#'
NULL #"cw_Alien"



#' @title cw_Alien_ReR
#'
#' @description
#'
#' Alien Genome crosswise matrix using [regioneR::resampleRegions()] function a permutation
#' strategy.Alist = AlienRSList_narrow, Blist = AlienRSList_narrow
#'
#' @name cw_Alien_ReR
#' @docType data
#' @usage data(cw_Alien)
#' @format An objects of class [genoMatriXeR][genoMatriXeR-class]; see [makeCrosswiseMatrix()].
#'
#' @keywords datasets
#'
NULL #"cw_Alien"



#' @title cw_Alien_ReG_no_Square
#'
#' @description
#'
#' Alien Genome crosswise matrix using [regioneR::resampleGenome()] function as permutations
#' trategy. Alist = AlienRSList_narrow, Blist = AlienRSList_broad
#'
#' @name cw_Alien_ReG_no_Square
#' @docType data
#' @usage data(cw_Alien)
#' @format An objects of class [genoMatriXeR][genoMatriXeR-class]; see [makeCrosswiseMatrix()].
#'
#' @keywords datasets
#'
NULL #"cw_Alien"



#' @title mLZ_regA_ReG
#'
#' @description
#'
#' Alien Genome multiLocalZScore calculated for regA regionset from AlienRSList_narrow using [regioneR::resampleGenome()] function as permutation s
#' trategy.
#'
#' @name mLZ_regA_ReG
#' @docType data
#' @usage data(cw_Alien)
#' @format An objects of class [multiLocalZScore][multiLocalZScore-class]; see [makeLZMatrix()].
#'
#' @keywords datasets
#'
NULL #"cw_Alien"



#' @title mLZ_regA_ReG_br
#'
#' @description
#'
#' Alien Genome multiLocalZScore calculated for regA regionset from AlienRSList_broad using [regioneR::resampleGenome()] function as permutation s
#' trategy.
#'
#' @name mLZ_regA_ReG_br
#' @docType data
#' @usage data(cw_Alien)
#' @format An object of class [multiLocalZScore][multiLocalZScore-class]
NULL



#' @title mLZ_regD_ReG
#'
#' @description
#'
#' Alien Genome multiLocalZScore calculated for regD regionset from AlienRSList_narrow using [regioneR::resampleGenome()] function as permutation s
#' trategy.
#'
#' @name mLZ_regD_ReG
#' @docType data
#' @usage data(cw_Alien)
#' @format An object of class [multiLocalZScore][multiLocalZScore-class]
NULL

#' Get Matrix
#'
#' @description
#'
#' Returns the matrix from an [genoMatriXeR][genoMatriXeR-class] or [multiLocalZScore][multiLocalZScore-class] object.
#'
#' @usage getMatrix(rR)
#'
#' @param rR genoMatriXeR or multiLocalZScore object
#'
#' @return a numerical matrix from a
#'
#' @examples
#'
#' data("cw_Alien")
#'
#' cw_Alien_ReG <- makeCrosswiseMatrix(cw_Alien_ReG)
#' mtx <- getMatrix(cw_Alien_ReG)
#'
#' mtx
#'
#' @seealso [genoMatriXeR][genoMatriXeR-class], [multiLocalZScore][multiLocalZScore-class], [makeCrosswiseMatrix], [makeLZMatrix]
#'
#' @examples
#'
#' data("cw_Alien")
#'
#' cw_Alien_RaR <- makeCrosswiseMatrix(cw_Alien_RaR)
#' GM <- getMatrix(cw_Alien_RaR)
#'
#' GM
#'
#' @importFrom methods is
#' @importFrom methods hasArg
#'
#' @export getMatrix
#'

getMatrix <- function(rR) {

  stopifnot("rR is missing" = methods::hasArg(rR))
  stopifnot("rR must be of class genoMatriXeR or multiLocalZScore" = {
    methods::is(rR , "genoMatriXeR") | methods::is(rR , "multiLocalZScore")
  })

  if (methods::is(rR, "genoMatriXeR")) {
    if (is.null(rR@matrix[[1]])){
      warning("no matrix computed for genoMatriXeR object, run first makeCrosswiseMatrix()")
    }
    GM <- gmxrMatrix(rR)$GMat
  }

  if (methods::is(rR, "multiLocalZScore")) {
    if (is.null(rR@matrix[[1]])){
      warning("no matrix computed for multiLocalZScore object, run first makeLZMatrix()")
    }
    GM <- mlzsMatrix(rR)$LZM
  }

  return(GM)
}

#' Plot Local Z-Score Matrix
#'
#'
#' Plot Local Z-Score Matrix of associations/correlations stored in a [multiLocalZScore-class] object.
#'
#' @usage plotLocalZScoreMatrix (mLZ, lineColor = NA, colMatrix = "default",
#' matrix_type = "association", maxVal = "max", main = "", labSize = 6,
#' revert = FALSE, highlight = NULL, highlight_size = 2.5, highlight_max = FALSE,
#' smoothing = FALSE, ...)
#'
#' @inheritParams plotCrosswiseMatrix
#'
#' @param mLZ an object of class [multiLocalZScore-class] or a matrix
#' @param labSize numeric, size for the plot labels. (default = 6)
#' @param revert logical, if TRUE reverts the order of the plotted elements. (default = FALSE)
#' @param highlight character, vector indicating the region set names to highlight by adding labels pointing to the 0 shift position (default = NULL)
#' @param highlight_size numeric, size of the highlight labels. (default = 2.5)
#' @param highlight_max logical, if TRUE the highlight labels are placed at the maximum local z-score value instead of the 0 shift position. (default = FALSE)
#' @param smoothing logical, if TRUE the [stats::smooth.spline] function will be applied to the local z-score profile. (default = FALSE)
#' @param ...  further arguments to be passed to other methods.
#'
#' @return Returns a ggplot object.
#'
#' @seealso [multiLocalZscore] [makeLZMatrix] [multiLocalZScore-class]
#'
#' @examples
#'
#' data("cw_Alien")
#'
#'
#'
#' @import ggplot2
#' @importFrom ggrepel geom_label_repel
#' @importFrom reshape2 melt
#' @importFrom stats quantile
#' @importFrom RColorBrewer brewer.pal
#' @importFrom methods hasArg
#' @importFrom stats smooth.spline
#' @importFrom stats aggregate
#'
#' @export plotLocalZScoreMatrix

plotLocalZScoreMatrix <- function(mLZ,
                                  lineColor = NA,
                                  colMatrix = "default",
                                  matrix_type = "association",
                                  maxVal = "max",
                                  main = "",
                                  labSize = 6,
                                  revert = FALSE,
                                  highlight = NULL,
                                  highlight_size = 2.5,
                                  highlight_max = FALSE,
                                  smoothing = FALSE,
                                  ...) {
  # Check mLZ object
  stopifnot("mLZ is missing" = methods::hasArg(mLZ))
  stopifnot("mLZ needs to be a multiLocalZScore object" = {
    methods::is(mLZ, "multiLocalZScore") | methods::is(mLZ, "matrix")
  })
  stopifnot("The matrix slot of mLZ is empty, run first makeCrosswiseMatrix()" = !is.null(mlzsMatrix(mLZ)[[1]]))

  # Check arguments
  stopifnot("Invalid matrix_type, choose 'association' or 'correlation'" = matrix_type %in% c("association", "correlation"))
  stopifnot("maxVal has to be a numerical value, 'max' or NA" = {
    is.na(maxVal) | is.numeric(maxVal) | maxVal == "max"
  })

  if (matrix_type == "association") {
    GM <- t(getMatrix(mLZ))
    title <- "Association Matrix"

    if (is.na(maxVal)){
      maxVal<- stats::quantile(abs(GM),.95)
    }

    if (maxVal=="max"){
      maxVal<-max(c(abs(max(GM)),abs(min(GM))))
    }


    if(revert == TRUE){
      GM <-GM[rev(rownames(GM)), , drop = FALSE]
    }
  }

  if (matrix_type == "correlation") {
    GM <- mlzsMatrix(mLZ)$LZM_cor

    title <- "Correlation Matrix"
    maxVal <- 1
  }

  if (length(colMatrix)== 1){
    if (colMatrix == "default") {
      colMatrix <-
        rev(c(rev(RColorBrewer::brewer.pal(9, "PuBuGn")),
              RColorBrewer::brewer.pal(9, "YlOrRd")))

    }
  }

  DF <- reshape2::melt(GM, varnames = c("X", "Y"))

  if (smoothing == TRUE){
    smth <- stats::smooth.spline(DF$value)
    DF$value <- smth$y
  }


  p <- ggplot2::ggplot(DF, ggplot2::aes_string(x = "X", y = "Y")) +

    ggplot2::geom_tile(ggplot2::aes_string(fill = "value"), color = lineColor) +
    ggplot2::scale_fill_gradientn(
      colours = rev(colMatrix),
      limits = c(-maxVal, maxVal),
      oob = scales::squish
    )  +
    ggplot2::theme(
      axis.text.x = ggplot2::element_text(
        angle = 90,
        size = 6,
        hjust = 0.95,
        vjust = 0.2
      ),
      axis.text.y = ggplot2::element_text(size = labSize)
    ) +
    ggplot2::labs(
      subtitle = title,
      title = main,
      caption = mlzsParam(mLZ)$ranFUN
    )

  if (!is.null(highlight)) {
    if (highlight_max) {
      DF_label <- DF[DF$Y %in% highlight, , drop = FALSE]
      DF_label <- merge(stats::aggregate(value ~ Y, data = DF_label, FUN = max), DF_label)
      DF_label <- DF_label[order(DF_label$Y), , drop = FALSE]
      DF_label <- DF_label[!duplicated(DF_label$Y), , drop = FALSE]
    } else {
      DF_label <- DF[DF$Y %in% highlight & DF$X == 0, , drop = FALSE]
    }
    p <- p + ggrepel::geom_label_repel(data = DF_label, ggplot2::aes_string(label = "Y"), max.overlaps = Inf, size = highlight_size,
                              min.segment.length = 0, xlim = c(0.4 * max(DF$X), NA),
                              segment.curvature = -0.1,
                              segment.ncp = 3,
                              segment.angle = 20)
  }
  p <- p + ggplot2::geom_vline(xintercept = 0, linetype = "dotted", color = "black", alpha = 0.5)
  return(p)
}

test_that("Argument checks", {
  expect_error(plotLocalZScoreMatrix(), "missing")
  expect_error(plotLocalZScoreMatrix("a"), "multiLocalZScore")
  expect_error(plotLocalZScoreMatrix(mLZ_regA_ReG), "empty")
})

test_that("Returns the correct class without errors", {
  mLZ_regA_ReG <- makeLZMatrix(mLZ_regA_ReG)
  # Defaults
  expect_s3_class(plotLocalZScoreMatrix(mLZ_regA_ReG), "ggplot")
  # Matrix type
  expect_s3_class(plotLocalZScoreMatrix(mLZ_regA_ReG, matrix_type = "correlation"), "ggplot")
  # Maxval
  expect_s3_class(plotLocalZScoreMatrix(mLZ_regA_ReG, maxVal = 3), "ggplot")
  expect_s3_class(plotLocalZScoreMatrix(mLZ_regA_ReG, maxVal = -3), "ggplot")
  # Highlight
  expect_s3_class(plotLocalZScoreMatrix(mLZ_regA_ReG, highlight = c("regA_02", "regD")), "ggplot")
  expect_s3_class(plotLocalZScoreMatrix(mLZ_regA_ReG, highlight = c("regA_02", "regD"), highlight_max = TRUE), "ggplot")
})

#' getMultiEvaluation
#'
#' @description
#' Get `multiEvaluation` slot from [genoMatriXeR][genoMatriXeR-class] or [multiLocalZScore][multiLocalZScore-class] class.
#'
#' @usage getMultiEvaluation( rR, namesRS = NULL)
#' @param rR A genoMatriXeR or multiLocalZScore object.
#' @param namesRS a vector of names. (default = NA)
#'
#' @returns
#' If rR is a [genoMatriXeR][genoMatriXeR-class] object, a list of data frames resuming the associations results.
#' If rR is a [multiLocalZScore][multiLocalZScore-class] object, a list of two elements: "resumeTable" that is a data frame
#' summarizing the associations and "shifts", a list of shifts computed from [multiLocalZscore()] function for the elements
#' indicated in the nameRS vector.
#'
#' @seealso [genoMatriXeR][genoMatriXeR-class], [multiLocalZScore][multiLocalZScore-class]
#'
#' @examples
#'
#' data("cw_Alien")
#'
#' mevs <- getMultiEvaluation(cw_Alien_ReG, names = "regA")
#'
#' mevs
#'
#' @importFrom methods is
#' @importFrom methods hasArg
#'
#' @export getMultiEvaluation
#'

getMultiEvaluation <- function(rR,namesRS = NULL){

  stopifnot("rR is missing" = methods::hasArg(rR))
  stopifnot("rR must be an object of class genoMatriXeR or multiLocalZScore" = {
    methods::is(rR , "genoMatriXeR") | methods::is(rR , "multiLocalZScore")
  })

  if(methods::is(rR , "genoMatriXeR" )){

    if (!is.null(namesRS)) {
      if (!all(namesRS %in% names(gmxrMultiOverlaps(rR)))) {
        warning("One or more of namesRS is not a name of a region set in rR")
      }
    } else {
      namesRS <- names(gmxrMultiOverlaps(rR))
    }
    res <- gmxrMultiOverlaps(rR)[namesRS]
    res <- res[!vapply(res, is.null, TRUE)]
  }

  if(methods::is(rR , "multiLocalZScore" )){

    if (!is.null(namesRS)) {
      if (!all(namesRS %in% names(mlzsMultiLocalZscores(rR)$shifed_ZSs))) {
        warning("One or more of namesRS is not a name of a region set in rR")
      }
    } else {
      namesRS <- names(mlzsMultiLocalZscores(rR)$shifed_ZSs)
    }
    resTable<-mlzsMultiLocalZscores(rR)$resumeTab
    rownames(resTable)<- NULL
    resTable <- resTable[,-8, drop = FALSE]
    res <- list(resumeTable = resTable,
                shifts = mlzsMultiLocalZscores(rR)$shifed_ZSs[namesRS])
    res[["shifts"]] <- res[["shifts"]][!vapply(res[["shifts"]], is.null, TRUE)]
    }

  return(res)
}

test_that("getMultiEvaluation retrieves the correct data", {
  expect_snapshot(getMultiEvaluation(cw_Alien_ReG))
  expect_snapshot(getMultiEvaluation(cw_Alien_ReR))
  expect_snapshot(getMultiEvaluation(mLZ_regA_ReG))

  # With specific region set names
  expect_snapshot(getMultiEvaluation(cw_Alien_ReG, namesRS = c("regA", "regB")))
  expect_snapshot(getMultiEvaluation(mLZ_regA_ReG, namesRS = c("regAB", "regB")))
})

#' Make Local Z-Score Matrix
#'
#' @description
#'
#' Create a local z-score matrix from a [multiLocalZScore][multiLocalZScore-class]
#' object and save it in its `matrix` slot.
#'
#' @usage makeLZMatrix(mlZA, normalize = TRUE, clusterize = TRUE,
#'                 centralize = NA, hc.method = NULL, dist.method = "euclidean",
#'                 scale = FALSE, ...)
#'
#' @inheritParams makeCrosswiseMatrix
#'
#' @param mlZA an object of class [multiLocalZScore][multiLocalZScore-class] or a numerical matrix.
#' @param normalize logical, if TRUE the z-score values in the matrix will be normalized. (default = FALSE)
#' @param centralize numeric, only z-score values in a number of steps (defined by `centralize`) around the center of the local association will be used for clustering. If NA, all the values in the matrix will be used for clustering. (default = NA)
#' @param ...  further arguments to be passed to other methods.
#'
#' @return
#'
#' A object of class [multiLocalZScore][multiLocalZScore-class] containing three slots, with a populated `matrix` slot.
#'
#' \itemize{
#' \item \bold{\code{@parameters}}
#' \item \bold{\code{@multiLocalZscores}}
#' \item \bold{\code{@matrix}}
#'
#' }
#'
#'
#' @seealso  \code{\link{localZScore}}
#' @examples
#'
#' data("cw_Alien")
#'
#'
#'
#' @importFrom methods is
#' @export makeLZMatrix
#'
makeLZMatrix <- function(mlZA,
                          normalize = TRUE,
                          clusterize = TRUE,
                          centralize = NA,
                          hc.method = NULL,
                          dist.method = "euclidean",
                          scale = FALSE,
                          ...) {

  stopifnot("mlZA is missing" = methods::hasArg(mlZA))
  stopifnot("mlZA must be an object of class multiLocalZScore" = methods::is(mlZA,"multiLocalZScore"))

  if (normalize == TRUE) {

    mat <- do.call("rbind",lapply(seq_along(mlzsMultiLocalZscores(mlZA)$shifed_ZSs),
                                  FUN = function(i, mlZA){
                                    mlzsMultiLocalZscores(mlZA)$shifed_ZSs[[i]] / sqrt(mlzsMultiLocalZscores(mlZA)$max_zscores[i])},
                                  mlZA))

  }else{


    mat <- do.call("rbind",lapply(seq_along(mlzsMultiLocalZscores(mlZA)$shifed_ZSs),
                                  FUN = function(i, mlZA){
                                    mlzsMultiLocalZscores(mlZA)$shifed_ZSs[[i]]},
                                  mlZA))
  }

  rownames(mat) <- names(mlzsMultiLocalZscores(mlZA)$shifed_ZSs)
  colnames(mat) <- mlzsMultiLocalZscores(mlZA)$shifts


  if (clusterize == TRUE) {
    st <- 1
    en <- ncol(mat)
    if (!is.na(centralize)) {
      center <- round((ncol(mat) / 2)) + 1
      st <- (center - centralize)
      en <- (center + centralize)
    }
    fit <-
      chooseHclustMet(mat[, seq(st,en), drop = FALSE],
                      scale = scale,
                      vecMet = hc.method,
                      distHC = dist.method)
    ind <- fit$labels[fit$order]
    mat <- mat[ind, , drop = FALSE]

  }

  mat_corX <- cor(x = t(mat), method = "pearson")
  mat_corX[is.na(mat_corX)]<-0

  fit2 <-
    chooseHclustMet(mat_corX,
                    scale = scale,
                    vecMet = hc.method,
                    distHC = dist.method)
  ind <- fit2$labels[fit2$order]
  mat_corX <- mat_corX[ind, ind, drop = FALSE]

  matL <-
    list(
      LZM = mat,
      LZM_cor = mat_corX,
      FitRow = fit,
      FitCorr = fit2
    )

  mlzsMatrix(mlZA) <- matL

  return(mlZA)
}

#' multiLocalZscore
#'
#' @description
#'
#' Perform multiple permutation tests between a region set and each element in
#' a list of region sets using shifted positions to calculate a local z-score.
#'
#' @details
#'
#' This function performs multiple permutation tests between a single region set
#' and each element in a list of region sets. For every pairwise combination, the
#' evaluation step is repeated each time shifting the position of all the regions in the query region set
#' by a fixed step inside a defined window (using [regioneR::localZScore()].
#' This produces a "local z-score" profile that can be indicative of the nature
#' of the association between region sets. For example, an association can occur
#' "centrally" if the z-score value drops sharply when sifting the region set.
#' On the other hand, two region sets may have a peak of local z-score away from
#' the central position if they happen to occur often at a regular distance,
#' showing a "lateral" association.
#'
#' @usage multiLocalZscore(A, Blist = NULL, sampling = FALSE, fraction = 0.15,
#' min_sampling = 5000, ranFUN = "randomizeRegions", evFUN = "numOverlaps",
#' ntimes = 100, adj_pv_method = "BH", genome = "hg19", universe = NULL,
#' window = 1000, step = 100, ...)
#'
#' @inheritParams crosswisePermTest
#'
#' @param A query region set for which to estimate local z-score values.
#' @param Blist [GRangesList][GenomicRanges::GRangesList] or list of region sets in any accepted formats by [regioneR](https://bioconductor.org/packages/release/bioc/html/regioneR.html) package
#' ([GRanges][GenomicRanges::GRanges], [data.frame] etc.).
#' @param window numeric, window (number of base pairs) in which the local z-score will be calculated. (default = 1000)
#' @param step numeric, step (number of base pairs) by which will be estimated the local Z-score. (default = 100)
#' @param ...  further arguments to be passed to other methods.
#'
#' @return
#'
#' A object of class [multiLocalZScore][multiLocalZScore-class] containing three slots
#'
#' \itemize{
#' \item \bold{\code{@parameters}}
#' \item \bold{\code{@multiLocalZscores}}
#' \item \bold{\code{@matrix}}
#'
#' }
#'
#'
#' @seealso  [regioneR::localZScore()]
#'
#' @examples
#'
#' fakeGenome<- regioneR::toGRanges("chrF",1,1000)
#' regA <- regioneR::createRandomRegions(nregions = 10, length.mean = 10,
#' length.sd = 2,genome = fakeGenome)
#' regB <- regioneR::createRandomRegions(nregions = 10,length.mean = 10,
#' length.sd = 2,genome = fakeGenome)
#' regAs <-similarRegionSet(GR = regA,genome = fakeGenome, name = "A",
#' vectorPerc = seq(0.1,0.3,by =0.1))
#' regBs <-similarRegionSet(GR = regB,genome = fakeGenome, name = "B",
#' vectorPerc = seq(0.1,0.3,by =0.1))
#' ABList <- c(regAs,regBs)
#'
#' mlz_ptAB <- multiLocalZscore(A = regA, Blist = ABList,
#' genome = fakeGenome, ntimes = 10)
#' summary(mlz_ptAB)
#'
#'
#' @importFrom methods new
#' @importFrom methods show
#' @importFrom stats sd
#' @importFrom stats p.adjust
#'
#' @export multiLocalZscore



multiLocalZscore <- function(A,
                             Blist = NULL,
                             sampling = FALSE,
                             fraction = 0.15,
                             min_sampling = 5000,
                             ranFUN = "randomizeRegions",
                             evFUN = "numOverlaps",
                             ntimes = 100,
                             adj_pv_method = "BH",
                             genome = "hg19",
                             universe = NULL,
                             window = 1000,
                             step = 100,
                             ...) {

  stopifnot("Alist is missing" = methods::hasArg(A))
  stopifnot("fraction must be numeric" = is.numeric(fraction))
  stopifnot("sampling must be logical" = is.logical(sampling))
  stopifnot("min_sampling must be numeric" = is.numeric(min_sampling))
  stopifnot("ranFun must be charachter" = is.character(ranFUN))
  stopifnot("evFun must be charachter" = is.character(evFUN))

  paramList <- list(
    A = deparse(substitute(A)),
    Blist = deparse(substitute(Blist)),
    sampling = deparse(substitute(sampling)),
    fraction = deparse(substitute(fraction)),
    min_sampling = deparse(substitute(fraction)),
    ranFUN = ranFUN,
    evFUN = evFUN,
    universe = deparse(substitute(universe)),
    window = window,
    step = step,
    adj_pv_method = adj_pv_method
  )

  rFUN <- eval(parse(text = ranFUN))
  eFUN <- eval(parse(text = evFUN))

  A <- toGRanges(A)
  Blist <- as.list(Blist)

  if (sampling == TRUE) {
    if (length(A) >= min_sampling) {
      if (length(A) * fraction > min_sampling) {
        A <- A[sample(length(A), round(length(A) * fraction)), drop = FALSE]

      } else{
        A <- A[sample(length(A), min_sampling), drop = FALSE]
      }
    }
  }

  if (paramList$ranFUN == "resampleRegions" & is.null(universe)) {
    if (is.null(universe)) {
      methods::show(
        "resampleRegions function need that universe parameters in not NULL universe will created using all the regions present in Blist"
      )
      universe <- createUniverse(Blist)
    }
  }

  func.list <-
    regioneR::createFunctionsList(FUN = eFUN,
                        param.name = "B",
                        values = Blist)


  if(ranFUN == "resampleRegions"){

    pt <- regioneR::permTest(
      A = A,
      evaluate.function = func.list,
      randomize.function = rFUN,
      genome = genome ,
      ntimes = ntimes,
      universe = universe,
      ...
    )

  }else{

    pt <- regioneR::permTest(
      A = A,
      evaluate.function = func.list,
      randomize.function = rFUN,
      genome = genome,
      count.once = TRUE,
      ntimes = ntimes,

      ...
    )
  }

  lZs <-
    lapply(
      pt,
      regioneR::localZScore,
      ... ,
      A = A ,
      count.once = TRUE,
      window = window,
      step = step
    )
  names(lZs) <- names(pt)


  Nreg <- length(A)
  p_values <- do.call(c, pt)
  pval <- p_values[grep(".pval", names(p_values))]

  means_pemuted <-
    lapply(p_values[grep(".permuted", names(p_values))], mean)

  sd_pemuted <-
    lapply(p_values[grep(".permuted", names(p_values))], stats::sd)

  z_score <- p_values[grep(".zscore", names(p_values))]
  observed <- p_values[grep(".observed", names(p_values))]
  localZs <- do.call(c, lZs)
  shiftedZs <- localZs[grep("shifted.z.scores", names(localZs))]
  shifts <- localZs[grep(".shifts", names(localZs))][[1]]


  if (is.null(names(Blist))) {
    names(Blist) <- seq_along(Blist)
  }

  tab <- data.frame(
    name = names(Blist),
    p_value = unlist(pval),
    z_score = unlist(z_score),
    mean_perm_test = unlist(means_pemuted),
    sd_perm_test = unlist(sd_pemuted),
    n_overlaps = unlist(observed)
  )

  tab$norm_zscore <- tab$z_score / sqrt(Nreg)
  maxzscores <- (Nreg - tab$mean_perm_test) / tab$sd_perm_test
  tab$ranged_zscore <- tab$z_score / maxzscores
  tab$adj.p_value <-
  round(stats::p.adjust(tab$p_value, method = adj_pv_method), digits = 4)

  names(shiftedZs) <- names(Blist)

  paramList$Nregions <- Nreg

  rownames(tab) <- NULL

  mLZSobj <- mLZS(
    parameters = paramList ,
    multiLocalZscores = list(
      resumeTab = tab,
      max_zscores = maxzscores,
      shifts = shifts,
      shifed_ZSs = shiftedZs
    ),
    matrix = list(NULL)
  )


  return (mLZSobj)
}

test_that("multiLocalZscore: argument checks", {
  expect_error(multiLocalZscore(), "missing")
})

test_that("multiLocalZscore: different randomization strategies, returns the correct class without errors", {

  set.seed(42)

  expect_s4_class(multiLocalZscore(A = AlienRSList_narrow_small$regA,
                                   Blist = AlienRSList_narrow_small,
                                   ranFUN = "resampleRegions",
                                   evFUN = "numOverlaps",
                                   window = 100,
                                   step = 20,
                                   max_pv = 1,
                                   genome = AlienGenome), "multiLocalZScore")
  set.seed(42)

  expect_s4_class(multiLocalZscore(A = AlienRSList_narrow_small$regA,
                                   Blist = AlienRSList_narrow_small,
                                   ranFUN = "resampleGenome",
                                   evFUN = "numOverlaps",
                                   window = 100,
                                   step = 20,
                                   max_pv = 1,
                                   genome = AlienGenome), "multiLocalZScore")
  set.seed(42)

  expect_s4_class(multiLocalZscore(A = AlienRSList_narrow_small$regA,
                                   Blist = AlienRSList_narrow_small,
                                   ranFUN = "randomizeRegions",
                                   evFUN = "numOverlaps",
                                   window = 100,
                                   step = 20,
                                   max_pv = 1,
                                   genome = AlienGenome), "multiLocalZScore")
  set.seed(42)

  expect_s4_class(multiLocalZscore(A = AlienRSList_narrow_small$regA,
                                   Blist = AlienRSList_narrow_small,
                                   ranFUN = "circularRandomizeRegions",
                                   evFUN = "numOverlaps",
                                   window = 100,
                                   step = 20,
                                   max_pv = 1,
                                   genome = AlienGenome), "multiLocalZScore")
})

test_that("multiLocalZscore: different evaluation functions, returns the correct class without errors", {

  set.seed(42)

  expect_s4_class(multiLocalZscore(A = AlienRSList_narrow_small$regA,
                                   Blist = AlienRSList_narrow_small,
                                   ranFUN = "resampleRegions",
                                   evFUN = "numOverlaps",
                                   window = 100,
                                   step = 20,
                                   max_pv = 1,
                                   genome = AlienGenome), "multiLocalZScore")
  set.seed(42)

  expect_s4_class(multiLocalZscore(A = AlienRSList_narrow_small$regA,
                                   Blist = AlienRSList_narrow_small,
                                   ranFUN = "resampleRegions",
                                   evFUN = "meanDistance",
                                   window = 100,
                                   step = 20,
                                   max_pv = 1,
                                   genome = AlienGenome), "multiLocalZScore")
})

#' Sub List from region set list
#'
#' create a samples sublist starting from a list of Region Set
#'
#' @usage subList(Alist, min_sampling, fraction)
#' @return a sublist of GenomicRanges from an original GenomicRanges list
#'
#' @param Alist,  GRangesList or list of Region Set of any accepted formats by  [regioneR](https://bioconductor.org/packages/release/bioc/html/regioneR.html) package
#' @param min_sampling numeric, minimum number of regions for each element of the list,
#' if the number of regions is less than min_samplnig as subsempilng will be take the entire regionset
#' @param fraction numeric, percentage of regions selected for the subsampling
#'
#' @keywords internal

subList <- function(Alist,
                    min_sampling,
                    fraction) {

  subFUN<-function(A,min_sampling, fraction){

    if (min_sampling < length(A)) {
      subN <- round(length(A) * fraction)
      if (subN < min_sampling) {
        subN <- min_sampling
      }
      A <- A[sample(length(A), subN), drop = FALSE]
      subAlist <- A
    } else {
      subAlist <- A
    }
  }

  subAlist <- lapply(Alist, subFUN, min_sampling, fraction)




  return(subAlist)
}

#' Print method for genoMatriXeR class
#'
#' @param x A genoMatriXeR object.
#'
#' @return A printed output for genoMatriXeR objects.
#'
#' @seealso [genoMatriXeR][genoMatriXeR-class]
#'
#' @keywords internal

setMethod("print", "genoMatriXeR", function(x)
  list(
    param_slot = data.frame(
      param = names(x@parameters),
      value = unlist(x@parameters)[names(x@parameters)]
    ),
    Alist_Sample_slot = names(x@multiOverlaps),
    matrix_slot = x@matrix$GMat
  ))



#' Export parameters from genoMatriXeR objects
#'
#' @param x A genoMatriXeR object.
#'
#' @return Parameters slot of a genoMatriXeR object.
#'
#' @seealso [genoMatriXeR][genoMatriXeR-class]
#'
#' @keywords internal
#'

setGeneric("gmxrParam", function(x) standardGeneric("gmxrParam"))

setMethod("gmxrParam", "genoMatriXeR", function(x) x@parameters)



#' Export multiOverlaps slot from genoMatriXeR objects
#'
#' @param x A genoMatriXeR object.
#'
#' @return multiOverlaps slot of a genoMatriXeR.
#'
#' @seealso [genoMatriXeR][genoMatriXeR-class]
#'
#' @keywords internal

setGeneric("gmxrMultiOverlaps", function(x) standardGeneric("gmxrMultiOverlaps"))

setMethod("gmxrMultiOverlaps", "genoMatriXeR", function(x) x@multiOverlaps)


#' Export matrix slot from genoMatriXeR objects
#'
#' @param x A genoMatriXeR object.
#'
#' @return matrix slot of a genoMatriXeR object.
#'
#' @seealso [genoMatriXeR][genoMatriXeR-class]
#'
#' @keywords internal

setGeneric("gmxrMatrix", function(x) standardGeneric("gmxrMatrix"))

setMethod("gmxrMatrix", "genoMatriXeR", function(x) x@matrix)



#' Set matrix slot value of a genoMatriXeR object
#'
#' @param x A genoMatriXeR object.
#' @param value Value to assign to the matrix slot.
#'
#' @return A genoMatriXeR object.
#'
#' @importFrom methods validObject
#'
#' @keywords internal

setGeneric("gmxrMatrix<-", function(x, value) standardGeneric("gmxrMatrix<-"))

setMethod("gmxrMatrix<-", "genoMatriXeR", function(x, value){
  x@matrix <- value
  validObject(x)
  x
} )



#' Export parameters from multiLocalZScore objects
#'
#' @param x A multiLocalZScore object.
#'
#' @return parameters slot of a multiLocalZScore object.
#'
#' @seealso [multiLocalZScore][multiLocalZScore-class]
#'
#' @keywords internal

setGeneric("mlzsParam", function(x) standardGeneric("mlzsParam"))

setMethod("mlzsParam", "multiLocalZScore", function(x) x@parameters)



#' Set parameters slot value of a multiLocalZScore object
#'
#' @param x A multiLocalZScore object.
#' @param value Value to assign to the parameters slot.
#'
#' @return A multiLocalZScore object.
#'
#' @importFrom methods validObject
#'
#' @keywords internal

setGeneric("mlzsParam<-", function(x, value) standardGeneric("mlzsParam<-"))

setMethod("mlzsParam<-", "multiLocalZScore", function(x, value){
  x@parameters <- value
  validObject(x)
  x
} )



#' Export multiLocalZscores slot from multiLocalZScore objects
#'
#' @param x A multiLocalZScore object.
#'
#' @return multiLocalZscores slot of a multiLocalZScore object.
#'
#' @seealso [multiLocalZScore][multiLocalZScore-class]
#'
#' @keywords internal

setGeneric("mlzsMultiLocalZscores", function(x) standardGeneric("mlzsMultiLocalZscores"))

setMethod("mlzsMultiLocalZscores", "multiLocalZScore", function(x) x@multiLocalZscores)



#' Export matrix from multiLocalZScore objects
#'
#' @param x A multiLocalZScore object.
#'
#' @return A printed output for multiLocalZScore matrix slot.
#'
#' @seealso [multiLocalZScore][multiLocalZScore-class]
#'
#' @keywords internal

setGeneric("mlzsMatrix", function(x) standardGeneric("mlzsMatrix"))

setMethod("mlzsMatrix", "multiLocalZScore", function(x) x@matrix)



#' Set matrix slot value of a multiLocalZScore object.
#'
#' @param x A multiLocalZScore object.
#' @param value Value to assign to the multiLocalZScore slot.
#'
#' @return A multiLocalZScore object.
#'
#' @importFrom methods validObject
#'
#' @keywords internal

setGeneric("mlzsMatrix<-", function(x,value) standardGeneric("mlzsMatrix<-"))

setMethod("mlzsMatrix<-", "multiLocalZScore", function(x, value){
  x@matrix <- value
  validObject(x)
  x
} )

#' crosswiseMatrix
#'
#' @description
#'
#' Create a matrix from a genoMatriXeR object.
#'
#' @usage crosswiseMatrix(mPT, zs.type='norm_zscore',...)
#'
#' @inheritParams makeCrosswiseMatrix
#'
#' @return a numeric matrix
#'
#' @keywords internal

crosswiseMatrix <- function(mPT,
                            zs.type = "norm_zscore",
                            ...) {

  A.obj <- getMultiEvaluation(mPT)


  mat <- do.call("cbind",lapply(seq_along(A.obj),
                                FUN =  function(i,A.obj, zs.type){
                                  as.numeric(A.obj[[i]][, zs.type])
                                },
                                A.obj, zs.type))

  colnames(mat) <- names(A.obj)
  rownames(mat) <- A.obj[[1]][, 2]
  mat <- as.matrix(mat)

  return(mat)
}

---
title: "regioneReloaded"
author: "Roberto Malinverni"
output: BiocStyle::html_document   #rmarkdown::html_vignette
fig_width: 10
fig_height: 10 
vignette: >
  %\VignetteIndexEntry{regioneReloaded}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
 fig.width=6, 
 fig.height=6,
 fig.align = "center"
)
```

```{r style, echo = FALSE, results = 'asis'}
BiocStyle::markdown()
```



# Introduction

In genetic and epigenetic research, high-throughput sequencing methods generate large amounts of data. The meaningful interpretation is one of the biggest challenges when analyzing multiple genomic datasets.

Sequencing results can be summarized as ‘region sets’: a list of genomic regions defined by specific coordinates in a reference genome. This is true for all frequently used epigenomic methods such as chromatin immuprecipation (ChIP)-seq, CUT&RUN, DNA-methylation profiling and chromosome conformation capture-based methods. Genome-sequencing studies provide information on mutations, copy number variations and inversions that can be expressed as region sets. Transcriptomic data can be converted in region sets for instance by extracting the genomic position of differentially expressed genes or their regulatory elements. All regions can be further associated with metadata further characterizing them. Any annotated feature of interest in the genome itself, such as repetitive elements, conserved regions, or regulatory elements, can be chosen as regions set for further analysis.

To interpret the meaning of overlaps between regions sets, in 2015 we published `r BiocStyle::Biocpkg("regioneR")`, an R package developed for the statistical evaluation of the association between sets of genomic regions. The main limitation of regioneR was that it can only perform pairwise association analysis. The resulting association value ("z-score") of different pairwise analyses could not be directly compared since z-scores depend on the size and nature of the input region sets. When scaling up the number of pairwise comparisons of larger data sets, the required increase in calculation time becomes a serious limitation.

To address these issues, we now present `r BiocStyle::Rpackage("regioneReloaded")`: an R package that is the logically designed evolution of `r BiocStyle::Biocpkg("regioneR")` allowing to calculate the statistical association between multiple regions sets at the same time. `r BiocStyle::Rpackage("regionReloaded")` comprises a set of functions created to analyze clusters of associations and to facilitate the interpretation of results. Importantly, it includes strategies to improve p-value calculations and provides normalized z-scores allowing the direct comparison of multiple analysis. It also builds upon `r BiocStyle::Biocpkg("regioneR")` by adding new plotting functions for obtaining publication-ready graphs.

Taken together, `r BiocStyle::Rpackage("regioneReloaded")`, aims to be a novel and valuable addition to the repertoire of available tools in the Bioconductor repository for the analysis of high-content genomic datasets.

## regioneR and regioneReloaded

`r BiocStyle::Biocpkg("regioneR")` is an R package published in 2015 created to statistically test the positional association between genomic region sets. The core of `r BiocStyle::Biocpkg("regioneR")` is a permutation test framework specifically designed to work in a genomic environment. For a detailed insight into the permutation test strategy implemented in `r BiocStyle::Biocpkg("regioneR")`, including the different randomization and evaluation strategies, please see the [regioneR vignette](https://bioconductor.org/packages/release/bioc/vignettes/regioneR/inst/doc/regioneR.html). The two main results that can be obtained with this statistical method can be summarized in two graphs. Figure 1A shows the association observed between the two region sets under study, highlighting the distance calculated in standard deviations from the random distribution. Figure 1B shows the local z-score: a narrow peak, as the one shown, indicates that the association is highly dependent on the exact location of the region. One the contrary, a flat profile would suggest a regional association.

(figure 1)

![regioneR basic Graphs](figures/regioner_grphs.png){width=120%}

## Normalized Z-Score

`r BiocStyle::Rpackage("regioneReloaded")` aims to integrate the framework previously developed for `r BiocStyle::Biocpkg("regioneR")` to calculate associations of different region sets simultaneously. However, the values of z-score obtained in different tests can not be directly compared. In particular, the value of the z-score is directly associated to the square root of the number of regions present in the first region set of the test (RS1). 

To compare the z-scores obtained in multi pairwise tests between region sets, we introduce the concept of **normalized z-score**, which allows not only to directly compare different association events but also to work with subsets of data and speed up the calculations.

The normalized z-score is calculated as follows:

nZS = ZS / $\sqrt{n}$

We can empirically evaluate how the value of z-score between two well known strongly associated proteins, CTCF (ENCFF237OKO) and RAD21 (ENCFF072UEX) in HepG2 cell line from ENCODE portal, (Sloan et al. 2016, https://www.encodeproject.org/) , increases with the number of regions included in the test. On the other hand, the value of the normalized z-score is much more stable with different number of regions. Importantly, we see that the value of normalized z-score is stable approximately after including only 30% of the regions in the dataset. This demonstrates than sampling a portion of the dataset is a viable strategy to reduce calculation time without impacting the capacity to obtain meaningful normalized z-score values.

![Normal z-score empirical calculations](figures/normal_ZScore.png){width=90%}

Another crucial factor for the calculation of the normal z-score is the number of permutations performed in the test (`ntimes`). We suggest to use a minimum of 5000 permutations to achieve reproducible results.

![Ntimes demonstration](figures/ntimes_stabilizations.png){width=90%}

# Installation

```{r, eval=FALSE}

if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("regioneReloaded")

```


# Quick start

```{r setup}
library("regioneReloaded")
```

The permutation test can be performed on a list multiple region sets by the function `crosswisePermTest()`. This process is computing intensive and its calculation time depends on the  number of cores called by the parameter `mc.cores` (see `r BiocStyle::Biocpkg("regioneR")`). The result of the permutation test obtained by running the code below is included as a pre-computed example dataset which can be loaded into the environment by running the command `data("cw_Alien_RaR")`.

`AlienGenome` and `AlienRSList` are toy datasets described in the next section of the vignette. 

```{r load _data, eval=FALSE}
#NOT RUN
  
  set.seed(42)
  cw_Alien_ReG<-crosswisePermTest(Alist = AlienRSList_narrow,
                            sampling = FALSE,
                            mc.cores= 25,
                            ranFUN = "resampleGenome",
                            evFUN = "numOverlaps",
                            genome = AlienGenome,
                            ntimes= 1000
  )
#
```

Once the multiple permutation tests are performed, we can generate a matrix of pairwise associations between the region sets with the function `makeCrosswiseMatrix()` and visualize it with `plotCrosswiseMatrix()`.

```{r}

data("cw_Alien")

cw_Alien_ReG<-makeCrosswiseMatrix(cw_Alien_ReG, pvcut = 1)

plotCrosswiseMatrix(cw_Alien_ReG)

```

# Example dataset: the Alien Genome

Performing Permutation tests with region sets on an eukaryotic genome can take a long computation time. To demonstrate the different regionReloaded features on a small toy dataset with low computation times, we have created a fake genome called the 'AlienGenome' and an associated list of region sets. The Alien Genome consists of four chromosomes of  lengths ranging from 2Mb to 0.1Mb.

![Graphical descrition of the AlienGenome](figures/AlienGenome_scheme.png){width=100%}

```{r}

AlienGenome <-
  toGRanges(data.frame(
    chr = c("AlChr1", "AlChr2", "AlChr3", "AlChr4"),
    start = c(rep(1, 4)),
    end = c(2e6, 1e6, 5e5, 1e5)
  ))


```

Four basic region sets were created on this genome. The first three ("regA", "regB", "regC"), were created using the function `createRandomRegions()` from the package `r BiocStyle::Biocpkg("regioneR")`. Each region set consists of 100 regions with an average width of 100 bp (and a standard deviation of 50 bp). Being randomly generated, the three region sets should show no significant associations with each other.


```{r}
gnm <- AlienGenome

nreg=100

regA <-
  createRandomRegions(
    nregions = nreg,
    length.mean = 100,
    length.sd = 50,
    non.overlapping = TRUE,
    genome = gnm
  )

regB <-
  createRandomRegions(
    nregions = nreg,
    length.mean =  100,
    length.sd = 50 ,
    non.overlapping = TRUE,
    genome = gnm
  )

regC <-
  createRandomRegions(
    nregions = nreg,
    length.mean = 100,
    length.sd = 50,
    non.overlapping = TRUE,
    genome = gnm
  )

```

To generate "artificial" associations we can use the `similarRegionSet()` function, which produces sets of random regions with some degree of similarity to the original input region set. For each set of regions regA, regB and regC, we create a list of region sets that share a percentage (90% to 10%) of similarity with the original set.

```{r}

vectorPerc <- seq(0.1, 0.9, 0.1)

RsetA <-
  similarRegionSet(
    GR = regA,
    name = "regA",
    genome = gnm,
    vectorPerc = vectorPerc
  )
RsetB <-
  similarRegionSet(
    GR = regB,
    name = "regB",
    genome = gnm,
    vectorPerc = vectorPerc
  )
RsetC <-
  similarRegionSet(
    GR = regC,
    name = "regC",
    genome = gnm,
    vectorPerc = vectorPerc
  )

```

Next we create a region set of 100 regions that shares half the regions with regA and half with regB called regAB.  From this region set we create similar region sets again using `similarRegionSet()`.

```{r}

vectorPerc2 <- seq(0.2, 0.8, 0.2)
regAB <- c(sample(regA, nreg / 2), sample(regB, nreg / 2))
RsetAB <-
  similarRegionSet(
    GR = regAB,
    name = "regAB",
    genome = gnm,
    vectorPerc = vectorPerc2
  )

```

As a negative association control, we create random region sets that contain no regions of "regA", "regB", "regC", "regAB or "regABC" using `createRandomRegions()` and `substractRegions()` functions from  `r BiocStyle::Biocpkg("regioneR")`.

```{r}

reg_no_A <-
  createRandomRegions(
    nregions = nreg,
    length.mean = 100,
    length.sd = 50,
    non.overlapping = TRUE,
    genome = subtractRegions(gnm, regA)
  )

reg_no_B <-
  createRandomRegions(
    nregions = nreg,
    length.mean = 100,
    length.sd = 50,
    non.overlapping = TRUE,
    genome = subtractRegions(gnm, regB)
  )

reg_no_C <-
  createRandomRegions(
    nregions = nreg,
    length.mean = 100,
    length.sd = 50,
    non.overlapping = TRUE,
    genome = subtractRegions(gnm, regC)
  )

reg_no_AB <-
  createRandomRegions(
    nregions = nreg,
    length.mean = 100,
    length.sd = 50,
    non.overlapping = TRUE,
    genome = subtractRegions(gnm, c(regA, regB))
  )

reg_no_ABC <-
  createRandomRegions(
    nregions = nreg,
    length.mean = 100,
    length.sd = 50,
    non.overlapping = TRUE,
    genome = subtractRegions(gnm, c(regA, regB, regC))
  )

```

To demonstrate the detection of "lateral" association (association with a region close to the one being tested), we create the "regD" region set. It is composed of regions in the vicinity of region set "regA" but does not overlap with the regions of "regA" itself.

```{r}

dst <- sample(c(-300,300),length(regA),replace = TRUE)
regD <- regioneR::toGRanges(
                    data.frame(
                      chr=as.vector(GenomeInfoDb::seqnames(regA)),
                      start = start(regA) + dst,
                      end = end (regA) + dst
                      )
                    )

RsetD <-
  similarRegionSet(
    GR = regD,
    name = "regD",
    genome = gnm,
    vectorPerc = vectorPerc2
  )

```

Finally, we store all the generated sets of regions in a list called `AlienRSList` which we can use as input for the `crosswisePermTest()` function to perform the multiple permutation test.

```{r}

Rset_NO <- list(reg_no_A, reg_no_B, reg_no_C, reg_no_AB, reg_no_ABC)

names(Rset_NO) <- c("reg_no_A", "reg_no_B", "reg_no_C", "reg_no_AB", "reg_no_ABC")

AlienRSList_narrow <- c(RsetA, RsetB, RsetC, RsetD, RsetAB, Rset_NO)

summary(AlienRSList_narrow)

```

# Multi Permutation Test with regioneReloaded
## Crosswise Analysis and the genoMatriXeR object

`crosswisePermTest()` is the main statistical function of the package. "Crosswise" analysis (in contrast to "pairwise") refers to the calculation of permutation tests between all possible combinations of elements in a first list of region sets (`Alist`) with those in a second list (`Blist`). The core statistical calculations of the permutation tests rely on [permTest()](https://rdrr.io/bioc/regioneR/man/permTest.html). 

The result of `crosswisePermTest()` is stored in an S4 object of class `genoMatriXeR` that contains three slots: *parameters*, *multiOverlaps* and *matrix*.

* gMXR_obj
  + @parameters
    + Alist
    + Blist
    + sampling
    + fraction
    + min_sampling
    + ranFUN
    + evFUN
    + universe
    + adj_pv_method
    + max_pv
    + nc
    + matOrder
    + ntimes
  + @multiOverlaps
    + one field for each comparison
  + @matrix
    + GMat
    + GMat_pv
    + GMat_corX
    + GMat_corY
    + FitRow
    + FitCol


### Parameters

The slot "parameters" stores all the parameters that were used to obtain the `genoMatriXeR` object and can be retrieved with `getParameters()`.

```{r }

data("cw_Alien")
getParameters(cw_Alien_ReG)

```

### multiOverlaps

The "multiOverlaps" slot contains a list of data frames that contain the results of each permutation test performed. For each region set in "Alist", a data frame is generated with 11 columns and a number of rows equal to the elements in "Blist". The columns of the data frame contain the following information:

+ **order.id:**        order of comparison
+ **name:**            name of region sets in Blist  
+ **n_regionA:**       number of permuted Alist regions
+ **n_regionB:**       number of regions in each regions set of Blist 
+ **z_score:**         z-score calculated by [permTest](https://rdrr.io/bioc/regioneR/man/permTest.html)
+ **p_value:**         p.value calculated by [permTest](https://rdrr.io/bioc/regioneR/man/permTest.html)
+ **n_hits:**          number of hits computed using the evaluation function on a regions set of Alist versus each regions set of Blists
+ **mean_perm_test:**  mean of hits computed using the evaluation function on the permutated region set
+ **sd_perm_test:**    standard deviation of hits computed using the evaluation function on the permutated region set
+ **norm_zscore:**     normalized z-scores 
+ **adj_p_value:**     adjusted p.value 

### Matrix

When the genoMatriXeR object is initially created by running `crosswisePermTest()`, the "matrix" slot will have a NULL value. See the section [Matrix calculation and visualization] on how to generate, access and visualize the association matrix.

## Evaluation functions

`r BiocStyle::Rpackage("regioneReloaded")` can use all the evaluation strategies present in `r BiocStyle::Biocpkg("regioneR")`, and it also allows the use of custom evaluation functions. The examples considered by this vignette will be based on the default evaluation function `numOverlaps()`.

## Randomization functions

`r BiocStyle::Rpackage("regioneReloaded")` can use all the randomization strategies present in `r BiocStyle::Biocpkg("regioneR")` and  it also allows the use of custom functions.

A notable difference with regioneR is that the randomization function `resampleRegions()` can work without the presence of the parameter "universe". In this case a "universe" will be created by using all regions from the list of regions set "Alist" using the function `createUniverse()`. Three example pre-computed objects are included as sample data generated with three different randomization functions: "randomizeRegions", "resampleRegions" and "resampleGenome".


```{r, eval=FALSE}

#NOT RUN

set.seed(42)
cw_Alien_RaR <-  crosswisePermTest(
  Alist = AlienRSList_narrow,
  Blist = AlienRSList_narrow,
  sampling = FALSE,
  genome = AlienGenome,
  per.chromosome=TRUE,
  ranFUN = "randomizeRegions",
  evFUN = "numOverlaps",
  ntimes= 1000,
  mc.cores = 20
)


set.seed(42)
cw_Alien_ReR <-  crosswisePermTest(
  Alist = AlienRSList_narrow,
  Blist = AlienRSList_narrow,
  sampling = FALSE,
  genome = AlienGenome,
  per.chromosome=TRUE,
  ranFUN = "resampleRegions",
  evFUN = "numOverlaps",
  ntimes= 1000,
  mc.cores = 20
)

set.seed(42)
cw_Alien_ReG <-  crosswisePermTest(
  Alist = AlienRSList_narrow,
  Blist = AlienRSList_narrow,
  sampling = FALSE,
  genome = AlienGenome,
  per.chromosome=TRUE,
  ranFUN = "resampleGenome",
  evFUN = "numOverlaps",
  ntimes= 100,
  mc.cores = 20
)

#

```

## Matrix Calculation and visualization

Association matrix will be computed with the function `makeCrosswiseMatrix()`. This function returns a *genoMatriXeR* object with the matrix assigned to the "matrix" slot, the matrix will be able to be queried with the `getMatrix()` function. As a default value the matrix will be created using *normalized z-score* for a more in-depth description of the parameters that can be used to create the matrix we refer you to the `makeCrosswiseMatrix()` function manual. If no clustering method is chosen, automatically the most efficient clustering method will be chosen from those in [hclust](https://www.rdocumentation.org/packages/stats/versions/3.6.2/topics/hclust), as described in the `chooseHclustMet()` function manual.

```{r}

cw_Alien_RaR <- makeCrosswiseMatrix(cw_Alien_RaR)

cw_Alien_ReG <- makeCrosswiseMatrix(cw_Alien_ReG)

cw_Alien_ReR <- makeCrosswiseMatrix(cw_Alien_ReR)

```

To compare the output of the matrices created with different randomization functions, we need to use the fixed order of clusterization for all matrices. 

```{r}

modX <- getHClust(cw_Alien_ReG,hctype = "rows")
modY <- getHClust(cw_Alien_ReG,hctype = "cols")



X<-modX$labels[modX$order]
Y<-modY$labels[modX$order]

ord<-list(X=X,Y=Y)

p_ReG <- plotCrosswiseMatrix(cw_Alien_ReG, matrix_type = "association", ord_mat = ord)
p_ReR <- plotCrosswiseMatrix(cw_Alien_ReR, matrix_type = "association", ord_mat = ord)


plot(p_ReG)
plot(p_ReR)

```

`getHClust()` function returns an object of class [hclust](https://www.rdocumentation.org/packages/stats/versions/3.6.2/topics/hclust) that you can use for further analysis.

```{r}

plot(modX,cex = 0.8)

```

the *matrix_type* parameter `plotCrosswiseMatrix()` allows to choose between "association" matrix (where the z-score value obtained from the permutation test calculation will be shown), or "correlation" (where the Pearson's R-value between each Regions Set will be used).

```{r}

p_ReG_cor <- plotCrosswiseMatrix(cw_Alien_ReG, matrix_type = "correlation", ord_mat = ord)
# p_ReR_cor <- plotCrosswiseMatrix(cw_Alien_ReR, matrix_type = "correlation", ord_mat = ord)

plot(p_ReG_cor)
# plot(p_ReR_cor)

```



## Plot Single permutation test 

`r BiocStyle::Rpackage("regioneReloaded")` allows us to extract and visualize the results of a single Region Sets comparison, the visualization resumes the previous graphs in `r BiocStyle::Biocpkg("regioneR")` by exploiting the power of `r BiocStyle::Biocpkg("ggplot2")`.

```{r}
plotSinglePT(cw_Alien_ReG, RS1 = "regA", RS2 = "regA_05")
```

```{r}
  p_sPT1 <- plotSinglePT(cw_Alien_ReG, RS1 = "regA", RS2 = "regC")

plot(p_sPT1)
```

## Plot Dimensionality Reduction

Dimensionality reduction refers to a strategy capable of representing complex (high-density) data in a low-density space while retaining some meaningful properties of the original data. The plotCrosswiseDimRes function allows three of the most widely used algorithms (PCA, tRSNE, UMAP) to be applied to represent genoMatriXeR objects.


```{r}

set.seed(42)

plotCrosswiseDimRed(cw_Alien_ReG, nc = 6, type="PCA")

```

The data is clustered using a clustering algorithm that can be selected from (`hclust`, `kmeans` or `pam` ), giving the possibility of importing an external clustering method.

```{r}
set.seed(42)
p_cdr_hc <- plotCrosswiseDimRed(cw_Alien_ReG, nc = 6, type="PCA", clust_met = "hclust")

# set.seed(42)
# p_cdr_pam <- plotCrosswiseDimRed(cw_Alien_ReG, nc = 6, type="PCA", clust_met = "pam")

plot(p_cdr_hc) 
# plot(p_cdr_pam)
          
```

The parameters *listRS* and *emphasize* were added to emphasise the data found to be interesting.

```{r}

lsRegSet<-list(regA="regA",regB="regB",regC="regC")

set.seed(42)
plotCrosswiseDimRed(cw_Alien_ReG, nc = 6, type="PCA",listRS = lsRegSet)

set.seed(42)
plotCrosswiseDimRed(cw_Alien_ReG, nc = 6, type="PCA",listRS = lsRegSet,ellipse = TRUE, emphasize =TRUE)

set.seed(67)
plotCrosswiseDimRed(cw_Alien_ReG, nc = 6, type="tSNE",listRS = lsRegSet,ellipse = TRUE, emphasize =TRUE)

set.seed(67)
plotCrosswiseDimRed(cw_Alien_ReG, nc = 6, type="UMAP",listRS = lsRegSet,ellipse = TRUE, emphasize =TRUE)

```
The * return_table* parameter displays a table summarising the results of the clustering, incorporating the value *ASW* total mean of individual silhouette widths [silohuette](https://www.rdocumentation.org/packages/cluster/versions/2.1.3/topics/silhouette).

```{r}
set.seed(67)
silTable <- plotCrosswiseDimRed(cw_Alien_ReG, nc = 6, type="UMAP",listRS = lsRegSet,return_table = TRUE)

silTable
```

# Multi Local Zscore

The [multiLocalZscore] function allows the association of a single regions Set against a list of regions Sets to be analysed by applying the [localZScore](https://rdrr.io/bioc/regioneR/man/localZScore.html) function in a neighbourhood defined by the *window* parameter a number of times defined by the *step* parameter.

```{r, eval=FALSE }

#NOT RUN
mlz_Alien_ReG<-multiLocalZscore(A = AlienRSList_narrow$regA,
                 Blist = AlienRSList_narrow,
                 ranFUN = "resampleGenome",
                 evFUN = "numOverlaps",
                 window = 100,
                 step = 1,
                 max_pv = 1,
                 genome = AlienGenome)
```


As with the `crosswisePermTest()` function, an object consisting of three slots *paremeters* *multiLocalZscores* and *matrix* will be created. These can be queried by the functions `getParametrs()`, `getMultiEvaluation()` and `getMatrix()` respectively. Again, the object thus created will have the matrix slot = NULL.

```{r}
getParameters(mLZ_regA_ReG)

mlz_Me <- getMultiEvaluation(rR = mLZ_regA_ReG )

head(mlz_Me$resumeTable)
```

The matrix will be created by the function `makeLZMatrix()` in a similar manner as illustrated for the function `makeCrosswiseMatrix()`. Again, it is possible to pass a clustering method to the function, and if not, the best clustering function calculated using `chooseHclustMet()` will be chosen.

```{r}

mLZ_regA_ReG <- makeLZMatrix(mLZ_regA_ReG)

plot(getHClust(mLZ_regA_ReG),cex = 0.8)
```
The `plotLocalZScoreMatrix()` function allows the visualisation of an object of class *multilocalZScore*. This type of visualization will also allow the association to be tested in the area adjacent to the tested Region Set. 

```{r}
plotLocalZScoreMatrix(mLZ_regA_ReG, maxVal = "max")
```
## Single Local ZScore

Similarly to as seen above for the `plotSinglePT()` function, the `plotSingleLZ()` function allows us to specifically display single associations drawn from a *multiLocalZScore* object.
```{r}
plotSingleLZ(mLZ = mLZ_regA_ReG, RS =c("regA"), smoothing = TRUE)
```

It is also possible to simultaneously display multiple associations in the same graph by introducing a vector of region set names

```{r}
plotSingleLZ(mLZ = mLZ_regA_ReG,RS =c("regA","regA_02","regA_06","regA_08","regD"),smoothing = TRUE)
```


# Analyses of non-square matrices

`r BiocStyle::Rpackage("regioneReloaded")` allows the association of Regions Sets of any length to be calculated. *AlienRSList_broad* is a list of Region Set created from *AlienRSList_narrow*, in which the [extendRegions](https://rdrr.io/bioc/regioneR/man/extendRegions.html) function has increased the width to an average of 5kb, to complete *AlienRSList_broad* a set of random region sets was added (RegR).
```{r}
# average of the widths of AlienRSList_narrow
do.call("c",lapply(lapply(AlienRSList_narrow, width),mean))
# average of the widths of AlienRSList_broad
do.call("c",lapply(lapply(AlienRSList_broad, width),mean))
```

```{r eval=FALSE}

##NOT RUN
cw_Alien_RaR_no_Square <-  crosswisePermTest(
  Alist = AlienRSList_narrow,
  Blist = AlienRSList_broad,
  sampling = FALSE,
  genome = AlienGenome,
  per.chromosome=TRUE,
  ranFUN = "resampleGenome",
  evFUN = "numOverlaps",
  ntimes= 100,
  mc.cores = 6
)

###
```

the matrix calculated in this case is based on a double clustering of rows and columns

```{r}
cw_Alien_ReG_no_Square <- makeCrosswiseMatrix(cw_Alien_ReG_no_Square)

plotCrosswiseMatrix(cw_Alien_ReG_no_Square)
```

In this case, the `multiLocalZscore()` function works in exactly the same way as in the previous cases, but in order to see the form of the association, it is recommended to enlarge *window* parameter.

```{r, eval=FALSE}

#NOT RUN
mLZ_regA_ReG_br<-multiLocalZscore(A = 
                                    AlienRSList_narrow$regA, 
                                  Blist = AlienRSList_broad, 
                                  ranFUN = "resampleGenome",
                                  genome = AlienGenome,
                                  window = 5000,
                                  step =100)
##
```
```{r}
mLZ_regA_ReG_br<-makeLZMatrix(mLZ_regA_ReG_br)

plotLocalZScoreMatrix(mLZ_regA_ReG_br)
```


```{r}
plotSingleLZ(mLZ = mLZ_regA_ReG_br,RS =c("regA_br","regA_br_02","regA_br_06","regA_br_08","regD_br"), smoothing = TRUE)

```


# Session Info
```{r, sessionInfo}
sessionInfo()
```

# getParameters retrieves the correct data

    Code
      getParameters(cw_Alien_ReG)
    Output
             parameter              value
      1          Alist AlienRSList_narrow
      2          Blist AlienRSList_narrow
      3       sampling              FALSE
      4       fraction               0.15
      5   min_sampling               0.15
      6         ranFUN     resampleGenome
      7          evFUN        numOverlaps
      8         ntimes               1000
      9       universe               NULL
      10 adj_pv_method                 BH
      11            nc               NULL
      12      matOrder               NULL

---

    Code
      getParameters(mLZ_regA_ReG)
    Output
             parameter                   value
      1              A AlienRSList_narrow$regA
      2          Blist      AlienRSList_narrow
      3       sampling                   FALSE
      4       fraction                    0.15
      5   min_sampling                    0.15
      6         ranFUN          resampleGenome
      7          evFUN             numOverlaps
      8       universe                    NULL
      9         window                     600
      10          step                      10
      11 adj_pv_method                      BH
      12        max_pv                    0.05
      13      Nregions                     100

# crosswisePermTest: different randomization functions

    Code
      crosswisePermTest(Alist = AlienRSList_narrow_small, Blist = AlienRSList_narrow_small,
        sampling = FALSE, genome = AlienGenome, per.chromosome = TRUE, ranFUN = "resampleGenome",
        evFUN = "numOverlaps", ntimes = 10, mc.cores = 2)
    Output
      [1] "Performing permutation tests for regA (1 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      [1] "Performing permutation tests for regB (2 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      [1] "Performing permutation tests for regAB (3 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      An object of class "genoMatriXeR"
      Slot "parameters":
      $Alist
      [1] "AlienRSList_narrow_small"
      
      $Blist
      [1] "AlienRSList_narrow_small"
      
      $sampling
      [1] "FALSE"
      
      $fraction
      [1] "0.15"
      
      $min_sampling
      [1] "0.15"
      
      $ranFUN
      [1] "resampleGenome"
      
      $evFUN
      [1] "numOverlaps"
      
      $ntimes
      [1] 10
      
      $universe
      NULL
      
      $adj_pv_method
      [1] "BH"
      
      $nc
      NULL
      
      $matOrder
      NULL
      
      $errors
      NULL
      
      
      Slot "multiOverlaps":
      $regA
        order.id  name n_regionA n_regionB  z_score    p_value n_overlaps
      1        1  regA       100       100 142.1613 0.09090909        100
      2        2  regB       100       100   0.1355 0.72727273          1
      3        3 regAB       100       100  97.9865 0.09090909         51
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1            0.6    0.6992059    14.21613      0.1364
      2            0.9    0.7378648     0.01355      0.7273
      3            0.4    0.5163978     9.79865      0.1364
      
      $regB
        order.id  name n_regionA n_regionB  z_score    p_value n_overlaps
      1        1  regA       100       100   1.1619 0.45454545          1
      2        2  regB       100       100 140.7142 0.09090909        100
      3        3 regAB       100       100  59.7670 0.09090909         51
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1            0.4    0.5163978     0.11619      0.4545
      2            0.5    0.7071068    14.07142      0.1364
      3            0.6    0.8432740     5.97670      0.1364
      
      $regAB
        order.id  name n_regionA n_regionB z_score    p_value n_overlaps
      1        1  regA       100       100 74.5242 0.09090909         51
      2        2  regB       100       100 78.7407 0.09090909         51
      3        3 regAB       100       100 79.9656 0.09090909        102
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1            0.7    0.6749486     7.45242      0.0909
      2            1.2    0.6324555     7.87407      0.0909
      3            0.5    1.2692955     7.99656      0.0909
      
      
      Slot "matrix":
      [[1]]
      NULL
      
      

---

    Code
      crosswisePermTest(Alist = AlienRSList_narrow_small, Blist = AlienRSList_narrow_small,
        sampling = FALSE, genome = AlienGenome, ranFUN = "resampleRegions", evFUN = "numOverlaps",
        ntimes = 10, mc.cores = 2)
    Warning <simpleWarning>
      resampleRegions function need that 'universe' is not NULL, universe was created using all the regions present in Alist
    Output
      [1] "Performing permutation tests for regA (1 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      [1] "Performing permutation tests for regB (2 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      [1] "Performing permutation tests for regAB (3 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      An object of class "genoMatriXeR"
      Slot "parameters":
      $Alist
      [1] "AlienRSList_narrow_small"
      
      $Blist
      [1] "AlienRSList_narrow_small"
      
      $sampling
      [1] "FALSE"
      
      $fraction
      [1] "0.15"
      
      $min_sampling
      [1] "0.15"
      
      $ranFUN
      [1] "resampleRegions"
      
      $evFUN
      [1] "numOverlaps"
      
      $ntimes
      [1] 10
      
      $universe
      NULL
      
      $adj_pv_method
      [1] "BH"
      
      $nc
      NULL
      
      $matOrder
      NULL
      
      $errors
      NULL
      
      
      Slot "multiOverlaps":
      $regA
        order.id  name n_regionA n_regionB z_score    p_value n_overlaps
      1        1  regA       100       100 10.0159 0.09090909        100
      2        2  regB       100       100 -9.8730 0.09090909          1
      3        3 regAB       100       100 -0.2914 0.45454545         51
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1           48.7     5.121849     1.00159      0.1364
      2           51.6     5.125102    -0.98730      0.1364
      3           52.0     3.431877    -0.02914      0.4545
      
      $regB
        order.id  name n_regionA n_regionB  z_score    p_value n_overlaps
      1        1  regA       100       100 -13.5035 0.09090909          1
      2        2  regB       100       100  13.9173 0.09090909        100
      3        3 regAB       100       100  -0.1975 0.54545455         51
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1           50.9     3.695342    -1.35035      0.1364
      2           49.5     3.628590     1.39173      0.1364
      3           51.8     4.049691    -0.01975      0.5455
      
      $regAB
        order.id  name n_regionA n_regionB z_score    p_value n_overlaps
      1        1  regA       100       100  0.4248 0.45454545         51
      2        2  regB       100       100 -0.0992 0.45454545         51
      3        3 regAB       100       100 23.3125 0.09090909        102
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1           49.2     4.237400     0.04248      0.4545
      2           51.4     4.033196    -0.00992      0.4545
      3           51.4     2.170509     2.33125      0.2727
      
      
      Slot "matrix":
      [[1]]
      NULL
      
      

---

    Code
      crosswisePermTest(Alist = AlienRSList_narrow_small, Blist = AlienRSList_narrow_small,
        sampling = TRUE, genome = AlienGenome, ranFUN = "randomizeRegions", evFUN = "numOverlaps",
        ntimes = 10, mc.cores = 2)
    Output
      [1] "Performing permutation tests for regA (1 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      [1] "Performing permutation tests for regB (2 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      [1] "Performing permutation tests for regAB (3 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      An object of class "genoMatriXeR"
      Slot "parameters":
      $Alist
      [1] "AlienRSList_narrow_small"
      
      $Blist
      [1] "AlienRSList_narrow_small"
      
      $sampling
      [1] "TRUE"
      
      $fraction
      [1] "0.15"
      
      $min_sampling
      [1] "0.15"
      
      $ranFUN
      [1] "randomizeRegions"
      
      $evFUN
      [1] "numOverlaps"
      
      $ntimes
      [1] 10
      
      $universe
      NULL
      
      $adj_pv_method
      [1] "BH"
      
      $nc
      NULL
      
      $matOrder
      NULL
      
      $errors
      NULL
      
      
      Slot "multiOverlaps":
      $regA
        order.id  name n_regionA n_regionB  z_score    p_value n_overlaps
      1        1  regA       100       100 206.3986 0.09090909        100
      2        2  regB       100       100   1.8974 0.27272727          1
      3        3 regAB       100       100 104.9590 0.09090909         51
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1            0.3    0.4830459    20.63986      0.1364
      2            0.2    0.4216370     0.18974      0.2727
      3            0.3    0.4830459    10.49590      0.1364
      
      $regB
        order.id  name n_regionA n_regionB  z_score    p_value n_overlaps
      1        1  regA       100       100   0.4445 0.63636364          1
      2        2  regB       100       100 102.3847 0.09090909        100
      3        3 regAB       100       100  95.8170 0.09090909         51
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1            0.7    0.6749486     0.04445      0.6364
      2            0.5    0.9718253    10.23847      0.1364
      3            0.5    0.5270463     9.58170      0.1364
      
      $regAB
        order.id  name n_regionA n_regionB  z_score    p_value n_overlaps
      1        1  regA       100       100  53.0330 0.09090909         51
      2        2  regB       100       100  52.1690 0.09090909         51
      3        3 regAB       100       100 101.6664 0.09090909        102
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1            1.0    0.9428090     5.30330      0.0909
      2            0.6    0.9660918     5.21690      0.0909
      3            0.9    0.9944289    10.16664      0.0909
      
      
      Slot "matrix":
      [[1]]
      NULL
      
      

---

    Code
      crosswisePermTest(Alist = AlienRSList_narrow_small, Blist = AlienRSList_narrow_small,
        sampling = TRUE, genome = AlienGenome, ranFUN = "circularRandomizeRegions",
        evFUN = "numOverlaps", ntimes = 10, mc.cores = 2)
    Output
      [1] "Performing permutation tests for regA (1 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      [1] "Performing permutation tests for regB (2 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      [1] "Performing permutation tests for regAB (3 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      An object of class "genoMatriXeR"
      Slot "parameters":
      $Alist
      [1] "AlienRSList_narrow_small"
      
      $Blist
      [1] "AlienRSList_narrow_small"
      
      $sampling
      [1] "TRUE"
      
      $fraction
      [1] "0.15"
      
      $min_sampling
      [1] "0.15"
      
      $ranFUN
      [1] "circularRandomizeRegions"
      
      $evFUN
      [1] "numOverlaps"
      
      $ntimes
      [1] 10
      
      $universe
      NULL
      
      $adj_pv_method
      [1] "BH"
      
      $nc
      NULL
      
      $matOrder
      NULL
      
      $errors
      NULL
      
      
      Slot "multiOverlaps":
      $regA
        order.id  name n_regionA n_regionB z_score    p_value n_overlaps
      1        1  regA       100       100 68.9587 0.09090909        100
      2        2  regB       100       100  0.7071 0.45454545          1
      3        3 regAB       100       100 43.3013 0.09090909         51
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1            1.4    1.4298407     6.89587      0.1364
      2            0.5    0.7071068     0.07071      0.4545
      3            1.0    1.1547005     4.33013      0.1364
      
      $regB
        order.id  name n_regionA n_regionB  z_score    p_value n_overlaps
      1        1  regA       100       100   0.7071 0.45454545          1
      2        2  regB       100       100 104.6714 0.09090909        100
      3        3 regAB       100       100  72.3678 0.09090909         51
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1            0.5    0.7071068     0.07071      0.4545
      2            0.7    0.9486833    10.46714      0.1364
      3            0.4    0.6992059     7.23678      0.1364
      
      $regAB
        order.id  name n_regionA n_regionB  z_score    p_value n_overlaps
      1        1  regA       100       100  75.1168 0.09090909         51
      2        2  regB       100       100 120.4828 0.09090909         51
      3        3 regAB       100       100 145.3077 0.09090909        102
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1            0.3    0.6749486     7.51168      0.0909
      2            0.2    0.4216370    12.04828      0.0909
      3            0.4    0.6992059    14.53077      0.0909
      
      
      Slot "matrix":
      [[1]]
      NULL
      
      

# crosswisePermTest: different evaluation functions

    Code
      crosswisePermTest(Alist = AlienRSList_narrow_small, Blist = AlienRSList_narrow_small,
        sampling = FALSE, genome = AlienGenome, per.chromosome = TRUE, ranFUN = "circularRandomizeRegions",
        evFUN = "numOverlaps", ntimes = 10, mc.cores = 2)
    Output
      [1] "Performing permutation tests for regA (1 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      [1] "Performing permutation tests for regB (2 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      [1] "Performing permutation tests for regAB (3 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      An object of class "genoMatriXeR"
      Slot "parameters":
      $Alist
      [1] "AlienRSList_narrow_small"
      
      $Blist
      [1] "AlienRSList_narrow_small"
      
      $sampling
      [1] "FALSE"
      
      $fraction
      [1] "0.15"
      
      $min_sampling
      [1] "0.15"
      
      $ranFUN
      [1] "circularRandomizeRegions"
      
      $evFUN
      [1] "numOverlaps"
      
      $ntimes
      [1] 10
      
      $universe
      NULL
      
      $adj_pv_method
      [1] "BH"
      
      $nc
      NULL
      
      $matOrder
      NULL
      
      $errors
      NULL
      
      
      Slot "multiOverlaps":
      $regA
        order.id  name n_regionA n_regionB  z_score    p_value n_overlaps
      1        1  regA       100       100 147.1223 0.09090909        100
      2        2  regB       100       100   0.4445 0.63636364          1
      3        3 regAB       100       100  72.0818 0.09090909         51
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1            0.7    0.6749486    14.71223      0.1364
      2            0.7    0.6749486     0.04445      0.6364
      3            0.6    0.6992059     7.20818      0.1364
      
      $regB
        order.id  name n_regionA n_regionB z_score    p_value n_overlaps
      1        1  regA       100       100  0.7071 0.45454545          1
      2        2  regB       100       100 90.0496 0.09090909        100
      3        3 regAB       100       100 47.4820 0.09090909         51
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1            0.5    0.7071068     0.07071      0.4545
      2            0.9    1.1005049     9.00496      0.1364
      3            0.7    1.0593499     4.74820      0.1364
      
      $regAB
        order.id  name n_regionA n_regionB  z_score    p_value n_overlaps
      1        1  regA       100       100  46.8851 0.09090909         51
      2        2  regB       100       100  63.6401 0.09090909         51
      3        3 regAB       100       100 106.7796 0.09090909        102
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1            0.6    1.0749677     4.68851      0.0909
      2            0.8    0.7888106     6.36401      0.0909
      3            0.7    0.9486833    10.67796      0.0909
      
      
      Slot "matrix":
      [[1]]
      NULL
      
      

---

    Code
      crosswisePermTest(Alist = AlienRSList_narrow_small, Blist = AlienRSList_narrow_small,
        sampling = FALSE, genome = AlienGenome, ranFUN = "circularRandomizeRegions",
        evFUN = "meanDistance", ntimes = 10, mc.cores = 2)
    Output
      [1] "Performing permutation tests for regA (1 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      [1] "Performing permutation tests for regB (2 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      [1] "Performing permutation tests for regAB (3 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      An object of class "genoMatriXeR"
      Slot "parameters":
      $Alist
      [1] "AlienRSList_narrow_small"
      
      $Blist
      [1] "AlienRSList_narrow_small"
      
      $sampling
      [1] "FALSE"
      
      $fraction
      [1] "0.15"
      
      $min_sampling
      [1] "0.15"
      
      $ranFUN
      [1] "circularRandomizeRegions"
      
      $evFUN
      [1] "meanDistance"
      
      $ntimes
      [1] 10
      
      $universe
      NULL
      
      $adj_pv_method
      [1] "BH"
      
      $nc
      NULL
      
      $matOrder
      NULL
      
      $errors
      NULL
      
      
      Slot "multiOverlaps":
      $regA
        order.id  name n_regionA n_regionB  z_score    p_value n_overlaps
      1        1  regA       100       100 -12.3581 0.09090909       0.00
      2        2  regB       100       100  -1.4163 0.18181818   17277.30
      3        3 regAB       100       100  -6.7400 0.09090909    8437.48
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1       16444.66     1330.675    -1.23581      0.1364
      2       21025.48     2646.449    -0.14163      0.1818
      3       16145.46     1143.609    -0.67400      0.1364
      
      $regB
        order.id  name n_regionA n_regionB  z_score    p_value n_overlaps
      1        1  regA       100       100  -0.4496 0.45454545   17674.54
      2        2  regB       100       100 -15.3156 0.09090909       0.00
      3        3 regAB       100       100  -6.7996 0.09090909    9355.01
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1       18243.88     1266.461    -0.04496      0.4545
      2       19879.67     1298.001    -1.53156      0.1364
      3       18539.53     1350.739    -0.67996      0.1364
      
      $regAB
        order.id  name n_regionA n_regionB z_score    p_value n_overlaps
      1        1  regA       100       100 -3.9950 0.09090909    8452.50
      2        2  regB       100       100 -3.6587 0.09090909    9403.62
      3        3 regAB       100       100 -5.0762 0.09090909       0.00
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1       17157.04     2178.879    -0.39950      0.0909
      2       19213.99     2681.367    -0.36587      0.0909
      3       17259.11     3400.036    -0.50762      0.0909
      
      
      Slot "matrix":
      [[1]]
      NULL
      
      

# crosswisePermTest: resampling and fraction

    Code
      crosswisePermTest(Alist = AlienRSList_narrow_small, Blist = AlienRSList_narrow_small,
        sampling = TRUE, fraction = 0.25, genome = AlienGenome, per.chromosome = TRUE,
        ranFUN = "resampleGenome", evFUN = "numOverlaps", ntimes = 10, mc.cores = 2)
    Output
      [1] "Performing permutation tests for regA (1 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      [1] "Performing permutation tests for regB (2 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      [1] "Performing permutation tests for regAB (3 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      An object of class "genoMatriXeR"
      Slot "parameters":
      $Alist
      [1] "AlienRSList_narrow_small"
      
      $Blist
      [1] "AlienRSList_narrow_small"
      
      $sampling
      [1] "TRUE"
      
      $fraction
      [1] "0.25"
      
      $min_sampling
      [1] "0.25"
      
      $ranFUN
      [1] "resampleGenome"
      
      $evFUN
      [1] "numOverlaps"
      
      $ntimes
      [1] 10
      
      $universe
      NULL
      
      $adj_pv_method
      [1] "BH"
      
      $nc
      NULL
      
      $matOrder
      NULL
      
      $errors
      NULL
      
      
      Slot "multiOverlaps":
      $regA
        order.id  name n_regionA n_regionB  z_score    p_value n_overlaps
      1        1  regA       100       100 142.1613 0.09090909        100
      2        2  regB       100       100   0.1355 0.72727273          1
      3        3 regAB       100       100  97.9865 0.09090909         51
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1            0.6    0.6992059    14.21613      0.1364
      2            0.9    0.7378648     0.01355      0.7273
      3            0.4    0.5163978     9.79865      0.1364
      
      $regB
        order.id  name n_regionA n_regionB  z_score    p_value n_overlaps
      1        1  regA       100       100   1.1619 0.45454545          1
      2        2  regB       100       100 140.7142 0.09090909        100
      3        3 regAB       100       100  59.7670 0.09090909         51
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1            0.4    0.5163978     0.11619      0.4545
      2            0.5    0.7071068    14.07142      0.1364
      3            0.6    0.8432740     5.97670      0.1364
      
      $regAB
        order.id  name n_regionA n_regionB z_score    p_value n_overlaps
      1        1  regA       100       100 74.5242 0.09090909         51
      2        2  regB       100       100 78.7407 0.09090909         51
      3        3 regAB       100       100 79.9656 0.09090909        102
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1            0.7    0.6749486     7.45242      0.0909
      2            1.2    0.6324555     7.87407      0.0909
      3            0.5    1.2692955     7.99656      0.0909
      
      
      Slot "matrix":
      [[1]]
      NULL
      
      

---

    Code
      crosswisePermTest(Alist = AlienRSList_narrow_small, Blist = AlienRSList_narrow_small,
        sampling = TRUE, fraction = 0.5, genome = AlienGenome, per.chromosome = TRUE,
        ranFUN = "resampleGenome", evFUN = "numOverlaps", ntimes = 10, mc.cores = 2)
    Output
      [1] "Performing permutation tests for regA (1 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      [1] "Performing permutation tests for regB (2 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      [1] "Performing permutation tests for regAB (3 of 3)"
      [1] "Note: The minimum p-value with only 10 permutations is 0.0909090909090909. You should consider increasing the number of permutations."
      An object of class "genoMatriXeR"
      Slot "parameters":
      $Alist
      [1] "AlienRSList_narrow_small"
      
      $Blist
      [1] "AlienRSList_narrow_small"
      
      $sampling
      [1] "TRUE"
      
      $fraction
      [1] "0.5"
      
      $min_sampling
      [1] "0.5"
      
      $ranFUN
      [1] "resampleGenome"
      
      $evFUN
      [1] "numOverlaps"
      
      $ntimes
      [1] 10
      
      $universe
      NULL
      
      $adj_pv_method
      [1] "BH"
      
      $nc
      NULL
      
      $matOrder
      NULL
      
      $errors
      NULL
      
      
      Slot "multiOverlaps":
      $regA
        order.id  name n_regionA n_regionB  z_score    p_value n_overlaps
      1        1  regA       100       100 192.8746 0.09090909        100
      2        2  regB       100       100   0.3644 0.54545455          1
      3        3 regAB       100       100  74.5242 0.09090909         51
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1            0.4    0.5163978    19.28746      0.1364
      2            0.7    0.8232726     0.03644      0.5455
      3            0.7    0.6749486     7.45242      0.1364
      
      $regB
        order.id  name n_regionA n_regionB  z_score    p_value n_overlaps
      1        1  regA       100       100   0.1006 0.63636364          1
      2        2  regB       100       100 192.4873 0.09090909        100
      3        3 regAB       100       100  74.5242 0.09090909         51
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1            0.9    0.9944289     0.01006      0.6364
      2            0.6    0.5163978    19.24873      0.1364
      3            0.7    0.6749486     7.45242      0.1364
      
      $regAB
        order.id  name n_regionA n_regionB  z_score    p_value n_overlaps
      1        1  regA       100       100  53.0330 0.09090909         51
      2        2  regB       100       100  72.0818 0.09090909         51
      3        3 regAB       100       100 137.0170 0.09090909        102
        mean_perm_test sd_perm_test norm_zscore adj.p_value
      1            1.0    0.9428090     5.30330      0.0909
      2            0.6    0.6992059     7.20818      0.0909
      3            0.9    0.7378648    13.70170      0.0909
      
      
      Slot "matrix":
      [[1]]
      NULL
      
      

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotCrosswiseMatrix.R
\name{plotCrosswiseMatrix}
\alias{plotCrosswiseMatrix}
\title{plotCrosswiseMatrix}
\usage{
plotCrosswiseMatrix(mPT, lineColor = NA, interpolate = FALSE, colMatrix =
"default", matrix_type = "association", cor = "row",
maxVal = NA, main = "", ord_mat = NULL)
}
\arguments{
\item{mPT}{an object of class \link[=genoMatriXeR-class]{genoMatriXeR} or a numerical matrix.}

\item{lineColor}{logical, color for the line grid delineating the tiles of the matrix plot. If NA, no line will be drawn. (default = NA)}

\item{interpolate}{logical, if TRUE the image will be interpolated using the function \code{\link[=geom_raster]{geom_raster()}}. (default = FALSE)}

\item{colMatrix}{character or vector of colors, if "default" will be used a default selection see..}

\item{matrix_type}{character, type of matrix to be plotted, either "association" or "correlation". (default = "association")}

\item{cor}{character, if \code{matrix_type} is "correlation", choose if the function \code{\link[=cor]{cor()}} will be executed on each "row" or "col" of the matrix. (default = "row")}

\item{maxVal}{numeric, maximum absolute value displayed by the plot. If "max", the maximum values in the matrix are used. If NA, the 0.95 quantile of all absolute values is used. (default = NA)}

\item{main}{character, title of the plot. (default = "")}

\item{ord_mat}{numeric, list with two numeric vectors that represent the ordering of rows and column of the matrix to be used in the plot.
If NULL, the order of the matrix is preserved as is. (default = NULL)}
}
\value{
Returns a ggplot object.
}
\description{
Plot matrix of associations/correlations stored in a \link[=genoMatriXeR-class]{genoMatriXeR} object.
}
\details{
This functions creates a graphical representation of the matrix of associations
stored in a \link[=genoMatriXeR-class]{genoMatriXeR} object. The values plotted and
clustering options can be controlled when creating the matrix with the function
\link{makeCrosswiseMatrix}.
}
\examples{

data("cw_Alien")

cw_Alien_ReG <- makeCrosswiseMatrix( cw_Alien_ReG)

plotCrosswiseMatrix(cw_Alien_ReG, matrix_type = "association")

plotCrosswiseMatrix(cw_Alien_ReG, matrix_type = "correlation")


}
\seealso{
\link{crosswisePermTest} \link{makeCrosswiseMatrix}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getMatrix.R
\name{getMatrix}
\alias{getMatrix}
\title{Get Matrix}
\usage{
getMatrix(rR)
}
\arguments{
\item{rR}{genoMatriXeR or multiLocalZScore object}
}
\value{
a numerical matrix from a
}
\description{
Returns the matrix from an \link[=genoMatriXeR-class]{genoMatriXeR} or \link[=multiLocalZScore-class]{multiLocalZScore} object.
}
\examples{

data("cw_Alien")

cw_Alien_ReG <- makeCrosswiseMatrix(cw_Alien_ReG)
mtx <- getMatrix(cw_Alien_ReG)

mtx


data("cw_Alien")

cw_Alien_RaR <- makeCrosswiseMatrix(cw_Alien_RaR)
GM <- getMatrix(cw_Alien_RaR)

GM

}
\seealso{
\link[=genoMatriXeR-class]{genoMatriXeR}, \link[=multiLocalZScore-class]{multiLocalZScore}, \link{makeCrosswiseMatrix}, \link{makeLZMatrix}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/crosswisePermTest.R
\name{crosswisePermTest}
\alias{crosswisePermTest}
\title{crosswisePermTest}
\usage{
crosswisePermTest(Alist, Blist = NULL, sampling = FALSE, fraction = 0.15,
 min_sampling = 5000, ranFUN = "randomizeRegions", evFUN = "numOverlaps",
 ntimes = 100, universe = NULL, adj_pv_method = "BH",
 genome = "hg19", ...)
}
\arguments{
\item{Alist, Blist}{\link[GenomicRanges:GRangesList-class]{GRangesList} or list of region sets in any accepted formats by \href{https://bioconductor.org/packages/release/bioc/html/regioneR.html}{regioneR} package
(\link[GenomicRanges:GRanges-class]{GRanges}, \link{data.frame} etc.).}

\item{sampling}{logical, if TRUE the function will use only a sample of each element of Alist to perform the test as specified in \code{fraction.} (default = FALSE)}

\item{fraction}{logical, if \code{sampling=TRUE}, defines the fraction of the region sets used to perform the test. (default = 0.15)}

\item{min_sampling}{numeric, minimum number of regions accepted after sampling is performed with the specified \code{fraction}. If the number of sampled
regions is less than \code{min_sampling}, the number specified by \code{min_sampling} will be used as number of regions sampled instead. (default = 5000)}

\item{ranFUN}{character, the randomization strategy used for the test, see \href{https://bioconductor.org/packages/release/bioc/html/regioneR.html}{regioneR}. (default = "randomizeRegions")}

\item{evFUN}{character, the evaluation strategy used for the test, see  \href{https://bioconductor.org/packages/release/bioc/html/regioneR.html}{regioneR}. (default = "numOverlaps)}

\item{ntimes}{numeric, number of permutations used in the test. (default = 100)}

\item{universe}{region set to use as universe, used only when \code{\link[regioneR:resampleRegions]{regioneR::resampleRegions()}} function is selected. (default = NULL)}

\item{adj_pv_method}{character, the method used for the calculation of the adjusted p-value, to choose between the options of \code{\link[=p.adjust]{p.adjust()}}. (default = "BH")}

\item{genome}{character or \link[GenomicRanges:GRanges-class]{GRanges}, genome used to compute the randomization. (default = "hg19")}

\item{...}{further arguments to be passed to other methods.}
}
\value{
A object of class \link[=genoMatriXeR-class]{genoMatriXeR} containing three slots

\itemize{
\item \bold{\code{@parameters}}
\item \bold{\code{@multioverlaps}}
\item \bold{\code{@matrix}}

}
}
\description{
Perform multiple permutation tests between each element in two lists of region sets.
}
\details{
This function performs multiple permutation tests for all pairwise combinations
of the elements in two lists of region sets. Essentially, it uses the \code{\link[regioneR:permTest]{regioneR::permTest()}}
function and its associated randomization and evaluation functions. It creates and returns a
\linkS4class{genoMatriXeR} object with the result of the permutation tests stored in the \code{multiOverlaps} slot.
In addition, all the parameters used for the test are stored in the \code{parameters} slot.
}
\examples{

fakeGenome <- regioneR::toGRanges("chrF", 1, 1000)
regA <- regioneR::createRandomRegions(nregions = 10, length.mean = 10,
length.sd = 2, genome = fakeGenome)
regB <- regioneR::createRandomRegions(nregions = 10, length.mean = 10,
length.sd = 2, genome = fakeGenome)
regAs <- similarRegionSet(GR = regA, genome = fakeGenome, name = "A",
vectorPerc = seq(0.1, 0.3, by = 0.1))
regBs <- similarRegionSet(GR = regB, genome = fakeGenome, name = "B",
vectorPerc = seq(0.1, 0.3, by = 0.1))
ABList <- c(regAs, regBs)
cw_ptAB <- crosswisePermTest(ABList, genome = fakeGenome, ntimes = 10)
print(cw_ptAB)

}
\seealso{
\link[=genoMatriXeR-class]{genoMatriXeR}, \href{https://bioconductor.org/packages/release/bioc/html/regioneR.html}{\code{regioneR}}, \code{\link[regioneR:permTest]{regioneR::permTest()}}, \code{\link[regioneR:overlapPermTest]{regioneR::overlapPermTest()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/randomizeRegionsPerc.R
\name{randomizeRegionsPerc}
\alias{randomizeRegionsPerc}
\title{randomizeRegionsPerc}
\usage{
randomizeRegionsPerc(GR, genome = "hg19", frac = 0.2, ...)
}
\arguments{
\item{GR}{a \link[GenomicRanges:GRanges-class]{GRanges} object with the input region set.}

\item{genome}{genome of reference to generate the similar region sets. (default = "hg19)}

\item{frac}{fraction of the original region set to randomize. (default = 0.2)}

\item{...}{further arguments to be passed to other methods.}
}
\value{
a \link[GenomicRanges:GRanges-class]{GRanges} object
}
\description{
Create a random region set similar to a reference region set.
}
\details{
This function takes an input region set and generates a region set where a
fraction of the regions has been randomized.
}
\examples{

data("cw_Alien")

nreg <- 100

regA <-
  createRandomRegions(
  nregions = nreg,
  length.mean = 100,
  length.sd = 10,
  non.overlapping = TRUE,
  genome = AlienGenome
 )

regA_02 <- randomizeRegionsPerc(GR = regA, genome = AlienGenome, frac = 0.2)

}
\seealso{
\code{\link[=similarRegionSet]{similarRegionSet()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/makeLZMatrix.R
\name{makeLZMatrix}
\alias{makeLZMatrix}
\title{Make Local Z-Score Matrix}
\usage{
makeLZMatrix(mlZA, normalize = TRUE, clusterize = TRUE,
                centralize = NA, hc.method = NULL, dist.method = "euclidean",
                scale = FALSE, ...)
}
\arguments{
\item{mlZA}{an object of class \link[=multiLocalZScore-class]{multiLocalZScore} or a numerical matrix.}

\item{normalize}{logical, if TRUE the z-score values in the matrix will be normalized. (default = FALSE)}

\item{clusterize}{logical, if TRUE the matrix will be clustered using the method specified by \code{hc.method} (default = TRUE)}

\item{centralize}{numeric, only z-score values in a number of steps (defined by \code{centralize}) around the center of the local association will be used for clustering. If NA, all the values in the matrix will be used for clustering. (default = NA)}

\item{hc.method}{character, select the \code{\link[=hclust]{hclust()}} method to use for clustering the matrix. If NULL, the clustering method will be automatically selected by the function \code{\link[=chooseHclustMet]{chooseHclustMet()}}. (default = NULL)}

\item{dist.method}{character, the distance measure to be used from those available in \code{\link[=dist]{dist()}} . (default = "euclidean")}

\item{scale}{logical, if TRUE the matrix will be scaled. (default = FALSE)}

\item{...}{further arguments to be passed to other methods.}
}
\value{
A object of class \link[=multiLocalZScore-class]{multiLocalZScore} containing three slots, with a populated \code{matrix} slot.

\itemize{
\item \bold{\code{@parameters}}
\item \bold{\code{@multiLocalZscores}}
\item \bold{\code{@matrix}}

}
}
\description{
Create a local z-score matrix from a \link[=multiLocalZScore-class]{multiLocalZScore}
object and save it in its \code{matrix} slot.
}
\examples{

data("cw_Alien")



}
\seealso{
\code{\link{localZScore}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regioneReloaded_methods.R
\name{mlzsMatrix<-}
\alias{mlzsMatrix<-}
\title{Set matrix slot value of a multiLocalZScore object.}
\usage{
mlzsMatrix(x) <- value
}
\arguments{
\item{x}{A multiLocalZScore object.}

\item{value}{Value to assign to the multiLocalZScore slot.}
}
\value{
A multiLocalZScore object.
}
\description{
Set matrix slot value of a multiLocalZScore object.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getParameters.R
\name{getParameters}
\alias{getParameters}
\title{getParameters}
\usage{
getParameters(rR, show_err = FALSE)
}
\arguments{
\item{rR}{A genoMatriXeR or multiLocalZScore class object.}

\item{show_err}{logical, if TRUE the function returns a list with two dataframes:
one containing the parameter values and one with any error messages that have been
generated during the permutation test iterations when running \link{crosswisePermTest}.}
}
\value{
A dataframe with parameters and values, or a list with two dataframes
with parameters and errors information.
}
\description{
Get parameters from a genoMatriXeR or multiLocalZScore class object.
}
\examples{

data("cw_Alien")

prm <- getParameters(cw_Alien_ReG)

prm


}
\seealso{
\link[=genoMatriXeR-class]{genoMatriXeR}, \link[=multiLocalZScore-class]{multiLocalZScore}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DFformLZ.R
\name{DFfromLZ}
\alias{DFfromLZ}
\title{Dataframe from MultiLocalZScore object}
\usage{
DFfromLZ( mLZ, RS )
}
\arguments{
\item{mLZ}{object class MultilocalZScore}

\item{RS}{string name of single region set present in the mLZ object}
}
\value{
a data.frame from \linkS4class{multiLocalZScore}
}
\description{
Dataframe from MultiLocalZScore object
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cleanCrosswiseMatrix.R
\name{cleanCrosswiseMatrix}
\alias{cleanCrosswiseMatrix}
\title{cleanCrosswiseMatrix}
\usage{
cleanCrosswiseMatrix(GM, GM_pv, pvcut, scale, subEX)
}
\arguments{
\item{GM}{matrix,  numerical matrix of z-scores.}

\item{GM_pv}{matrix, numerical matrix of pvalues.}

\item{pvcut}{numeric, the z-score value is substituted by \code{subEX} (0 by default) for all the associations with an adj.pvalue (as calculated in \code{\link[=crosswisePermTest]{crosswisePermTest()}}) higher than \code{pvcut}. (default = 0.05)}

\item{scale}{logical, if TRUE the matrix will be scaled. (default = FALSE)}

\item{subEX}{numeric, value used to substitute the z-score values when the associated pvalue is higher than \code{pvcut}. (default = 0)}
}
\value{
a matrix filtered for a matrix of pvalue
}
\description{
Clean and scale a matrix from a genoMatriXeR object
}
\seealso{
\code{\link[=makeCrosswiseMatrix]{makeCrosswiseMatrix()}}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getHClust.R
\name{getHClust}
\alias{getHClust}
\title{getHClust}
\usage{
getHClust( rR, hctype = "rows")
}
\arguments{
\item{rR}{A genoMatriXeR or multiLocalZScore object.}

\item{hctype}{character. Can be "rows" or "cols". (default= "cols")}
}
\value{
an object of class \link{hclust}
}
\description{
get Object of class \link{hclust} from  \link[=genoMatriXeR-class]{genoMatriXeR} or \link[=multiLocalZScore-class]{multiLocalZScore}
}
\examples{

data("cw_Alien")

cw_Alien_ReG <- makeCrosswiseMatrix(cw_Alien_ReG)
hc <- getHClust(cw_Alien_ReG)

plot(hc)

}
\seealso{
\link[=genoMatriXeR-class]{genoMatriXeR}, \link[=multiLocalZScore-class]{multiLocalZScore}, \link{hclust}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regioneReloaded_methods.R
\name{print,genoMatriXeR-method}
\alias{print,genoMatriXeR-method}
\title{Print method for genoMatriXeR class}
\usage{
\S4method{print}{genoMatriXeR}(x)
}
\arguments{
\item{x}{A genoMatriXeR object.}
}
\value{
A printed output for genoMatriXeR objects.
}
\description{
Print method for genoMatriXeR class
}
\seealso{
\link[=genoMatriXeR-class]{genoMatriXeR}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regioneReloaded_classes.R
\docType{class}
\name{genoMatriXeR-class}
\alias{genoMatriXeR-class}
\alias{gMXR}
\title{genoMatriXeR Class}
\description{
An S4 class for "genoMatriXeR" object.
}
\section{Slots}{

\describe{
\item{\code{parameters}}{List of parameters used to create the object.}

\item{\code{multiOverlaps}}{Results of multiple pairwise permutation tests generated with \code{\link[=crosswisePermTest]{crosswisePermTest()}}.}

\item{\code{matrix}}{List of numerical matrices containing z-score, pvalues and correlation values generated with \code{\link[=makeCrosswiseMatrix]{makeCrosswiseMatrix()}}}
}}

\examples{

data("cw_Alien")

AlienRSList_narrow_small  <- AlienRSList_narrow[c("regA","regB","regC")]

cw_test <- crosswisePermTest(Alist = AlienRSList_narrow_small,Blist = AlienRSList_narrow_small,
                            sampling = FALSE, genome = AlienGenome, per.chromosome = TRUE,
                            ranFUN = "resampleGenome", evFUN = "numOverlaps",
                            ntimes = 10, mc.cores = 2)

class(cw_test)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotCrosswiseDimRed.R
\name{plotCrosswiseDimRed}
\alias{plotCrosswiseDimRed}
\title{plotCrosswiseDimRed}
\usage{
plotCrosswiseDimRed(mPT, type = "PCA", GM_clust = NA, clust_met =
"hclust", nc = 5, listRS = NULL, main = "", labSize = 2, emphasize = FALSE,
labAll = FALSE, labMaxOverlap = 100, ellipse = TRUE, colPal = NULL,
perplexity = 10, theta = 0.1, return_table = FALSE, return_plot = TRUE, ...)
}
\arguments{
\item{mPT}{an object of class genoMatriXeR or a numerical matrix.}

\item{type}{character, dimensional reduction algorithm to use ("PCA", "tSNE", "UMAP"). (default  = "PCA")}

\item{GM_clust}{numeric, vector of assigned clusters used to cluster the matrix. If NA, the matrix will be clustered using the method defined by \code{clust_met}. (default = NA)}

\item{clust_met}{character, unsupervised cluster strategy used (\link{hclust}, \link{kmeans} or \link{pam}). (default = "hclust")}

\item{nc}{numeric, number of clusters to define if using the default "kmeans" method. (default = 5)}

\item{listRS}{list, a list of names of region sets of interest to be highlighted in the graph. (default = NULL)}

\item{main}{character, title for the plot. (default = "")}

\item{labSize}{numeric, size for point labels in the plot. If 0, no labels will be plotted. (default = 2)}

\item{emphasize}{logical, if TRUE, only the cluster in which the elements of \code{listRS} are present will be highlighted. (default = FALSE)}

\item{labAll}{logical, if TRUE all data points are labelled, even if not in \code{listRS} when \code{emphasize} = TRUE. (default = FALSE)}

\item{labMaxOverlap}{numeric, max.overlaps for \code{\link{geom_text_repel}}. (default = 100)}

\item{ellipse}{logical, if TRUE ellipses will be drawn around the clusters. (default = FALSE)}

\item{colPal}{character, colors to use as palette for the plot. If NULL, default colors will be used. (default = NULL)}

\item{perplexity, theta}{numeric, if \code{type} = "tSNE" values of perplexity and theta for the function \code{\link[=Rtsne]{Rtsne()}}. (default = 10)}

\item{return_table}{logical, if TRUE a table with the cluster assigned to each region is returned. (default = FALSE)}

\item{return_plot}{logical, if TRUE a plot is returned. (default = TRUE)}

\item{...}{further arguments to be passed on to other methods}
}
\value{
A ggplot object or a table with cluster assignments is returned.
}
\description{
Plot a visualization of a \link[=genoMatriXeR-class]{genoMatriXeR} object (or matrix) using different
dimensional reduction algorithms (PCA, tSNE and UMAP).
}
\details{
This function generates a plot with a two-dimensional representation of the
association data stored in a \link[=genoMatriXeR-class]{genoMatriXeR} object by
using either PCA, tSNE or UMAP transformations of the data. This function
incorporates a clustering step and allows to highlight specific region sets
of interest and the clusters they belong to. In addition to generating a plot,
a table with the cluster assignments can be retrieved.
}
\examples{

data("cw_Alien")

cw_Alien_ReG <- makeCrosswiseMatrix(cw_Alien_ReG)

plotCrosswiseDimRed(cw_Alien_ReG, type = "PCA")

CDR_clust <- plotCrosswiseDimRed(cw_Alien_ReG, type = "UMAP", return_table = TRUE)

print(CDR_clust)

}
\seealso{
\code{\link[=crosswisePermTest]{crosswisePermTest()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regioneReloaded_methods.R
\name{mlzsMultiLocalZscores}
\alias{mlzsMultiLocalZscores}
\title{Export multiLocalZscores slot from multiLocalZScore objects}
\usage{
mlzsMultiLocalZscores(x)
}
\arguments{
\item{x}{A multiLocalZScore object.}
}
\value{
multiLocalZscores slot of a multiLocalZScore object.
}
\description{
Export multiLocalZscores slot from multiLocalZScore objects
}
\seealso{
\link[=multiLocalZScore-class]{multiLocalZScore}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regioneReloaded_data.R
\docType{data}
\name{AlienGenome}
\alias{AlienGenome}
\title{AlienGenome}
\format{
An objects of class \link[GenomicRanges:GRanges-class]{GRanges}.
}
\usage{
data(cw_Alien)
}
\description{
The Alien Genome is an artificial genomic coordinates system for the purposes
of testing and demonstrating the functions of regioneReload with a low
computing time.
}
\details{
The Alien Genome consists of four chromosomes and is generated by the
following code:

\preformatted{AlienGenome <-
toGRanges(data.frame(
  chr = c("AlChr1", "AlChr2", "AlChr3", "AlChr4"),
  start = c(rep(1, 4)),
  end = c(2e6, 1e6, 5e5, 1e5)
))}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotSingleLZ.R
\name{plotSingleLZ}
\alias{plotSingleLZ}
\title{plotSingleLZ}
\usage{
plotSingleLZ(mLZ, RS, xlab = "", normZS = TRUE, ylim = NULL, main = NA,
 colPal = NULL, labValues = TRUE, labSize = 2.5, labMax = FALSE, smoothing = FALSE, ...)
}
\arguments{
\item{mLZ}{an object of class \link[=multiLocalZScore-class]{multiLocalZScore}.}

\item{RS}{character, vector of region set names for which to plot the local Z-score results.}

\item{xlab}{character, label for the x axis. (default = NA)}

\item{normZS}{logical, indicates whether the normalized Z-score values should be plotted. If FALSE, the raw Z-score is used. (default = TRUE)}

\item{ylim}{numeric, vector with two elements: minimum and maximum Y values of the plot. If NULL, the plot limits are set by default so all data points can be plotted. (default = NULL)}

\item{main}{character, title for the plot. If NA, the name of the query region set in the multiLocalZScore object will be used. (default = NA)}

\item{colPal}{character, colors to use as palette for the plot. If NULL, default colors will be used. (default = NULL)}

\item{labValues}{logical, if TRUE each local Z-score profile is labelled at position 0 with the name of the region set and its Z-score value at the central position. (default = TRUE)}

\item{labSize}{numerical, size of the labels from labValues in the plot. (default = 2.5)}

\item{labMax}{logical, if TRUE the labels are placed at the maximum value of each local Z-score profile instead of the center. (default = FALSE)}

\item{smoothing}{logical, if TRUE the \code{\link[=smooth.spline]{smooth.spline()}} function will be applied to the localZ-score profile. (default = FALSE)}

\item{...}{further arguments to be passed to other methods.}
}
\value{
Returns a ggplot object.
}
\description{
Plot the result of specific local Z-Score tests from a \link[=multiLocalZScore-class]{multiLocalZScore} object in the
form of line plot profiles.
}
\details{
This function generates a line plot with the local Z-score profiles of
selected region sets from a \link[=multiLocalZScore-class]{multiLocalZScore} object. This type of plot
complements the local Z-score matrix (generated by \link{plotLocalZScoreMatrix},
since it allows to visualize in detail the local Z-score profile of just the
region sets of interest.

This plot is well suited for a single or a few region sets, but
will get busy if attempting to plot many different profiles. For the latter,
the full matrix generated by \link{plotLocalZScoreMatrix} is usually a better
visualization option.
}
\examples{

data("cw_Alien")

plotSingleLZ(mLZ_regA_ReG, RS = c("regD", "regD_02", "regA", "regAB_04"),
labMax = TRUE, smoothing = TRUE)

}
\seealso{
\code{\link[=multiLocalZscore]{multiLocalZscore()}}, \code{\link[=makeLZMatrix]{makeLZMatrix()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotLocalZScoreMatrix.R
\name{plotLocalZScoreMatrix}
\alias{plotLocalZScoreMatrix}
\title{Plot Local Z-Score Matrix}
\usage{
plotLocalZScoreMatrix (mLZ, lineColor = NA, colMatrix = "default",
matrix_type = "association", maxVal = "max", main = "", labSize = 6,
revert = FALSE, highlight = NULL, highlight_size = 2.5, highlight_max = FALSE,
smoothing = FALSE, ...)
}
\arguments{
\item{mLZ}{an object of class \linkS4class{multiLocalZScore} or a matrix}

\item{lineColor}{logical, color for the line grid delineating the tiles of the matrix plot. If NA, no line will be drawn. (default = NA)}

\item{colMatrix}{character or vector of colors, if "default" will be used a default selection see..}

\item{matrix_type}{character, type of matrix to be plotted, either "association" or "correlation". (default = "association")}

\item{maxVal}{numeric, maximum absolute value displayed by the plot. If "max", the maximum values in the matrix are used. If NA, the 0.95 quantile of all absolute values is used. (default = NA)}

\item{main}{character, title of the plot. (default = "")}

\item{labSize}{numeric, size for the plot labels. (default = 6)}

\item{revert}{logical, if TRUE reverts the order of the plotted elements. (default = FALSE)}

\item{highlight}{character, vector indicating the region set names to highlight by adding labels pointing to the 0 shift position (default = NULL)}

\item{highlight_size}{numeric, size of the highlight labels. (default = 2.5)}

\item{highlight_max}{logical, if TRUE the highlight labels are placed at the maximum local z-score value instead of the 0 shift position. (default = FALSE)}

\item{smoothing}{logical, if TRUE the \link[stats:smooth.spline]{stats::smooth.spline} function will be applied to the local z-score profile. (default = FALSE)}

\item{...}{further arguments to be passed to other methods.}
}
\value{
Returns a ggplot object.
}
\description{
Plot Local Z-Score Matrix of associations/correlations stored in a \linkS4class{multiLocalZScore} object.
}
\examples{

data("cw_Alien")



}
\seealso{
\link{multiLocalZscore} \link{makeLZMatrix} \linkS4class{multiLocalZScore}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/createUniverse.R
\name{createUniverse}
\alias{createUniverse}
\title{createUniverse}
\usage{
createUniverse(Alist, joinR = TRUE)
}
\arguments{
\item{Alist}{list of regions set in a format accepted for \href{https://bioconductor.org/packages/release/bioc/html/regioneR.html}{regioneR}}

\item{joinR}{logical, if TRUE all the regions will be joined using the function \code{\link[regioneR:joinRegions]{regioneR::joinRegions()}}.(default == TRUE)}
}
\value{
A list of \link[GenomicRanges:GRanges-class]{GRanges} objects
}
\description{
Create the universe parameter for \code{\link[regioneR:resampleRegions]{regioneR::resampleRegions()}} using all unique regions present in Alist.
}
\examples{

data("cw_Alien")

universe <- createUniverse(AlienRSList_narrow)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getMultiEvaluation.R
\name{getMultiEvaluation}
\alias{getMultiEvaluation}
\title{getMultiEvaluation}
\usage{
getMultiEvaluation( rR, namesRS = NULL)
}
\arguments{
\item{rR}{A genoMatriXeR or multiLocalZScore object.}

\item{namesRS}{a vector of names. (default = NA)}
}
\value{
If rR is a \link[=genoMatriXeR-class]{genoMatriXeR} object, a list of data frames resuming the associations results.
If rR is a \link[=multiLocalZScore-class]{multiLocalZScore} object, a list of two elements: "resumeTable" that is a data frame
summarizing the associations and "shifts", a list of shifts computed from \code{\link[=multiLocalZscore]{multiLocalZscore()}} function for the elements
indicated in the nameRS vector.
}
\description{
Get \code{multiEvaluation} slot from \link[=genoMatriXeR-class]{genoMatriXeR} or \link[=multiLocalZScore-class]{multiLocalZScore} class.
}
\examples{

data("cw_Alien")

mevs <- getMultiEvaluation(cw_Alien_ReG, names = "regA")

mevs

}
\seealso{
\link[=genoMatriXeR-class]{genoMatriXeR}, \link[=multiLocalZScore-class]{multiLocalZScore}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/subList.R
\name{subList}
\alias{subList}
\title{Sub List from region set list}
\usage{
subList(Alist, min_sampling, fraction)
}
\arguments{
\item{Alist, }{GRangesList or list of Region Set of any accepted formats by  \href{https://bioconductor.org/packages/release/bioc/html/regioneR.html}{regioneR} package}

\item{min_sampling}{numeric, minimum number of regions for each element of the list,
if the number of regions is less than min_samplnig as subsempilng will be take the entire regionset}

\item{fraction}{numeric, percentage of regions selected for the subsampling}
}
\value{
a sublist of GenomicRanges from an original GenomicRanges list
}
\description{
create a samples sublist starting from a list of Region Set
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regioneReloaded_data.R
\docType{data}
\name{cw_Alien}
\alias{cw_Alien}
\title{cw_Alien}
\format{
An objects of class \link[=genoMatriXeR-class]{genoMatriXeR}; see \code{\link[=makeCrosswiseMatrix]{makeCrosswiseMatrix()}}.
}
\usage{
data(cw_Alien)
}
\description{
Alien Genome crosswise matrix using \link[regioneR:randomizeRegions]{regioneR::randomizeRegions} , \link[regioneR:circularRandomizeRegions]{regioneR::circularRandomizeRegions},
\link[regioneR:resampleRegions]{regioneR::resampleRegions}, \link[regioneR:resampleGenome]{regioneR::resampleGenome} functions as permutation strategies.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/makeCrosswiseMatrix.R
\name{makeCrosswiseMatrix}
\alias{makeCrosswiseMatrix}
\title{makeCrosswiseMatrix}
\usage{
makeCrosswiseMatrix(mPT, clusterize = TRUE, hc.method = NULL, dist.method = "euclidean",
transform = FALSE, scale = FALSE, zs.type = 'norm_zscore', symm_matrix = TRUE,
selectRow = NULL, selectCol = NULL, pvcut = 1, subEX = 0, GM_diag = TRUE, ...)
}
\arguments{
\item{mPT}{an object of class \link[=genoMatriXeR-class]{genoMatriXeR}.}

\item{clusterize}{logical, if TRUE the matrix will be clustered using the method specified by \code{hc.method} (default = TRUE)}

\item{hc.method}{character, select the \code{\link[=hclust]{hclust()}} method to use for clustering the matrix. If NULL, the clustering method will be automatically selected by the function \code{\link[=chooseHclustMet]{chooseHclustMet()}}. (default = NULL)}

\item{dist.method}{character, the distance measure to be used from those available in \code{\link[=dist]{dist()}} . (default = "euclidean")}

\item{transform}{logical, if TRUE the matrix will be transformed using the function \code{\link[=t]{t()}}. (default = FALSE)}

\item{scale}{logical, if TRUE the matrix will be scaled. (default = FALSE)}

\item{zs.type}{character, z-score type to use to generate the matrix, either raw z-score ("zscore") or normalized z-score ("norm_zscore"). (default = "norm_zscore")}

\item{symm_matrix}{logical, if TRUE the matrix will be treated as symmetrical (same clustering for rows and columns). (default = TRUE)}

\item{selectRow, selectCol}{vector, the matrix will be reduced selecting the rows and/or columns in this vector. (default = NULL)}

\item{pvcut}{numeric, the z-score value is substituted by \code{subEX} (0 by default) for all the associations with an adj.pvalue (as calculated in \code{\link[=crosswisePermTest]{crosswisePermTest()}}) higher than \code{pvcut}. (default = 0.05)}

\item{subEX}{numeric, value used to substitute the z-score values when the associated pvalue is higher than \code{pvcut}. (default = 0)}

\item{GM_diag}{logic, if FALSE the values of the diagonal will be set to 0. (default = TRUE)}

\item{...}{further arguments to be passed to other methods.}
}
\value{
An object of class \link[=genoMatriXeR-class]{genoMatriXeR} containing three slots, with a populated \code{matrix} slot.

\itemize{
\item \bold{\code{@parameters}}
\item \bold{\code{@multioverlaps}}
\item \bold{\code{@matrix}}

}
}
\description{
Populate the \code{matrix} slot in a \link[=genoMatriXeR-class]{genoMatriXeR} object.
}
\details{
This function will create a series of matrices of z-scores, adj.pvalues and
pearson correlation values from all the pairwise permutation tests stored in
the \code{multiOverlaps} slot of a \link[=genoMatriXeR-class]{genoMatriXeR} as
calculated with \code{\link[=multiPermTest]{multiPermTest()}}. These matrices will then be stored in the
\code{matrix} slot of the \link[=genoMatriXeR-class]{genoMatriXeR} object. In addition,
clustering will be performed on the association matrices using \link{hclust}.
}
\examples{

data("cw_Alien")

cw_Alien_ReG <- makeCrosswiseMatrix(cw_Alien_ReG)

summary(cw_Alien_ReG)

}
\seealso{
\code{\link[=crosswisePermTest]{crosswisePermTest()}}, \code{\link[=chooseHclustMet]{chooseHclustMet()}}, \code{\link[=plotCrosswiseMatrix]{plotCrosswiseMatrix()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotSinglePT.R
\name{plotSinglePT}
\alias{plotSinglePT}
\title{plotSinglePT}
\usage{
plotSinglePT(mPT, RS1, RS2, xlab = NA, main = NA)
}
\arguments{
\item{mPT}{an object of class \link[=genoMatriXeR-class]{genoMatriXeR}.}

\item{RS1, RS2}{character, names of region sets in a genoMatriXeR object for which to represent the pairwise permutation test results.}

\item{xlab}{character, label for x axis. (default = NA)}

\item{main}{title for the plot, if NA the name of the genoMatriXeR object is used (default = NA)}
}
\value{
Returns a ggplot object.
}
\description{
Plot the result of a single pairwise permutation test from a genoMatriXeR object.
}
\details{
This function generates a plot representing the result of a single
permutation test stored in a \link[=genoMatriXeR-class]{genoMatriXeR} object. This includes a plot of the
density distribution of the randomized evaluations and a vertical line
showing the observed evaluation in the original region set. The values of the
mean randomized evaluations and the value of the observed evaluation are
shown, in addition to the calculated Z-score, normalized Z-score and adjusted
p-value.
}
\examples{

data("cw_Alien")
plotSinglePT(cw_Alien_ReG, RS1 = "regA", RS2 = "regA_05")
plotSinglePT(cw_Alien_ReG, RS1 = "regA", RS2 = "regC")

}
\seealso{
\link{crosswisePermTest} \link{makeCrosswiseMatrix}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regioneReloaded_data.R
\docType{data}
\name{mLZ_regD_ReG}
\alias{mLZ_regD_ReG}
\title{mLZ_regD_ReG}
\format{
An object of class \link[=multiLocalZScore-class]{multiLocalZScore}
}
\usage{
data(cw_Alien)
}
\description{
Alien Genome multiLocalZScore calculated for regD regionset from AlienRSList_narrow using \code{\link[regioneR:resampleGenome]{regioneR::resampleGenome()}} function as permutation s
trategy.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regioneReloaded_methods.R
\name{mlzsMatrix}
\alias{mlzsMatrix}
\title{Export matrix from multiLocalZScore objects}
\usage{
mlzsMatrix(x)
}
\arguments{
\item{x}{A multiLocalZScore object.}
}
\value{
A printed output for multiLocalZScore matrix slot.
}
\description{
Export matrix from multiLocalZScore objects
}
\seealso{
\link[=multiLocalZScore-class]{multiLocalZScore}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chooseHclustMet.R
\name{chooseHclustMet}
\alias{chooseHclustMet}
\title{chooseHclustMet}
\usage{
chooseHclustMet(GM, scale = FALSE, vecMet = NULL, distHC = "euclidean")
}
\arguments{
\item{GM}{matrix,  numerical matrix.}

\item{scale}{logical, if TRUE, the clustering will be performed using the scaled matrix. (default = FALSE)}

\item{vecMet}{character, vector of methods that will be tested in the function.
If NULL, the following methods will be tested: "complete", "average", "single", "ward.D2", "median", "centroid" and "mcquitty. (default = NULL)}

\item{distHC}{character, the distance measure to be used from those available in \code{\link[=dist]{dist()}} . (default = "euclidean")}
}
\value{
An object of class \link{hclust}
}
\description{
Evaluate and choose the best method for clustering a matrix using the \code{\link[=hclust]{hclust()}} function.
}
\examples{

M1 <- matrix(1:18, nrow = 6, ncol = 3)
set.seed(42)
M2 <- matrix(sample(100, 18), nrow = 6, ncol = 3)
GM <- cbind(M1, M2)

chooseHclustMet(GM)


}
\seealso{
\code{\link[=hclust]{hclust()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/crosswiseMatrix.R
\name{crosswiseMatrix}
\alias{crosswiseMatrix}
\title{crosswiseMatrix}
\usage{
crosswiseMatrix(mPT, zs.type='norm_zscore',...)
}
\arguments{
\item{mPT}{an object of class \link[=genoMatriXeR-class]{genoMatriXeR}.}

\item{zs.type}{character, z-score type to use to generate the matrix, either raw z-score ("zscore") or normalized z-score ("norm_zscore"). (default = "norm_zscore")}

\item{...}{further arguments to be passed to other methods.}
}
\value{
a numeric matrix
}
\description{
Create a matrix from a genoMatriXeR object.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/multiPermTest.R
\name{multiPermTest}
\alias{multiPermTest}
\title{multiPermTest}
\usage{
multiPermTest (A, Blist, ranFUN, evFUN, uni, genome, rFUN, ntimes, adj_pv_method, ...)
}
\arguments{
\item{A}{Genomic Ranges or any accepted formats by  \href{https://bioconductor.org/packages/release/bioc/html/regioneR.html}{regioneR} package
(\link[GenomicRanges:GRanges-class]{GRanges}, \link{data.frame} etc.).}

\item{ranFUN}{character, the randomization strategy used for the test, see \href{https://bioconductor.org/packages/release/bioc/html/regioneR.html}{regioneR}. (default = "randomizeRegions")}

\item{evFUN}{character, the evaluation strategy used for the test, see  \href{https://bioconductor.org/packages/release/bioc/html/regioneR.html}{regioneR}. (default = "numOverlaps)}

\item{uni}{region set to use as universe, used only when \code{\link[regioneR:resampleRegions]{regioneR::resampleRegions()}} function is selected. (default = NULL)}

\item{genome}{character or \link[GenomicRanges:GRanges-class]{GRanges}, genome used to compute the randomization. (default = "hg19")}

\item{ntimes}{numeric, number of permutations used in the test. (default = 100)}

\item{adj_pv_method}{character, the method used for the calculation of the adjusted p-value, to choose between the options of \code{\link[=p.adjust]{p.adjust()}}. (default = "BH")}

\item{...}{further arguments to be passed to other methods.}
}
\value{
a data frame object computed starting from results of \code{\link[regioneR:permTest]{regioneR::permTest()}} function
}
\description{
multiPermTest
}
\details{
Perform a multiple permutation test
}
\seealso{
\code{\link[regioneR:permTest]{regioneR::permTest()}}
}
\keyword{function}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/multiLocalZscore.R
\name{multiLocalZscore}
\alias{multiLocalZscore}
\title{multiLocalZscore}
\usage{
multiLocalZscore(A, Blist = NULL, sampling = FALSE, fraction = 0.15,
min_sampling = 5000, ranFUN = "randomizeRegions", evFUN = "numOverlaps",
ntimes = 100, adj_pv_method = "BH", genome = "hg19", universe = NULL,
window = 1000, step = 100, ...)
}
\arguments{
\item{A}{query region set for which to estimate local z-score values.}

\item{Blist}{\link[GenomicRanges:GRangesList-class]{GRangesList} or list of region sets in any accepted formats by \href{https://bioconductor.org/packages/release/bioc/html/regioneR.html}{regioneR} package
(\link[GenomicRanges:GRanges-class]{GRanges}, \link{data.frame} etc.).}

\item{sampling}{logical, if TRUE the function will use only a sample of each element of Alist to perform the test as specified in \code{fraction.} (default = FALSE)}

\item{fraction}{logical, if \code{sampling=TRUE}, defines the fraction of the region sets used to perform the test. (default = 0.15)}

\item{min_sampling}{numeric, minimum number of regions accepted after sampling is performed with the specified \code{fraction}. If the number of sampled
regions is less than \code{min_sampling}, the number specified by \code{min_sampling} will be used as number of regions sampled instead. (default = 5000)}

\item{ranFUN}{character, the randomization strategy used for the test, see \href{https://bioconductor.org/packages/release/bioc/html/regioneR.html}{regioneR}. (default = "randomizeRegions")}

\item{evFUN}{character, the evaluation strategy used for the test, see  \href{https://bioconductor.org/packages/release/bioc/html/regioneR.html}{regioneR}. (default = "numOverlaps)}

\item{ntimes}{numeric, number of permutations used in the test. (default = 100)}

\item{adj_pv_method}{character, the method used for the calculation of the adjusted p-value, to choose between the options of \code{\link[=p.adjust]{p.adjust()}}. (default = "BH")}

\item{genome}{character or \link[GenomicRanges:GRanges-class]{GRanges}, genome used to compute the randomization. (default = "hg19")}

\item{universe}{region set to use as universe, used only when \code{\link[regioneR:resampleRegions]{regioneR::resampleRegions()}} function is selected. (default = NULL)}

\item{window}{numeric, window (number of base pairs) in which the local z-score will be calculated. (default = 1000)}

\item{step}{numeric, step (number of base pairs) by which will be estimated the local Z-score. (default = 100)}

\item{...}{further arguments to be passed to other methods.}
}
\value{
A object of class \link[=multiLocalZScore-class]{multiLocalZScore} containing three slots

\itemize{
\item \bold{\code{@parameters}}
\item \bold{\code{@multiLocalZscores}}
\item \bold{\code{@matrix}}

}
}
\description{
Perform multiple permutation tests between a region set and each element in
a list of region sets using shifted positions to calculate a local z-score.
}
\details{
This function performs multiple permutation tests between a single region set
and each element in a list of region sets. For every pairwise combination, the
evaluation step is repeated each time shifting the position of all the regions in the query region set
by a fixed step inside a defined window (using \code{\link[regioneR:localZScore]{regioneR::localZScore()}}.
This produces a "local z-score" profile that can be indicative of the nature
of the association between region sets. For example, an association can occur
"centrally" if the z-score value drops sharply when sifting the region set.
On the other hand, two region sets may have a peak of local z-score away from
the central position if they happen to occur often at a regular distance,
showing a "lateral" association.
}
\examples{

fakeGenome<- regioneR::toGRanges("chrF",1,1000)
regA <- regioneR::createRandomRegions(nregions = 10, length.mean = 10,
length.sd = 2,genome = fakeGenome)
regB <- regioneR::createRandomRegions(nregions = 10,length.mean = 10,
length.sd = 2,genome = fakeGenome)
regAs <-similarRegionSet(GR = regA,genome = fakeGenome, name = "A",
vectorPerc = seq(0.1,0.3,by =0.1))
regBs <-similarRegionSet(GR = regB,genome = fakeGenome, name = "B",
vectorPerc = seq(0.1,0.3,by =0.1))
ABList <- c(regAs,regBs)

mlz_ptAB <- multiLocalZscore(A = regA, Blist = ABList,
genome = fakeGenome, ntimes = 10)
summary(mlz_ptAB)


}
\seealso{
\code{\link[regioneR:localZScore]{regioneR::localZScore()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regioneReloaded_methods.R
\name{gmxrParam}
\alias{gmxrParam}
\title{Export parameters from genoMatriXeR objects}
\usage{
gmxrParam(x)
}
\arguments{
\item{x}{A genoMatriXeR object.}
}
\value{
Parameters slot of a genoMatriXeR object.
}
\description{
Export parameters from genoMatriXeR objects
}
\seealso{
\link[=genoMatriXeR-class]{genoMatriXeR}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regioneReloaded_data.R
\docType{data}
\name{AlienRSList_narrow}
\alias{AlienRSList_narrow}
\title{AlienRSList_narrow}
\format{
A list of \link[GenomicRanges:GRanges-class]{GRanges} objects.
}
\usage{
data(cw_Alien)
}
\description{
List of region sets (as \link[GenomicRanges:GRanges-class]{GRanges}) on the \link{AlienGenome}.
}
\details{
This region sets are generated for the purpose of demonstrating the functions
of RegioneReloaded with a low computing time and "predictable" associations. The
regions are generated with by combining \code{\link[=createRandomRegions]{createRandomRegions()}} and
\code{\link[=similarRegionSet]{similarRegionSet()}} so that there is a known overlap between certain region
sets. To see a full description of this sample data and the code used to
generate it, see the RegioneReloaded vignette.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/similarRegionSet.R
\name{similarRegionSet}
\alias{similarRegionSet}
\title{similar RegionSets}
\usage{
similarRegionSet(GR, name, genome, vectorPerc)
}
\arguments{
\item{GR}{a \link[GenomicRanges:GRanges-class]{GRanges} object with the input region set.}

\item{name}{character, name for the output region sets. The names will be generated by adding an underscore and the
fraction of similarity after the name of each region set generated. (default = "A")}

\item{genome}{genome of reference to generate the similar region sets. (default = "hg19)}

\item{vectorPerc}{numeric, vector of desired randomized fractions. (default = seq(.1,.9,.1))}
}
\value{
A list of \link[GenomicRanges:GRanges-class]{GRanges} objects.
}
\description{
Create a list of similar region sets to a reference region set.
}
\details{
This function takes a region set as an input and a vector of desired randomized
fractions. For each fraction value, a new region set will be generated
where that fraction of the original regions in the input region set has been randomized.
In effect, this creates region sets that are "similar" to a controlled degree
to the original region set. This tool can be useful for validation purposes
and its use in the demonstration of the usage of this package can be
seen in the \code{RegioneReloaded} vignette.
}
\examples{

data("cw_Alien")

A<-createRandomRegions(nregions = 20, length.mean = 1000, length.sd = 100,
genome = AlienGenome)

similAList <- similarRegionSet(GR = A, genome = AlienGenome,
vectorPerc = seq(0.1,0.9,0.2), name = "test")

summary (similAList)


data("cw_Alien")

regA <- createRandomRegions(
  nregions = 100,
  length.mean = 10,
 length.sd = 5,
 genome = AlienGenome
)

listRegA <- similarRegionSet(GR = regA, genome = AlienGenome)
summary(listRegA)

}
\seealso{
\link[GenomicRanges:GRanges-class]{GRanges}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regioneReloaded_data.R
\docType{data}
\name{cw_Alien_ReR}
\alias{cw_Alien_ReR}
\title{cw_Alien_ReR}
\format{
An objects of class \link[=genoMatriXeR-class]{genoMatriXeR}; see \code{\link[=makeCrosswiseMatrix]{makeCrosswiseMatrix()}}.
}
\usage{
data(cw_Alien)
}
\description{
Alien Genome crosswise matrix using \code{\link[regioneR:resampleRegions]{regioneR::resampleRegions()}} function a permutation
strategy.Alist = AlienRSList_narrow, Blist = AlienRSList_narrow
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regioneReloaded_methods.R
\name{gmxrMatrix<-}
\alias{gmxrMatrix<-}
\title{Set matrix slot value of a genoMatriXeR object}
\usage{
gmxrMatrix(x) <- value
}
\arguments{
\item{x}{A genoMatriXeR object.}

\item{value}{Value to assign to the matrix slot.}
}
\value{
A genoMatriXeR object.
}
\description{
Set matrix slot value of a genoMatriXeR object
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regioneReloaded_classes.R
\docType{class}
\name{multiLocalZScore-class}
\alias{multiLocalZScore-class}
\alias{mLZS}
\title{multiLocalZScore Class}
\description{
An S4 class for "multiLocalZScore" object.
}
\section{Slots}{

\describe{
\item{\code{parameters}}{List of parameters used to create the object}

\item{\code{multiLocalZscores}}{Results of multiple pairwise permutation tests on shifted region sets generated with \code{\link[=multiLocalZscore]{multiLocalZscore()}}.}

\item{\code{matrix}}{List of numerical matrices containing local z-scores and correlation values generated with \code{\link[=makeLZMatrix]{makeLZMatrix()}}.}
}}

\examples{

data("cw_Alien")

AlienRSList_narrow_small  <- AlienRSList_narrow[c("regA","regB","regC")]

mlz_test <- multiLocalZscore(A = AlienRSList_narrow_small$regA, Blist = AlienRSList_narrow_small,
                            sampling = FALSE, genome = AlienGenome, per.chromosome = TRUE,
                            ranFUN = "resampleGenome", evFUN = "numOverlaps",
                            ntimes = 10, mc.cores = 2)

class(mlz_test)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/regioneReloaded_methods.R
\name{mlzsParam<-}
\alias{mlzsParam<-}
\title{Set parameters slot value of a multiLocalZScore object}
\usage{
mlzsParam(x) <- value
}
\arguments{
\item{x}{A multiLocalZScore object.}

\item{value}{Value to assign to the parameters slot.}
}
\value{
A multiLocalZScore object.
}
\description{
Set parameters slot value of a multiLocalZScore object
}
\keyword{internal}
